<%-- COPYRIGHT:		Copyright (C) 2016-2018 McAfee, Inc.  All rights reserved--%>
<%@ page import="com.mcafee.orion.core.OrionCore" %>
<%@ page import="com.mcafee.scor.common.Constants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.rulegroup.RuleGroupConstants" %>
<%@ page import="com.mcafee.scor.policy.ui.vo.ExecutionControlVO" %>
<%@ page import="com.mcafee.scor.policy.PolicyConstants" %>
<%@ page import="com.mcafee.scor.common.CommonConstants" %>

<!-- COPYRIGHT:		Copyright (C) 2016-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>

<orion:script context="/core" src="/majic.js"/>


<orion:style context="/SOLIDCORE_META" url="/css/override.css" />

<orion:message key="scor.policy.awl.execControl.addEditRule.button.add" var='addBtn' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.button.edit" var='editBtn' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.button.remove" var='removeBtn' escape="javascript"/>

<orion:message key="scor.policy.awl.execControl.list.header.action" var='listHeaderAction' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.list.header.processName" var='listHeaderProcessName' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.list.header.path" var='listHeaderPath' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.list.header.cmdArgument" var='listHeaderCommandLineArgument' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.list.header.parentProcessName" var='listHeaderParentProcessName' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.list.header.userName" var='listHeaderUserName' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.list.header.ruleDescription" var='listHeaderDescription' escape="HTML"/>

<orion:message key="scor.policy.awl.execControl.addEditRule.title.addRule" var='addTitle' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.title.editRule" var='editTitle' escape="javascript"/>

<orion:message key="scor.policy.awl.execControl.addEditRule.and" var='andBetweenAttributes' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.action" var='addEditActionName' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.processName" var='addEditProcessName' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.path" var='addEditPathName' escape="none"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.cmdArgument" var='addEditCmdArgumentName' escape="none"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.parentProcessName" var='addEditParentProcessName' escape="none"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.userName" var='addEditUserName' escape="none"/>

<orion:message key="scor.policy.awl.execControl.addEditRule.path" var='addEditPathName_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.cmdArgument" var='addEditCmdArgumentName_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.parentProcessName" var='addEditParentProcessName_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.userName" var='addEditUserName_js' escape="javascript"/>

<orion:message key="scor.policy.awl.execControl.addEditRule.allow" var='addEditAllow' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.block" var='addEditBlock' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.block.label" var='addEditAttrAction_label' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.block.interactive" var='addEditBlockInteractive' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.block.interactive.label" var='addEditBlockInteractive_label' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.monitor" var='addEditMonitor' escape="HTML"/>

<orion:message key="scor.policy.awl.execControl.match.equals" var='matchTypeEquals' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.match.notEquals" var='matchTypeNotEquals' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.match.matches" var='matchTypeMatches' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.match.notMatches" var='matchTypeNotMatches' escape="HTML"/>
<orion:message key="scor.policy.awl.execControl.match.noArgSpecified" var='matchTypeNoArgSpecified' escape="HTML"/>

<!--Copying same keys for escaping in javascript too-->
<orion:message key="scor.policy.awl.execControl.addEditRule.allow" var='addEditAllow_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.block" var='addEditBlock_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.block.interactive" var='addEditBlockInteractive_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.monitor" var='addEditMonitor_js' escape="javascript"/>

<orion:message key="scor.policy.awl.execControl.match.equals" var='matchTypeEquals_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.match.notEquals" var='matchTypeNotEquals_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.match.matches" var='matchTypeMatches_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.match.notMatches" var='matchTypeNotMatches_js' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.match.noArgSpecified" var='matchTypeNoArgSpecified_js' escape="javascript"/>

<orion:message key="scor.policy.awl.execControl.addEditRule.validation.attributes.msg1" var='otherAttributesValidationMsg1' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.validation.attributes.msg2" var='otherAttributesValidationMsg2' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.validation.cmdArg.regEx" var='cmdArgValidationMsg' escape="javascript"/>
<orion:message key="scor.policy.awl.execControl.addEditRule.validation.fileName" var='fileNameValidationMsg' escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.fullyQualifiedReq" var='pathValidationMsg' escape="javascript"/>

<orion:message key="scor.awl.execControl.no.editPermission.msg" var="noEditPermissionMsg" escape="HTML"/>

<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupExecControlRules" authToken = "isAuthorizedToViewExecControlRules"/>

<c:set var="equals" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_MATCH_TYPE.EQUALS.getKey()%>"/>
<c:set var="notEquals" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_MATCH_TYPE.NOT_EQUALS.getKey()%>"/>
<c:set var="matches" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_MATCH_TYPE.MATCHES.getKey()%>"/>
<c:set var="notMatches" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_MATCH_TYPE.NOT_MATCHES.getKey()%>"/>
<c:set var="noArgSpecified" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_MATCH_TYPE.NO_ARG_SPECIFIED.getKey()%>"/>

<c:set var="actionKeyAllow" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_ACTION.ALLOW.getKey()%>"/>
<c:set var="actionKeyBlock" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_ACTION.BLOCK.getKey()%>"/>
<c:set var="actionKeyBlockInteractive" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_ACTION.BLOCK_INTERACTIVE.getKey()%>"/>
<c:set var="actionKeyMonitor" scope="request" value="<%=PolicyConstants.EXEC_CONTROL_ACTION.MONITOR.getKey()%>"/>

<orion:box id="execControlTabId">
	<div id="execControlErrorDivId" class="errorRuleTab">${noEditPermissionMsg}</div>
    <table id="execControlTableId" cellspacing="0" cellpadding="0" width="98%">
        <%@ include file="../AdjustOtherTabs.jsp" %>
        <tr>
            <td class="orionSummaryColumn">
                <!-- width is 98% of the width of the list widget so its 980px-->
                <table cellspacing='3' cellpadding='0' width='980px'>
                    <tr>
                    	<td width="15%"><b>${listHeaderDescription}</b></td>
	                    <td width="10%"><b>${listHeaderAction}</b></td>
						<td width="10%"><b>${listHeaderProcessName}</b></td>
						<td width="20%"><b>${listHeaderPath}</b></td>
						<td width="23%"><b>${listHeaderCommandLineArgument}</b></td>
						<td width="10%"><b>${listHeaderParentProcessName}</b></td>
						<td width="10%"><b>${listHeaderUserName}</b></td>
                    </tr>
                </table>
                <orion:box id="execControlListContainerId" height="auto" width="620"/>
            </td>
        </tr>
    </table>

    <div id="execControlListRowTemplateId" style="display:none;">
        <table cellspacing='0' cellpadding='0' width='98%' style="table-layout: fixed" >
            <tr >
            
            	<td width="15%" class="scorWordWrap">@execControlDescriptionMsg</td>
    			
            	<td width="10%">@actionDisplayString</td>
    			<td width="0%" style="display:none;">@execControlActionId</td>
				<td width="10%" class="scorWordWrap">@execControlProcessNameId</td>
				
				<td width="0%" style="display:none;">@pathMatchTypeId</td>
				<td width="0%" style="display:none;">@execControlpathId</td>
				<td width="20%" class="scorWordWrap">@pathDisplayString</td>
				
				<td width="0%" style="display:none;">@cmdArgMatchTypeId</td>
				<td width="0%" style="display:none;">@execControlcmdArgId</td>
				<td width="23%" class="scorWordWrap">@cmdArgDisplayString</td>
				
				<td width="0%" style="display:none;">@parentProcessMatchTypeId</td>
				<td width="0%" style="display:none;">@execControlparentProcessId</td>
				<td width="10%" class="scorWordWrap">@parentProcessDisplayString</td>
				
				<td width="0%" style="display:none;">@userNameMatchTypeId</td>
				<td width="0%" style="display:none;">@execControluserNameId</td>
				<td width="10%" class="scorWordWrap">@userNameDisplayString</td>
            </tr>
        </table>
    </div>


    <div id="execControlEditorTemplate" style="display:none;">
         	 
                
	    <table width="100%">
	    	<tr>
		    <td width="24%">
		        <label>
		                ${addEditActionName}:
		        </label>
		    </td>
		    <td width="80%">
		    	<table>
		    		<tr>
						<td>
							<input type="text" id="actionDisplayString" style="display:none">
							<input type="text" id="execControlActionId" style="display:none">
							<label>
								<orion:radiobutton name="execControlAction" id="actionTypeAttrId" value="actionKeyAttr" checked="true" onclick="actionSelectHandler()"/>
									${addEditAttrAction_label}&nbsp;&nbsp;&nbsp;
									<orion:select id="attrActionSelectId" name="attrActionSelect" style="width:70px;"  >
									 	<option value="${actionKeyAllow}">${addEditAllow}</option>
								        <option value="${actionKeyBlock}">${addEditBlock}</option>
								        <option value="${actionKeyMonitor}" selected>${addEditMonitor}</option>
							        </orion:select>
							</label>
						</td>
					</tr>
					<tr>
						<td>
							<label>
								<orion:radiobutton name="execControlAction" id="actionKeyBlockInteractiveTypeId" value="${actionKeyBlockInteractive}" onclick="actionSelectHandler()"/>
									${addEditBlockInteractive_label}
							</label>
						</td>
					</tr>
				</table>
				<br/>
		    </td>
	    
	    </tr>
		</table>
        <table width="100%">   
        
            <tr>
                <td width="24%">${addEditProcessName}:</td>
                <td colspan="3">
                    <orion:textbox id="execControlProcessNameId" required="true" size="71" maxlength="260"/>
                </td>
            </tr>
         </table>
         <table id="attributesTableId" width="100%">
           	<tr>
                <td width="24%"></td>
  				<td width="12%"></td>
                <td><div style="float: left; width: 20%; padding-left: 15%;"><hr size="1px" color="#dbdbdb"></div><div style="float:left;color:#adadad;">${andBetweenAttributes}</div><div style="float: left; width: 20%;"><hr size="1px" color="#dbdbdb"></div></td>
            </tr>
            <tr>
                <td width="24%"><orion:checkbox  id="path_ckboxId" name="pathChkbox" onclick="enableDisableAttribute('path')" text="${addEditPathName}:"/></td>
                <td width="12%">
	                <orion:select id="pathMatchTypeId" name="pathMatchType" style="width:90px;"  >
					 	<option value="${equals}">${matchTypeEquals}</option>
				        <option value="${notEquals}">${matchTypeNotEquals}</option>
					</orion:select>
				</td> 
                <td>
                    <input type="text" id="pathDisplayString" style="display:none"></input><orion:textbox id="execControlpathId" size="55" maxlength="260"  />
                </td>
            </tr>
            <tr>
                <td width="24%"></td>
  				<td width="12%"></td>
                <td><div style="float: left; width: 20%; padding-left: 15%;"><hr size="1px" color="#dbdbdb"></div><div style="float:left;color:#adadad;">${andBetweenAttributes}</div><div style="float: left; width: 20%;"><hr size="1px" color="#dbdbdb"></div></td>
            </tr>
            <tr>
                <td width="24%"><orion:checkbox  id="cmdArg_ckboxId" name="cmdArgChkbox" onclick="enableDisableAttribute('cmdArg')" text="${addEditCmdArgumentName}:"/></td>
                <td width="12%">
	                <orion:select id="cmdArgMatchTypeId" name="cmdArgMatchType" style="width:90px;">
	                	<option value="${noArgSpecified}">${matchTypeNoArgSpecified}</option>
	                	<option value="${equals}" selected>${matchTypeEquals}</option>
				        <option value="${notEquals}">${matchTypeNotEquals}</option>
				        <option value="${matches}">${matchTypeMatches}</option>
				        <option value="${notMatches}">${matchTypeNotMatches}</option>
					</orion:select>
				</td>
                <td>
                    <input type="text" id="cmdArgDisplayString" style="display:none"><orion:textbox id="execControlcmdArgId" size="55" maxlength="3072"  />
                </td>
            </tr>
            <tr>
                <td width="24%"></td>
  				<td width="12%"></td>
                <td><div style="float: left; width: 20%; padding-left: 15%;"><hr size="1px" color="#dbdbdb"></div><div style="float:left;color:#adadad;">${andBetweenAttributes}</div><div style="float: left; width: 20%;"><hr size="1px" color="#dbdbdb"></div></td>
            </tr>
            <tr>
                <td width="24%"><orion:checkbox  id="parentProcess_ckboxId" name="parentProcessChkbox" onclick="enableDisableAttribute('parentProcess')" text="${addEditParentProcessName}:"/></td>
                <td width="12%">
	                <orion:select id="parentProcessMatchTypeId" name="parentProcessMatchType" style="width:90px;">
					 	<option value="${equals}">${matchTypeEquals}</option>
				        <option value="${notEquals}">${matchTypeNotEquals}</option>
					</orion:select>
				</td>
                <td>
                    <input type="text" id="parentProcessDisplayString" style="display:none"><orion:textbox id="execControlparentProcessId" size="55" maxlength="260"/>
                </td>
            </tr>
            <tr>
                <td width="24%"></td>
  				<td width="12%"></td>
                <td><div style="float: left; width: 20%; padding-left: 15%;"><hr size="1px" color="#dbdbdb"></div><div style="float:left;color:#adadad;">${andBetweenAttributes}</div><div style="float: left; width: 20%;"><hr size="1px" color="#dbdbdb"></div></td>
            </tr>
            <tr>
                <td width="24%"><orion:checkbox  id="userName_ckboxId" name="userNameChkbox" onclick="enableDisableAttribute('userName')" text="${addEditUserName}:"/></td>
                <td width="12%">
	                <orion:select id="userNameMatchTypeId" name="userNameMatchType" style="width:90px;">
					 	<option value="${equals}">${matchTypeEquals}</option>
				        <option value="${notEquals}">${matchTypeNotEquals}</option>
					</orion:select>
				</td>
                <td>
                    <input type="text" id="userNameDisplayString" style="display:none"><orion:textbox id="execControluserNameId" size="55" maxlength="104"/>
                </td>
            </tr>
            <tr><td width="24%">&nbsp;</td><td></td><td></td></tr>
            <tr>
		        <td width="24%">${listHeaderDescription}:</td>
		        <td colspan="2">
		            <orion:textbox id="execControlDescriptionMsg" size="71" maxlength="260"/>
		        </td>
		    </tr>
        </table>
        
        <br/>
        <div id="error_include" style="display:none;color:red;">
            *&nbsp;
        </div>

    </div>
</orion:box>

<script type="text/javascript">
<c:if test = "${isAuthorizedToViewExecControlRules == false}">
	$j('#execControlTabId').hide();
</c:if>
var execControlVOList;

var scor = scor || {};
scor.rg = scor.rg || {};
scor.rg.awl = scor.rg.awl || {};
scor.rg.awl.execControl = scor.rg.awl.execControl || {};

scor.rg.awl.execControl.matchTypeToDisplayStringMap = {
	'${equals}' : '${matchTypeEquals_js}',
	'${notEquals}' : '${matchTypeNotEquals_js}',
	'${matches}' : '${matchTypeMatches_js}',
	'${notMatches}' : '${matchTypeNotMatches_js}',
	'${noArgSpecified}' : '${matchTypeNoArgSpecified_js}'
};

scor.rg.awl.execControl.actionKeyToDisplayStringMap = {
	'${actionKeyBlock}' : '${addEditBlock_js}',
	'${actionKeyBlockInteractive}' : '${addEditBlockInteractive_js}',
	'${actionKeyAllow}' : '${addEditAllow_js}',
	'${actionKeyMonitor}' : '${addEditMonitor_js}'
};

function enableDisableAttribute(attribute){
	if($j('#'+attribute+'_ckboxId').is(':checked') == true){
		$j('#'+attribute+'MatchTypeId').attr('disabled',false).css("background-color","");
		$j('#execControl'+attribute+'Id').attr('disabled',false);
	}else{
		$j('#'+attribute+'MatchTypeId').val('${equals}').attr('disabled',true).css("background-color","#EAE7E7");
		$j('#execControl'+attribute+'Id').val('');
		$j('#'+attribute+'DisplayString').val('');
		$j('#execControl'+attribute+'Id').attr('disabled',true);
	}
};

execControlVOList = new majic.ListWidget({
    container: "execControlListContainerId",
    width: "1000px",
    height: "320px",
    addCallback: execControlAddCallback,
    editCallback: execControlEditCallback,
    removeCallback: myEpoEnableApplyButton,
    buttons: {
        'add': '${addBtn}',
        'edit': '${editBtn}',
        'remove':'${removeBtn}'
    },
    content: $('execControlEditorTemplate').innerHTML,
    displayText: $('execControlListRowTemplateId').innerHTML,
    formatCallback: listWidgetformatCallback
});

function enableExecControlVOList(enable){
    execControlVOList.setEnabled(enable);
}

scor.rg.awl.execControl.hideButton = function(buttonName) {
	var btnNameList = ['add', 'edit', 'remove'];
	var i;
	var found = -1;//false
	var button;
	for (i=0;i<btnNameList.length;i++){
		if (buttonName === btnNameList[i]) {
			found = i;
			break;
		}
	}
	if (found !== -1) {
		button = execControlVOList.buttonElements[found];
		button.style.display = 'none';
	}
};


function getExecControlVOs(){
    var vo = [];
    var rows = execControlVOList.getRows();
    for (var rowKey in rows)
    {
        var row = rows[rowKey];
        if (row != null && row != undefined)
        {
				
        	var items = [];
        	if(row['execControlpathId'] != undefined && scor.utils.trim(row['execControlpathId']) != ''/*row['path_ckboxId']*/){
        		items.push({"key":"path","criteria":row['pathMatchTypeId'],"value":scor.utils.trim(row['execControlpathId'])});
        	}
        	if(row['execControlcmdArgId'] != undefined && scor.utils.trim(row['execControlcmdArgId']) != ''){
        		items.push({"key":"command_line","criteria":row['cmdArgMatchTypeId'],"value":scor.utils.trim(row['execControlcmdArgId'])});
        	}
    		if(row['cmdArgMatchTypeId'] == '${noArgSpecified}'){
    			items.push({"key":"command_line","criteria":'${equals}',"value":""});
    		}
        	if(row['execControlparentProcessId'] != undefined && scor.utils.trim(row['execControlparentProcessId']) != ''/*row['parentProcess_ckboxId']*/){
        		items.push({"key":"parent_process_name","criteria":row['parentProcessMatchTypeId'],"value":scor.utils.trim(row['execControlparentProcessId'])});
        	}
        	if(row['execControluserNameId'] != undefined && scor.utils.trim(row['execControluserNameId']) != ''/*row['userName_ckboxId']*/){
        		items.push({"key":"user","criteria":row['userNameMatchTypeId'],"value":scor.utils.trim(row['execControluserNameId'])});
       		}
       		
            vo.push({"action": scor.utils.trim(row['execControlActionId']),
                "processName": scor.utils.trim(row['execControlProcessNameId']),
                "ruleDescription": scor.utils.trim(row['execControlDescriptionMsg']),
                "ruleItems": items
            });
        }
    }
    return vo;
}

scor.rg.awl.execControl.getStringWithMatch = function(ruleItemVOs, attributeKey){
		for(var index = 0 ; index < ruleItemVOs.length; index++){
			var ruleItemVO = ruleItemVOs[index];
			if(ruleItemVO.key == attributeKey){
				if(ruleItemVO.criteria == '${noArgSpecified}'
						||(ruleItemVO.criteria == '${equals}' && scor.utils.trim(ruleItemVO.value) == '')){
					ruleItemVO.displayString = scor.rg.awl.execControl.matchTypeToDisplayStringMap['${noArgSpecified}'];
					ruleItemVO.criteria = '${noArgSpecified}';
				}else{
					ruleItemVO.displayString = scor.rg.awl.execControl.matchTypeToDisplayStringMap[ruleItemVO.criteria]+': '+ruleItemVO.value;	
				}
				return ruleItemVO;
			}
		}
		return {"value":"","criteria":"", "displayString":""};
}

function populateExecControlVOs(execControlVOs){
    scor.utils.clearMagicListWidget(execControlVOList);
    execControlVOs = execControlVOs ? execControlVOs : {};
    for(var i=0; i < execControlVOs.length; i++)
    {
		
		var ruleItemVOs = execControlVOs[i].ruleItems;
		
		var path = scor.rg.awl.execControl.getStringWithMatch(ruleItemVOs, 
					"<%=ExecutionControlVO.EXECUTION_CONTROL_ATTRIBUTE_KEYS.PATH.getKey()%>");
		var parentProcessName = scor.rg.awl.execControl.getStringWithMatch(ruleItemVOs, 
					"<%=ExecutionControlVO.EXECUTION_CONTROL_ATTRIBUTE_KEYS.PARENT_PROCESS_NAME.getKey()%>");
		var cmdArgument = scor.rg.awl.execControl.getStringWithMatch(ruleItemVOs, 
					"<%=ExecutionControlVO.EXECUTION_CONTROL_ATTRIBUTE_KEYS.CMD_LINE.getKey()%>");
		var userName = scor.rg.awl.execControl.getStringWithMatch(ruleItemVOs, 
					"<%=ExecutionControlVO.EXECUTION_CONTROL_ATTRIBUTE_KEYS.USER.getKey()%>");
    
        var newObj = {
        	"execControlActionId" : execControlVOs[i].action,
        	"actionDisplayString" : scor.rg.awl.execControl.actionKeyToDisplayStringMap[execControlVOs[i].action],
            "execControlProcessNameId" : execControlVOs[i].processName,
            "execControlDescriptionMsg" : execControlVOs[i].ruleDescription === undefined?'':execControlVOs[i].ruleDescription,
            
            "pathMatchTypeId"	:			path.criteria,
            "execControlpathId" : 			path.value,
            "pathDisplayString" : 			path.displayString,
            
            "cmdArgMatchTypeId"			:	cmdArgument.criteria,
            "execControlcmdArgId"		: 	cmdArgument.value,
            "cmdArgDisplayString"		:	cmdArgument.displayString,
            
            "parentProcessMatchTypeId"	:	parentProcessName.criteria,
            "execControlparentProcessId": 	parentProcessName.value,
            "parentProcessDisplayString": 	parentProcessName.displayString, 
            
            "userNameMatchTypeId"	:		userName.criteria,
            "execControluserNameId" : 		userName.value,
            "userNameDisplayString" : 		userName.displayString
        }
        execControlVOList.insert(newObj) ;
    }
}


function execControlAddCallback(){
    execControlCommonCallBk('${addTitle}');
}


function execControlEditCallback(){
	var selectedRow = execControlVOList.selrow;
	if(typeof selectedRow === 'undefined' || selectedRow === null){
		return;
	}
	execControlCommonCallBk('${editTitle}');
}

function emptyAllFieldsForBlockInteractive(){ 
	$j('#execControlpathId').val('');
	$j('#execControlcmdArgId').val('');
	$j('#execControlparentProcessId').val('');
	$j('#execControluserNameId').val('');
	$j('#execControlDescriptionMsg').val('');
	$j('#cmdArgMatchTypeId').val('${equals}');//To empty attribute in case of interactive mode
	$j('#path_ckboxId').attr('checked', false);
	$j('#cmdArg_ckboxId').attr('checked', false);
	$j('#parentProcess_ckboxId').attr('checked', false);
	$j('#userName_ckboxId').attr('checked', false);
};

function populateMagicListValues(isBlockInteractiveAction){
		var actionStringElement = scor.utils.GetElementFromDialogBox('actionDisplayString','input');
		if( actionStringElement != undefined && actionStringElement != null){
			var actionString  = scor.rg.awl.execControl.actionKeyToDisplayStringMap[$j('#execControlActionId').val()];
			actionStringElement.value = actionString; 
		}
				
		if(isBlockInteractiveAction != undefined && isBlockInteractiveAction == true){
			emptyAllFieldsForBlockInteractive();
		}
		
		var pathStringElement = scor.utils.GetElementFromDialogBox('pathDisplayString','input');
		if( pathStringElement != undefined && pathStringElement != null){ 
			var pathString = '';
			if(scor.utils.trim($j('#execControlpathId').val()) != ''){
				pathString = scor.rg.awl.execControl.matchTypeToDisplayStringMap[$j('#pathMatchTypeId').val()]+': '+$j('#execControlpathId').val();
			}
			pathStringElement.value = pathString; 
		}
		
		var cmdArgStringElement = scor.utils.GetElementFromDialogBox('cmdArgDisplayString','input');
		if( cmdArgStringElement != undefined && cmdArgStringElement != null){ 
			var cmdArgString = '';
			if($j('#cmdArgMatchTypeId').val() == '${noArgSpecified}' && $j('#cmdArg_ckboxId').is(':checked') == true){
				cmdArgString = scor.rg.awl.execControl.matchTypeToDisplayStringMap[$j('#cmdArgMatchTypeId').val()];
			}
			if(scor.utils.trim($j('#execControlcmdArgId').val()) != ''){
				cmdArgString = scor.rg.awl.execControl.matchTypeToDisplayStringMap[$j('#cmdArgMatchTypeId').val()]+': '+$j('#execControlcmdArgId').val();
			}
			cmdArgStringElement.value = cmdArgString; 
		}
		
		var parentProcessStringElement = scor.utils.GetElementFromDialogBox('parentProcessDisplayString','input');
		if( parentProcessStringElement != undefined && parentProcessStringElement != null){
			var parentProcessString = ''; 
			if(scor.utils.trim($j('#execControlparentProcessId').val()) != ''){
				parentProcessString = scor.rg.awl.execControl.matchTypeToDisplayStringMap[$j('#parentProcessMatchTypeId').val()]+': '+$j('#execControlparentProcessId').val();
			}
			parentProcessStringElement.value = parentProcessString; 
		}
		
		var userNameStringElement = scor.utils.GetElementFromDialogBox('userNameDisplayString','input');
		if( userNameStringElement != undefined && userNameStringElement != null){
			var userNameString = ''; 
			if(scor.utils.trim($j('#execControluserNameId').val()) != ''){
				userNameString = scor.rg.awl.execControl.matchTypeToDisplayStringMap[$j('#userNameMatchTypeId').val()]+': '+$j('#execControluserNameId').val();
			}
			userNameStringElement.value = userNameString; 
		}
}

function execControlCommonCallBk(title){
	scorSetDialogSize(410,760);
    OrionCore.setDialogBoxTitle(title);
  	
  	var processNameElement = scor.utils.GetElementFromDialogBox('execControlProcessNameId','input');
  	var pathElement = scor.utils.GetElementFromDialogBox('execControlpathId','input');
  	var cmdArgElement = scor.utils.GetElementFromDialogBox('execControlcmdArgId','input');
  	var parentProcessElement = scor.utils.GetElementFromDialogBox('execControlparentProcessId','input');
  	var userElement = scor.utils.GetElementFromDialogBox('execControluserNameId','input');
  	
  	initEnableDisableState(pathElement, cmdArgElement, parentProcessElement, userElement);
  	registerValidationHandlers(processNameElement, pathElement, cmdArgElement, parentProcessElement, userElement);
  	actionButtonInit();
  	
    OrionForm.revalidate();
    var existingOkHanlder = OrionCore.dialogBoxOkHandler;
    OrionCore.dialogBoxOkHandler = function () {
	
    	var action = $j("input[name='execControlAction']:checked").val();
    	var isBlockInteractiveAction = (action != undefined && action != null && action == '${actionKeyBlockInteractive}');
    	
        if(!processNameValidator()){
            return false;
        }
        if(!isBlockInteractiveAction && !validateOtherAttributesOnOk()){
        	return false;
        }
    		
		unRegisterValidationHandlers(processNameElement, pathElement, cmdArgElement, parentProcessElement, userElement);
		
		populateMagicListValues(isBlockInteractiveAction);		
        existingOkHanlder();
        myEpoEnableApplyButton();
    	};
    
	};
	
	function initEnableDisableState(pathElement, cmdArgElement, parentProcessElement, userElement){
		if(OrionValidate.isNotEmpty(pathElement.value)){
			$j('#path_ckboxId').attr('checked', true);
		}
		enableDisableAttribute('path');
		if(OrionValidate.isNotEmpty(cmdArgElement.value)){
			$j('#cmdArg_ckboxId').attr('checked', true);
			enableDisableAttribute('cmdArg');
		}
		else if($j('#cmdArgMatchTypeId').val() == '${noArgSpecified}'){
			$j('#cmdArg_ckboxId').attr('checked', true);
			$j('#cmdArgMatchTypeId').attr('disabled',false).css("background-color","");
			$j('#execControlcmdArgId').attr('disabled',true);
		}else{
			enableDisableAttribute('cmdArg');
		}
		if(OrionValidate.isNotEmpty(parentProcessElement.value)){
			$j('#parentProcess_ckboxId').attr('checked', true);
		}
		enableDisableAttribute('parentProcess');
		if(OrionValidate.isNotEmpty(userElement.value)){
			$j('#userName_ckboxId').attr('checked', true);
		}
		enableDisableAttribute('userName');
	};
	
	function registerValidationHandlers(processNameElement, pathElement, cmdArgElement, parentProcessElement, userElement){
		 OrionEvent.registerHandler(processNameElement, processNameValidator , null, "keyup", false);
		 OrionEvent.registerHandler(pathElement, pathValidator , null, "keyup", false);
		 OrionEvent.registerHandler(cmdArgElement, cmdArgRegExValidatorOnKeyUp , null, "keyup", false);
		 OrionEvent.registerHandler(parentProcessElement, parentProcessNameValidator , null, "keyup", false);
		 OrionEvent.registerHandler(userElement, validateOtherAttributesOnKeyUp , null, "keyup", false);
		 OrionEvent.registerHandlerById('cmdArgMatchTypeId', cmdArgRegExValidatorOnKeyUp , null, "change", false);
		 OrionEvent.registerHandlerById('attrActionSelectId', actionSelectHandler , null, "change", false);
	};
	
	function unRegisterValidationHandlers(processNameElement, pathElement, cmdArgElement, parentProcessElement, userElement){
	
		OrionEvent.unregisterHandler(processNameElement, processNameValidator , null, "keyup", false);
		OrionEvent.unregisterHandler(pathElement, pathValidator , null, "keyup", false);
		OrionEvent.unregisterHandler(cmdArgElement, cmdArgRegExValidatorOnKeyUp , null, "keyup", false);
		OrionEvent.unregisterHandler(parentProcessElement, parentProcessNameValidator , null, "keyup", false);
		OrionEvent.unregisterHandler(userElement, validateOtherAttributesOnKeyUp , null, "keyup", false);	
		OrionEvent.unregisterHandlerById('cmdArgMatchTypeId', cmdArgRegExValidatorOnKeyUp , null, "change", false);
		OrionEvent.unregisterHandlerById('attrActionSelectId', actionSelectHandler , null, "change", false);
	};
	
	function actionButtonInit(){
		var action = $j('#execControlActionId').val();
		if(action != undefined && action != null && action == '${actionKeyBlockInteractive}'){
			//$j("input[name='execControlAction']").val('${actionKeyBlockInteractive}');
			$j('#actionKeyTypeAttrId').prop("checked", false);
			$j('#actionKeyBlockInteractiveTypeId').prop("checked", true);
			$j('#attributesTableId').hide();
			$j('#attrActionSelectId').attr('disabled',true).css("background-color","#EAE7E7");
			processNameValidator();
		}else{
			$j('#attributesTableId').show();
			$j('#attrActionSelectId').attr('disabled',false).css("background-color","");
			$j('#actionKeyBlockInteractiveTypeId').prop("checked", false);
			$j('#actionKeyTypeAttrId').prop("checked", true);
			if(action == ''){
				action = '${actionKeyMonitor}';
			}
			$j('#attrActionSelectId').val(action);
			$j('#execControlActionId').val(action);
		}
		
	};
	
	function actionSelectHandler(){
		var actionType = $j("input[name='execControlAction']:checked").val();
		if(actionType != undefined && actionType != null && actionType == '${actionKeyBlockInteractive}'){
			$j('#attributesTableId').hide();
			$j('#attrActionSelectId').attr('disabled',true).css("background-color","#EAE7E7");
			$j('#execControlActionId').val(actionType);
		}else{
			$j('#attributesTableId').show();
			$j('#attrActionSelectId').attr('disabled',false).css("background-color","");
			var action = $j('#attrActionSelectId').val();
			$j('#execControlActionId').val(action);
		}
	};
	
	function processNameValidator(){
	    var processNameElement = scor.utils.GetElementFromDialogBox('execControlProcessNameId','input');
	    var validationObj = scor.validation.emptyValidater(processNameElement);
        if(validationObj.isInvalid()){
            return false;
        }else{
        	validationObj = scor.validation.windowsFileNameCharactersValidater(processNameElement.value);
        	validationObj.setMsg('${fileNameValidationMsg}');
        	scor.validation.processValidationResult(validationObj,processNameElement);
        	if(validationObj.isInvalid()){
                return false;
        	}else{
        		return true;
        	}
        }
	    
	};
	
	function parentProcessNameValidator(){
		if(!$j('#parentProcess_ckboxId').prop('checked')){
			return true;
		}
	    var parentProcessNameElement = scor.utils.GetElementFromDialogBox('execControlparentProcessId','input');
	    var validationObj = scor.validation.windowsFileNameCharactersValidater(parentProcessNameElement.value);
    	validationObj.setMsg('${fileNameValidationMsg}');
    	scor.validation.processValidationResult(validationObj,parentProcessNameElement);
    	if(validationObj.isInvalid()){
            return false;
    	}else{
        	return true;
        } 
	};
	
	//Validation as wp/rp for CC policy
	function pathValidator(){
		if(!$j('#path_ckboxId').prop('checked')){
			return true;
		}
	    var pathElement = scor.utils.GetElementFromDialogBox('execControlpathId','input');
	    var pathValue = pathElement.value;
	    var validationObj = scor.validation.validatePath(pathValue, "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>");
    	//Check if this is not a network path followed by an invalid character at 3rd place.
    	//Need to be fixed in scor.validation.validatePath if this is an invalid case there too.
	    var validationObj1 = scor.validation.windowsFileNameCharactersValidater(pathValue.charAt(2));
	    var validationFlag2 = pathValue != null && pathValue.indexOf('*') < 0; //Check if path contains only '*'
	    
	    var isInValid = validationObj.isInvalid()  
	    					|| !validationFlag2
	    						|| ((pathValue.indexOf('\\\\') == 0) && validationObj1.isInvalid());
	    validationObj.setIsValid(!isInValid);
	    
    	validationObj.setMsg(OrionCore.escapeHtml('${pathValidationMsg}'));
    	scor.validation.processValidationResult(validationObj,pathElement);
    	if(isInValid){
            return false;
    	}else{
        	return true;
        } 
	};
	
	function cmdArgRegExValidatorOnOk(){
		if($j('#cmdArg_ckboxId').prop('checked')){
			return cmdArgRegExValidatorOnKeyUp();
		}
		return true;
	}
	
	function cmdArgRegExValidatorOnKeyUp(){
	    var cmdArgumentInputElement = scor.utils.GetElementFromDialogBox('execControlcmdArgId','input');
	    validateOtherAttributesOnKeyUp();//Handle for appropriate error message
	    var matchType = $j('#cmdArgMatchTypeId').val();
	    if(matchType == '${noArgSpecified}'){
	    	$j('#execControlcmdArgId').val('');
			$j('#cmdArgDisplayString').val('');
			$j('#execControlcmdArgId').attr('disabled',true);
			return true;
	    }else if( (matchType != '${matches}' && matchType != '${notMatches}')){
	    	$j('#execControlcmdArgId').attr('disabled',false);
	    	return true;
	    }
	    $j('#execControlcmdArgId').attr('disabled',false);
    	try {
    		   var arg =  cmdArgumentInputElement.value;
               new RegExp(arg);
               if(arg !== null && arg.length >=2){
            	   var testStr = arg;
            	   if(arg.indexOf('\\') == 0){
            		   testStr = '@'+arg;//preparing for regex match defined below 
            	   }
            	   //Finds all matches where there is a single/odd no. of backslash('\') followed by a non-escape character
	               var reString = /.*[^\\](\\\\)*\\[^utnvfrdDsSwWbB\\\/\.\*\+\?\|\(\)\[\]\{\}].*/;
            	   var re = new RegExp(reString);    
	               if(re.test(testStr) == true){
	            	   throw new ScorException("Invalid escape sequence in regular expression.");
	               }
               }
               var validationObj = new scor.validation.constructors.ValidationResult(true,'');
		       scor.validation.processValidationResult(validationObj,cmdArgumentInputElement);
		       return true;
        }
        catch(e) {
	           var validationObj = new scor.validation.constructors.ValidationResult(false,'${cmdArgValidationMsg}');
		       scor.validation.processValidationResult(validationObj,cmdArgumentInputElement);
		       return false;
        }
    
	};
	
	function validateOtherAttributesOnOk(){
		if(!cmdArgRegExValidatorOnOk() || !parentProcessNameValidator() || !pathValidator()){
        	return false;
        }
		return otherAttributesValidator(true);
	};
	
	function validateOtherAttributesOnKeyUp(){
		return otherAttributesValidator(false);
	};
	
	function otherAttributesValidator(fromOkHandler){
		
		var pathElement = scor.utils.GetElementFromDialogBox('execControlpathId','input');
		var cmdArgElement = scor.utils.GetElementFromDialogBox('execControlcmdArgId','input');
		var parentProcessNameElement = scor.utils.GetElementFromDialogBox('execControlparentProcessId','input');
		var userNameElement = scor.utils.GetElementFromDialogBox('execControluserNameId','input');
	   
	    var focusedElement = document.activeElement;
	    
	    if(focusedElement != undefined && focusedElement != null){
		    focusedElement = (focusedElement == pathElement
		    					|| focusedElement == cmdArgElement
		    						|| focusedElement == parentProcessNameElement
		    							|| focusedElement == userNameElement)? focusedElement : pathElement;
	    }
	    
	    var isValid =  OrionValidate.isNotEmpty(pathElement.value) 
			    		|| OrionValidate.isNotEmpty(cmdArgElement.value)
			    			||($j('#cmdArgMatchTypeId').val() == '${noArgSpecified}' && $j('#cmdArg_ckboxId').is(':checked') == true)
				    			|| OrionValidate.isNotEmpty(parentProcessNameElement.value)
				    				|| OrionValidate.isNotEmpty(userNameElement.value);

	    var msg = '';
	    if(isValid && fromOkHandler){
	    	//empty field not allowed
	    	if(!pathElement.disabled && !OrionValidate.isNotEmpty(pathElement.value)){
	    		focusedElement = pathElement;
	    		isValid = false;
	    	}
	    	else if(!cmdArgElement.disabled && !OrionValidate.isNotEmpty(cmdArgElement.value)
	    			&& ($j('#cmdArgMatchTypeId').val() != '${noArgSpecified}')){
	    		focusedElement = cmdArgElement;
	    		isValid = false;
	    	}
	    	else if(!parentProcessNameElement.disabled && !OrionValidate.isNotEmpty(parentProcessNameElement.value)){
	    		focusedElement = parentProcessNameElement;
	    		isValid = false;
	    	}
	    	else if(!userNameElement.disabled && !OrionValidate.isNotEmpty(userNameElement.value)){
	    		focusedElement = userNameElement;
	    		isValid = false;
	    	}
	    	msg = "Applicable fields cannot be empty.";
	    }else{
			msg = '${otherAttributesValidationMsg1} ' + '${addEditPathName_js}'+', '
						+'${addEditCmdArgumentName_js}'+', '+'${addEditParentProcessName_js}'+' ${otherAttributesValidationMsg2} '
							+'${addEditUserName_js}'+'.';
	    }
	    var validationObj = new scor.validation.constructors.ValidationResult(isValid, msg);
    	scor.validation.processValidationResult(validationObj,focusedElement);
		if(!isValid){
	    	return false;
	    }else{
	    	return true;
	    }
	};

</script>
