<!-- Copyright (C) 2014 McAfee, Inc.  All rights reserved.  -->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ page import="com.mcafee.scor.common.Constants"%>

<orion:message key="policy.mon.advanced.addRule" var="addRule" escape="none" />
<orion:message key="scor.policy.awl.obExclusion.file" var="fileVar"  escape="html"/>
<orion:message key="scor.policy.awl.obExclusion.process" var="processVar" escape="html"/>
<orion:message key="scor.policy.awl.obExclusion.obType" var="obTypeVar" escape="html"/>
<orion:message key="scor.policy.awl.obExclusion.rule" var="rule" escape="html"/>
<orion:message key="scor.policy.awl.obExclusion.rule" var="ruleJS" escape="javascript"/>
<orion:message key="scor.policy.awl.obExclusion.delete" var="delete" escape="html"/>
<orion:message key="policy.mon.adv.and" var="andVar" escape="html"/>
<orion:message key="policy.mon.adv.and" var="andVarJS" escape="javascript"/>
<orion:message key="scor.policy.awl.obExclusion.obFilterDescriptionText.text1" var="obFilterDescriptionText1" escape="html"/>
<orion:message key="scor.policy.awl.obExclusion.obFilterDescriptionText.text2" var="obFilterDescriptionText2" escape="html"/>

<jsp:include page="/common/includejQuery.jsp" />

<style type="text/css">
.obFiltersDescriptionArea {
	background-color:#EDEDED;
	border-color:#E0E0E0;
	border-style:none none solid;
	border-width:1px;
	color:#4A4A4A;
	font-size:10px;
	font-weight:normal;
	overflow:hidden;
	width:99%;
}
	
	.inputFieldClass {
		width:40%;
	}
	
	.deleteLinkClass {
		text-decoration: underline; 
		cursor: pointer; 
		cursor: hand;
	}
	
	.keyDivClass{
		padding-bottom: 3px;
	}
	
	.orLineDivClass{
		float: left; width: 48%; padding-bottom: 5px;
	}
	
	.orDivClass{
		width: 100%; float: left;
	}
</style>

<%!
    final String KEY_OBSERVATION_TYPE = "obType";
	final String KEY_FILE = "file";
	final String KEY_PROCESS = "process";	
	final String ID_KEY = "key";
	final String ID_CRITERIA = "criteria";
	final String ID_VALUE = "value";
	final String ID_DELETE = "delete";
	final String OB_RULE_FILTER_DIV = "obFilterDiv";
	final String HTML_OB_RULE_FILTER_DIV = "html-obFilterDiv";
	final String OBTYPE_ID_VALUE = KEY_OBSERVATION_TYPE+"-"+ID_VALUE;
	final String ERROR_DIV = "obErrorDiv";
%>

<script type="text/javascript">
		var scor = scor || {};
		scor.awl = scor.awl || {};
		scor.awl.obExclusion = scor.awl.obExclusion ||{};
		scor.awl.obExclusion.sectionCount = scor.awl.obExclusion.sectionCount || 0;
		scor.awl.obExclusion.obRuleSections = scor.awl.obExclusion.obRuleSections || [];
		scor.awl.obExclusion.obRulesMappedBySectionId = scor.awl.obExclusion.obRulesMappedBySectionId || {};
		

   		scor.awl.obExclusion.addRule = function (ruleItems, readOnly) {   
   	   		var rootDivElement = $j('#observationAllRulesDiv');
   			var childObRulesSectionDiv = $j('#observationRuleDiv').clone();
   			childObRulesSectionDiv.attr("id", "observationRuleDiv_"+scor.awl.obExclusion.sectionCount).css('display','inline');
   			scor.awl.obExclusion.setSectionIDInChildElementsForDiv(childObRulesSectionDiv);	   		
	   		rootDivElement.append(childObRulesSectionDiv);
	   		var obFilterRule = scor.awl.obExclusion.addMagicwidgetInChildSection(readOnly); 
	   		if (ruleItems) {
				for(var ruleItemIndex = 0; ruleItemIndex < ruleItems.length; ruleItemIndex++){
					var ruleItem = ruleItems[ruleItemIndex];
					var key = ruleItem.key;
					var criteria = ruleItem.criteria;
					var value = ruleItem.value;
					obFilterRule.add();
					var rowId =  obFilterRule.id;          
					scor.awl.obExclusion.setruleItems(key, criteria, value, rowId);				
				}
   		    }else{   	  
   		    	obFilterRule.add(); 		    
   		    	myEpoEnableApplyButton();
   	   		}  	   	   		 	   		
	   		scor.awl.obExclusion.obRuleSections.push(childObRulesSectionDiv.get(0)); 
	   		scor.awl.obExclusion.obRulesMappedBySectionId[scor.awl.obExclusion.sectionCount] = obFilterRule;
	   		scor.awl.obExclusion.registerHandlersForSection(scor.awl.obExclusion.sectionCount);
	   		if(readOnly){
   	   			scor.awl.obExclusion.doFormatingForReadOnlyGroupForObRuleDiv(childObRulesSectionDiv);   	
   	   	   	}	   	   	
	   		scor.awl.obExclusion.sectionCount++;	   		
   		}

   		scor.awl.obExclusion.setruleItems = function(key, criteria, value, rowId){
   			var keySeclectBox = $j("#<%=ID_KEY%>" + "_" + scor.awl.obExclusion.sectionCount + "_" + rowId);
   			$j(keySeclectBox).val(key);
  			var criteriaSeclectBox = $j("#<%=ID_CRITERIA%>" + "_" + scor.awl.obExclusion.sectionCount + "_" + rowId);
   			$j(criteriaSeclectBox).val(criteria);
   			var valueSelectBox = $j("#obType-value" + "_" + scor.awl.obExclusion.sectionCount + "_" + rowId);
   			var valueTextBox = $j("#<%=ID_VALUE%>" + "_" + scor.awl.obExclusion.sectionCount + "_" + rowId);
   	   		if(key === "<%=KEY_OBSERVATION_TYPE%>"){   	   			
   				$j(valueSelectBox).val(value);
   	   		}else{   	   			
   				$j(valueTextBox).val(value);
   	   	   	}
   	   		var map = {'key': keySeclectBox, 'valueBox' :valueTextBox, 'valueSelectBox':valueSelectBox,'criteriaBox': criteriaSeclectBox, 
   	    	   		'id': scor.awl.obExclusion.sectionCount, 'rowId': rowId};
   	   		scor.awl.obExclusion.onKeySelectdoFormating(map);
   	   	}
   		
   		scor.awl.obExclusion.setSectionIDInChildElementsForDiv = function(childObRuleDiv){
   			var allDivsInObRule = $j(childObRuleDiv).children('div');
   			for(var divIndex = 0 ; divIndex < allDivsInObRule.length; divIndex++){
	   	   			var div = allDivsInObRule[divIndex];
	   	   			var divKey = $j(div).attr('id');	   	   			  	   				
	   	   			$j(div).attr("id", divKey+"_"+scor.awl.obExclusion.sectionCount);	   	   			   	   	   	   		
	   	   	}	
   	   	}


   		scor.awl.obExclusion.doFormatingForReadOnlyGroupForObRuleDiv = function(inputDiv){
   			var allDivsInObRule = $j(inputDiv).find('div');
   			var sectionId = scor.awl.obExclusion.sectionCount;
   			for(var divIndex = 0 ; divIndex < allDivsInObRule.length; divIndex++){
	   	   			var div = allDivsInObRule[divIndex];
	   	   			var divKey = $j(div).attr('id');
	   	   			if(divKey.indexOf("<%=ID_DELETE%>") !== -1)
	   	   			{
	   	   				$j(div).html('${ruleJS} <br/> <br/>');
	   	   				continue;
		   	   		}
	   	   			if(divKey.indexOf("<%=OB_RULE_FILTER_DIV%>") !== -1)
	   	   			{
	   	   				var obRules = scor.awl.obExclusion.obRulesMappedBySectionId[sectionId]
	   	   				var rowIds = obRules.getRowIds();
         		 		for (var index = 0; index < rowIds.length; index++) {
         		 		 	var rowId = rowIds[index];
         	   		 		var keyBox = $j("#<%=ID_KEY%>" + "_" + sectionId + "_" + rowId); 
         	   		 		$j(keyBox).attr("disabled", true);
         	   		 		var criteriaBox = $j("#<%=ID_CRITERIA%>" + "_" + sectionId + "_" + rowId); 
         	   		 		$j(criteriaBox).attr("disabled", true);
         	   				var valueTextBox = $j("#<%=ID_VALUE%>" + "_" + sectionId + "_" + rowId); 
         	   				$j(valueTextBox).attr("disabled", true);
         	   				var valueSelectBox = $j("#obType-value" + "_" + sectionId + "_" + rowId);
         	   				$j(valueSelectBox).attr("disabled", true); 
         		 		}
	   	   			}   	   	   	   		
	   	   	}
   	   	}

   		scor.awl.obExclusion.addMagicwidgetInChildSection = function(readOnly){
   			var obHtmlContent = $j("#<%=HTML_OB_RULE_FILTER_DIV %>").html();
	   	 	while (obHtmlContent.indexOf("@SECTIONID") > -1){  
	   			obHtmlContent = obHtmlContent.replace("@SECTIONID", scor.awl.obExclusion.sectionCount);	 
	   	 	}  		
	   	 	var obj = new majic.AddWidget({
	         container:"<%=OB_RULE_FILTER_DIV%>" + "_" + scor.awl.obExclusion.sectionCount,
	         content:obHtmlContent,
	         readOnly: readOnly,
	         addCallback: scor.awl.obExclusion.rowAdded,
	         removeCallback: scor.awl.obExclusion.rowRemove
	     	});  
	     	return obj;	 	
   	   	}

   		scor.awl.obExclusion.rowAdded = function(row){
   			var parentDivId = $j(row).parent().attr("id");
   			var sectionCounter = scor.awl.obExclusion.getDivNumber(parentDivId);
   			var rowId = row.id;
   		   	var rowCounter = scor.awl.obExclusion.getDivNumber(rowId);
   		   	scor.awl.obExclusion.insertAndLabel(row);
   		 	scor.awl.obExclusion.registerHandlersForRows(sectionCounter, rowCounter);   		    
   		    myEpoEnableApplyButton();
   	   	}

   		scor.awl.obExclusion.rowRemove = function(){
   	   		var lastChild = this.cntr.lastChild;
   	   		var isAndLabelPresent = $j(lastChild).find("#andLabel");
   	   		if(isAndLabelPresent || isAndLabelPresent.length > 0){
   	   			$j(isAndLabelPresent).remove();
   	   	   	}
   		 	myEpoEnableApplyButton();   	   	
   	   	}

   		scor.awl.obExclusion.getDivNumber = function(divId){
   			return (divId).split(/_/).pop();
   	   	}

   		scor.awl.obExclusion.insertAndLabel = function(currentRow){
   	   		if(currentRow.previousSibling){
   	   	   		var isAndLabelPresent = $j(currentRow.previousSibling).find("#andLabel");
   	   	   		if(!isAndLabelPresent || isAndLabelPresent.length === 0){
   	   	   			var isPresentBreakElement = $j(currentRow.previousSibling).find('br');
					if(isPresentBreakElement.length !== 0){   				
						$j(isPresentBreakElement).before("<span id=\"andLabel\">${andVarJS}<\span>");
	   	   			}else{
   						$j(currentRow.previousSibling).append("<span id=\"andLabel\">${andVarJS}<\span>");
	   	   			}
   	   	   		}
   	   		}
   	   	}

   		scor.awl.obExclusion.registerHandlersForRows = function(sectionId, rowId){
   	   		var keyBoxid = "<%=ID_KEY%>"+"_"+sectionId+"_"+rowId;
   	   		var keyBox = $j('#'+keyBoxid);
   	   		
   	   		var valueTextBoxid = "<%=ID_VALUE%>"+"_"+sectionId+"_"+rowId;
   	   		var valueTextBox = $j('#'+valueTextBoxid);

   			var valueSelectBoxid = "obType-value"+"_"+sectionId+"_"+rowId;
   	   		var valueSelectBox = $j('#'+valueSelectBoxid);
   	   		    	
   	   		var criteriaBoxid = "<%=ID_CRITERIA%>"+"_"+sectionId+"_"+rowId;;
	   		var criteriaBox = $j('#'+criteriaBoxid);
	   		    	
   	   		var map = {'key': keyBox, 'valueBox' :valueTextBox, 'valueSelectBox':valueSelectBox,'criteriaBox': criteriaBox, 
   	    	   		'id': sectionId, 'rowId': rowId};
   	   		  		
   	   		OrionEvent.registerHandler(valueTextBox.get(0), scor.awl.obExclusion.onChangeValueTextBox, map, "keyup", true);	
	   		OrionEvent.registerHandler(criteriaBox.get(0), scor.awl.obExclusion.onCriteriaSelectTextBox, map, "change", true);
	   		OrionEvent.registerHandler(keyBox.get(0), scor.awl.obExclusion.onKeySelectBox, map, "change", true);   		   	   		
   	   	}

   		scor.awl.obExclusion.registerHandlersForSection = function(sectionId){
   	   			var deleteLink = "#<%=ID_DELETE%>"+"_"+sectionId;
   	   			var deleteDiv = $j(deleteLink);
   	   			var map = {'sectionId': sectionId};
  				OrionEvent.registerHandler(deleteDiv.get(0), scor.awl.obExclusion.onClickOfDeleteLink, map, "click", true);		
   	   	} 

   		scor.awl.obExclusion.onClickOfDeleteLink = function(evt){
   			var map = OrionEvent.getUserProperty(evt);
   			var sectionId = map.sectionId;
   	   		delete scor.awl.obExclusion.obRulesMappedBySectionId[sectionId];
   		 	myEpoEnableApplyButton();
   	   	}

   		scor.awl.obExclusion.onChangeValueTextBox = function(evt) {
   			var map = OrionEvent.getUserProperty(evt);
   			scor.awl.obExclusion.validateValueTextBox(map);
   	        myEpoEnableApplyButton();
   	     }
   		
   		scor.awl.obExclusion.onCriteriaSelectTextBox = function(evt) {
   			var map = OrionEvent.getUserProperty(evt);
   			scor.awl.obExclusion.validateValueTextBox(map);
   	        myEpoEnableApplyButton();
   	    }

   		scor.awl.obExclusion.onKeySelectBox = function(evt){
   			var map = OrionEvent.getUserProperty(evt);  
   			scor.awl.obExclusion.onKeySelectdoFormating(map) ;			
   	   	}

   		scor.awl.obExclusion.onKeySelectdoFormating = function(map){
   			var key = map.key;
   			var keyText = $j(key).val();
   			if(keyText !== "<%=Constants.OB_ADV_RULE_COND_EVENT_TYPE%>"){
   	   			var valueSelectBox = map.valueSelectBox;
   	   			$j(valueSelectBox).parent().css('display','none');
   			 	var valueBox = map.valueBox;
   			 	$j(valueBox).parent().css('display','inline')
    		    var criteriaBox = map.criteriaBox;
   			 	$j(criteriaBox).attr("disabled", false);
   			}else{
   	   			var valueSelectBox = map.valueSelectBox;
   	   			$j(valueSelectBox).parent().css('display','inline');
   			 	var valueBox = map.valueBox;
   			 	$j(valueBox).parent().css('display','none')
    		    var criteriaBox = map.criteriaBox;
   			 	$j(criteriaBox).attr("disabled", true);
   	   		}		   
   		 	myEpoEnableApplyButton();}

   		scor.awl.obExclusion.validateValueTextBox = function(map){
   	   		var key = map.key;
   	   		var keyText = $j(key).val();
   		    var valueBox = map.valueBox;
   		    var criteriaBox = map.criteriaBox;
   		  	var id = map.id;
   		  	var rowId = map.rowId;
   		    var criteriaText = $j(criteriaBox).val();
   		    var valueText = $j(valueBox).val();
   		    var isValid = true;
   		    var msg = "";
			if(keyText!== "<%=Constants.OB_ADV_RULE_COND_EVENT_TYPE%>" && criteriaText === "<%=Constants.MATCH_TYPE_EQUALS%>"){
   		    	var isValidObj = isPathValid(valueText, '${orion:escapeJavaScriptString(param.osType)}');
   		    	if (isValidObj) {
   		        	isValid = isValidObj.isValid;
   		        	msg = isValidObj.msg;
   		    	}
   		    	scor.awl.obExclusion.handleAefValidationError(isValid, msg, id, rowId);
			}else{
				scor.awl.obExclusion.handleAefValidationError(true, msg, id, rowId);
			}
   		}

   		
   		scor.awl.obExclusion.handleAefValidationError = function(isValid, msg, id, rowId){
			var row = $j("#<%=OB_RULE_FILTER_DIV%>"+"_"+id+"_awrow_"+rowId);
   			var errorDiv = $j("#<%=ERROR_DIV %>").clone();
   			var errorDivId = "<%=ERROR_DIV %>"+"_"+id+"_"+rowId;
   	   		errorDiv.attr("id", errorDivId); 
   			if(!isValid){
   				var isPresentBreakElement = $j(row).find('br');
   				if(!isPresentBreakElement || isPresentBreakElement.length === 0){   				
					row.append("<br/>");
   	   	   		}
   				var isErrorDivPresent = $j(row).parent().find("#"+errorDivId);
   	   	   		if(!isErrorDivPresent || isErrorDivPresent.length === 0){   				
					$j(errorDiv).css({'display':'inline','color': 'red'});
					$j(errorDiv).html(" " + msg);								
					row.append(errorDiv);
   	   	   		}else{
   	   	   			$j("#"+errorDivId).html(" ");
   	   	   			$j("#"+errorDivId).html(" " + msg);
   	   	   	   	}
			}else{
				$j("#"+errorDivId).html(" ");
				$j("#"+errorDivId).remove();
				$j(row).find('br').remove();
			}   					
     	 }


   		scor.awl.obExclusion.getRulesVO = function(){
     		  var finalobExclusionVOToSave = [];
     		  var sectionId;
     		 	for (sectionId in  scor.awl.obExclusion.obRulesMappedBySectionId) {
         		 		if(!(sectionId in scor.awl.obExclusion.obRulesMappedBySectionId)){
             		 		continue;
         		 		}
             		 	var obRules = scor.awl.obExclusion.obRulesMappedBySectionId[sectionId];
             		 	if(!obRules){
      	   	   		 		continue;
      	   	   		 	}
         	   		 	var ruleItems = [];
             		 	var rowIds = obRules.getRowIds();
             		 	for (var index = 0; index < rowIds.length; index++) {
                 		 	var rowId = rowIds[index];
         	   		 		var keyBox = $j("#<%=ID_KEY%>" + "_" + sectionId + "_" + rowId);                
                    		if (!keyBox || keyBox.length === 0) {   //maybe a deleted entry
                       			continue;
                    		}
                    		var key = $j(keyBox).val();
                    		var criteriaBox = $j("#<%=ID_CRITERIA%>" + "_" + sectionId + "_" + rowId); 
                    		var criteria = $j(criteriaBox).val();
                    		var value;
    						if(key ===  "<%=Constants.OB_ADV_RULE_COND_EVENT_TYPE%>"){
    							var selectValueBox = $j("#obType-value" + "_" + sectionId + "_" + rowId); 
    							value = $j(selectValueBox).val();
    						}else{
    							var textValueBox = $j("#<%=ID_VALUE%>" + "_" + sectionId + "_" + rowId); 
    							value = $j(textValueBox).val();
    						}
    				    	if (value === '') {
    			             	continue;       //skip empty values
    			        	}
                        	var item = {"key": key, "value": value, "criteria": criteria};
                    		ruleItems.push(item);
         	   			}     		 	                                               		 	
             		
         		 	if(ruleItems.length === 0) { continue; } //skip empty Rules
 	        		var _ruleItem = {"ruleItems": ruleItems};
 	        		finalobExclusionVOToSave.push(_ruleItem);  
     		 	}
         		 return finalobExclusionVOToSave; 	
     	   	}
   		
        	 
   	    

   		scor.awl.obExclusion.createAdvancedUI = function(observationExclusionObj, readOnly){
   			scor.awl.obExclusion.clearAdvancedUI();
         	if (!observationExclusionObj){
             	return;
         	}
         	for (var i = 0; i < observationExclusionObj.length; i++) {
             	if ((!observationExclusionObj[i].ruleItems) || (observationExclusionObj[i].ruleItems.length == 0)) {
                 	continue;
             	}
             	scor.awl.obExclusion.addRule(observationExclusionObj[i].ruleItems, readOnly);
         	}    	   		
   	   	}
   	   	

   		scor.awl.obExclusion.clearAdvancedUI = function() {
   	        while (scor.awl.obExclusion.obRuleSections.length !== 0) {
   	        	scor.awl.obExclusion.deleteRule(scor.awl.obExclusion.obRuleSections[0], true);
   	        }
   	     	scor.awl.obExclusion.obRuleSections = [];
   	     	scor.awl.obExclusion.obRulesMappedBySectionId = {};
   	     	scor.awl.obExclusion.sectionCount = 0;
   	    }


   		scor.awl.obExclusion.deleteRule = function (obj, fromCode) {
   		    for (var i = 0; i < scor.awl.obExclusion.obRuleSections.length; i++) {
   		        var div = scor.awl.obExclusion.obRuleSections[i];

   		        if (div == obj) {
   		        	scor.awl.obExclusion.obRuleSections.splice(i, 1);
   		            obj.parentNode.removeChild(obj);
   		            obj = null;     // Required for IE
   		            break;
   		        }
   		    }
   		}
   	    

  		scor.awl.obExclusion.ruleGroupReadOnly = function(readOnly){
   			OrionCore.setEnabledById( "SCORAddObExclusionRule", readOnly );
   	   	}

  </script>
  
 <orion:box id="observationExclusion">
            <br/><br/>
            <table id="" cellspacing='0' cellpadding='0' width='98%' style="padding-left: 10px;">
                <%@ include file="../AdjustOtherTabs.jsp" %>
                <tr>
                    <td>
                        
                    </td>
                </tr>
            </table>
        
<div id="observationAllRulesDiv" style="padding-left: 10px;">
	<div class="obFiltersDescriptionArea">${obFilterDescriptionText1 }<br/><br/>
		${obFilterDescriptionText2 }<br/><br/></div> <br/>
</div>
<div id="addRuleButtonBox" style="padding-left: 10px;"><orion:button id="SCORAddObExclusionRule" onclick="scor.awl.obExclusion.addRule(null, false);" text="${addRule}" /></div>
            
</orion:box>



<div id="observationRuleDiv" style="display: none;">
	<div id="<%=ID_DELETE%>">${rule} | <a class="deleteLinkClass" onclick="scor.awl.obExclusion.deleteRule(this.parentNode.parentNode, false)"> ${delete} </a> <br />
		<br />
	</div>
	<div id= "<%=OB_RULE_FILTER_DIV %>"></div>
	<div id="scorObExclusionOrBar" style='width: 100%; float: left;'>
		<div class = "orLineDivClass">
			<HR>
		</div>
		<div style="float: left; font-size: small;"><orion:message key="policy.mon.adv.or" escape="html" /></div>
		<div class = "orLineDivClass">
			<HR>
		</div>
		<br />
	</div>
</div>

<div id= "<%=HTML_OB_RULE_FILTER_DIV %>" style="display: none;font-size: 10px;">
	 <select id="<%=ID_KEY + "_" + "@SECTIONID_@ID"%>" name="<%=ID_KEY + "_" + "@SECTIONID_@ID"%>" tabindex="0">
       	<option value="<%=Constants.OB_ADV_RULE_COND_EVENT_TYPE%>">${obTypeVar}</option>
       	<option value="<%=Constants.OB_ADV_RULE_COND_FILE%>">${fileVar}</option>
       	<option value="<%=Constants.OB_ADV_RULE_COND_PARENT_PROCESS%>">${processVar}</option>        
    </select>
    	
	<select id="<%=ID_CRITERIA + "_" + "@SECTIONID_@ID"%>" name="<%=ID_CRITERIA + "_" + "@SECTIONID_@ID"%>" tabindex="0" disabled="disabled">
		<option value="equals"><orion:message key="scor.policy.mon.adv.match.equals" escape="html" /></option>
		<option value="begins"><orion:message key="scor.policy.mon.adv.match.beginsWith" escape="html" /></option>
		<option value="ends"><orion:message key="scor.policy.mon.adv.match.endsWith" escape="html" /></option>
		<option value="contains"><orion:message key="scor.policy.mon.adv.match.contains" escape="html" /></option>
		<option value="doesnt_contain"><orion:message key="scor.policy.mon.adv.match.doesNotContain" escape="html" /></option>
	</select> 
		
	<div id="<%=OBTYPE_ID_VALUE + "-div"%>" style="display:inline;">
		<orion:select id="obType-value_@SECTIONID_@ID" items="${observationDisplayKeyAttr}"/>	
	</div>
		
	<div id="<%=ID_VALUE+"-div"%>" style="display:none;">
       	<input id="<%=ID_VALUE + "_" + "@SECTIONID_@ID"%>" class="orionInput" tabindex="0" type="text" style="width:40%"/>
    </div>    	
</div>

<div id="<%=ERROR_DIV %>" style="display:none;"> </div>
