<!-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved-->
<%@ page import="com.mcafee.scor.common.Constants" %>

<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<orion:script context="/core" src="/majic.js"/>
<orion:script context="/core" src="/listlib.js"/>


<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="/jsFiles/ccpolicy/rp.js"/>
<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="/jsFiles/commonPolicy.js"/>

<orion:message key="scor.policy.cc.wp.groups" var="groups" escape="javascript"/>


<jsp:include page="../monpolicy/PolicyCommon.jsp"/>


<orion:box id="read-protect">
    <table cellspacing="0" cellpadding="0" width="98%">
        <tr>
            <td class="orionSummaryColumn">
                <table cellspacing='3' cellpadding='0' width='620px'>
                    <tr>
                        <td width="10%"><b><orion:message key="policy.mon.filter"
                                                          escape="html"/></b></td>
                        <td width="90%"><b><orion:message key="scor.policy.cc.file"
                                                          escape="html"/></b>
                        </td>
                    </tr>
                </table>
                <orion:box id="rpidPathFilterList" height="auto" width="620"/>
            </td>
        </tr>
    </table>
</orion:box>


<script type="text/javascript">
    var rpplatform;
    var rpreadOnly;
    var rptype;
    var rppathFilterList = new majic.ListWidget({
        container: "rpidPathFilterList",
        width: "620px",
        height: "320px",
        addCallback: fnAddPathFilterCallback,
        editCallback: fnAddPathFilterCallback,
        removeCallback: myEpoEnableApplyButton,
        buttons: {
            'add': '<orion:message key="policy.mon.button.add" escape="javascript"/>',
            'edit': '<orion:message key="policy.mon.button.edit" escape="javascript"/>',
            'remove': '<orion:message key="policy.mon.button.remove" escape="javascript"/>'
        },
        content: $('rp_path_filter_editor_template').innerHTML,
        displayText: $('filter_list_row_template').innerHTML
    });

    function getReadProtectVOArray() {
        <%--var arr = [];--%>
        <%--var paths = getProfileUnitVOArray(rppathFilterList);--%>
        <%--var groupName = OrionList.getSelectedItemText("<%=Constants.SCOR_CC_RP_GROUP_LIST_NAME%>");--%>
        <%--var result = scor.vos.profile.cc.ReadProtectVO(groupName,rpplatform,rpreadOnly,rptype,paths) ;--%>
        <%--arr.push(result.common.getVO());--%>
        <%--return arr;--%>
    }

    function rpinit(rpVOArr) {
        <%--//As we support only one group, so just hardcoding it--%>
        <%--var rpVO = rpVOArr[0];--%>
        <%--var groupName = rpVO.getGroupName();--%>
        <%--rpplatform= rpVO.getplatform();--%>
        <%--rpreadOnly= rpVO.getreadOnly();--%>
        <%--rptype=rpVO.gettype();--%>
        <%--var files = rpVO.getRpFiles();--%>
        <%--var map = {};--%>
        <%--map.key = "rp0";--%>
        <%--map.label = groupName;--%>
        <%--if ("${epoReadOnlyPolicyObject}" == "true") {--%>
            <%--rppathFilterList.setEnabled(false);--%>
        <%--}--%>
    }
</script>




