<!-- COPYRIGHT:		Copyright (C) 2019 McAfee, Inc.  All rights reserved-->

<%@taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<%@page import="com.mcafee.scor.common.ScorReturnCodes"%>
<%@page import="com.mcafee.scor.cpe.CPEConstants"%>
<%@page import="com.mcafee.scor.common.URLConstants"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>


<script type="text/javascript">
    OrionHelp.setHelpId("<%=HelpConstants.INVENTORY_BY_CPE_PAGE%>");
</script>

<c:set var="registeredTypeUID" value="scor.rt.cpeActions.uid" scope="request"/>
<c:set var="cpeTab" value="CpeApplicationsTab" scope="request"/>

<orion:message key="scor.reporting.inventory.cpeView.cpeTableTitle" var="cpeTableTitle" escape="none"/>

<orion:vbox>
    <orion:table2 id="cpeTableId" titleText="${requestScope.tableTitle}"
                  cellRendererAttr="<%=CPEConstants.CPE_CELL_RENDR_ATTR%>"
                  datasourceAttr="<%=CPEConstants.CPE_DATASOURCE_ATTR%>"
                  showCheckboxColumn="true"
                  sortOrder="0"
                  showTitleBar="false"
                  allowExport="true"
                  allowConfiguration="true"
                  allowAction="true"
                  allowFilter="true"
                  expandFilters="true"
                  showFilters="true"
                  allowAdvancedFilter="true"
                  enableDrilldown="false"
                  columnWidths="25,20,10,30,10"

                  registeredTypeUID="${requestScope.registeredTypeUID}"/>

</orion:vbox>




