<!-- COPYRIGHT:		Copyright (C) 2019 McAfee, Inc.  All rights reserved-->

<%@taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<%@page import="com.mcafee.scor.common.ScorReturnCodes"%>
<%@page import="com.mcafee.scor.cpe.CPEConstants"%>
<%@page import="com.mcafee.scor.common.URLConstants"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>



<orion:core>
    <orion:corehead>
        <%@ page import="com.mcafee.scor.common.URLConstants" %>
        <jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
    </orion:corehead>
    <orion:corebody>
        <orion:navigation tabId="scor.tab.cpe" />
        <orion:content>
            <orion:vbox>
                <jsp:include page="../common/alertForRunningContentUpdateOrMigrationOrRuleGroupSync.jsp"/>
                <orion:hbox>

                    <orion:vbox>
                        <orion:table2 id="cpesystemsappId" titleText="${requestScope.tableTitle}"
                                      cellRendererAttr="<%=CPEConstants.CPE_BY_SYSTEMS_CELL_RENDR_ATTR%>"
                                      datasourceAttr="<%=CPEConstants.CPE_BY_SYSTEMS_DATASOURCE_ATTR%>"
                                      showCheckboxColumn="true"
                                      sortOrder="0"
                                      showTitleBar="false"
                                      allowExport="true"
                                      allowConfiguration="true"
                                      allowAction="true"
                                      allowFilter="true"
                                      expandFilters="true"
                                      showFilters="true"
                                      allowAdvancedFilter="true"
                                      enableDrilldown="false"
                                      columnWidths="25,20,10,30,10"
                        />

                    </orion:vbox>

                </orion:hbox>
                <orion:message key="scor.navigation.back" var="backButtonText" escape="none" />
                <orion:footerbar align="right">
                    <orion:button id="back" text="${backButtonText}" onclick="OrionNavigation.back();"/>
                </orion:footerbar>
            </orion:vbox>
        </orion:content>
    </orion:corebody>

</orion:core>
