<!-- COPYRIGHT:		Copyright (C) 2015 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="com.mcafee.scor.cpe.CPEConstants" %>

<orion:script context="/core" src="/yui/connection/connection-min.js"/>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>

<orion:message key="scor.error.dialogBox.title" var="scorErrorTitle" escape="javascript"/>
<orion:message key="scor.inventory.CPE.importCPEDictionary.error" var="errorImportingCPEDictionary" escape="javascript"/>


<c:if test="${importCPEDictionaryType eq 'nist'}">
    <orion:message key="scor.cpe.importCPEDictionary.dialog.text" var="importCPEDictionaryConfirm" escape="html"/>

</c:if>
<c:if test="${importCPEDictionaryType eq 'custom'}">
    <orion:message key="scor.cpe.importCustomCPEDictionary.dialog.text" var="importCPEDictionaryConfirm" escape="html"/>
</c:if>





<SCRIPT  type="text/javascript">
    var isCustom =  ${importCPEDictionaryType eq 'custom'};

    OrionCore.addLoadHandler(init);

    var onUploadButtonClick = function(e)
    {
        scor.utils.fixYUIFileUploadOnIe();
        YAHOO.util.Connect.setForm(OrionForm.getForm(), true);
        var uploadHandler = {
            upload: function(res)
            {
                var result = res.responseText;
                verifySuccess(result);
            }
        };

        OrionForm.setEncoding(OrionForm.MULTIPART);
        try
        {
            if (!isCustom) {
                YAHOO.util.Connect.asyncRequest('POST', "<%=URLConstants.IMPORT_CPE_DICTIONARY_ACTION_URL%>?custom=<%=CPEConstants.CPE_INVENTORY_CPE_IMPORT%>", uploadHandler);
            }
            else
            {
                YAHOO.util.Connect.asyncRequest('POST', "<%=URLConstants.IMPORT_CPE_DICTIONARY_ACTION_URL%>?custom=<%=CPEConstants.CPE_INVENTORY_CUSTOM_IMPORT%>", uploadHandler);
            }
        }
        catch(e)
        {
            alert ("${errorImportingCPEDictionary}");
        }
        OrionCore.showPleaseWait(true);
    };

    function verifySuccess(result){

        OrionCore.showPleaseWait(false);
        var resultObj = JSON.parse(result);
        var resultVO = scor.vos.Result(resultObj);
        if (resultVO.isSuccess()) {
            OrionCore.showDialogBox(true,resultVO.getResult(),OrionCore.DIALOG_OK);
        } else {
            OrionCore.showDialogBox(true,resultVO.getMsg(),OrionCore.DIALOG_OK);
        }
    }

    function init(){
        OrionCore.dialogBoxOkHandler = onUploadButtonClick;
    }
    init();

</SCRIPT>


<table>
    <tr>
        <td>
            ${importCPEDictionaryConfirm}
        </td>
    </tr>
    <tr>
        <td>
            <orion:fileupload  id="scor.import.cpeDictionary"  name="scorImportCPEDictionary"  required="true" contentEditable="false"/>
        </td>
    </tr>
</table>

