<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved. -->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.URLConstants"%>
<%@page
	import="com.mcafee.scor.observationmode.ObservationModeConstants"%>
<%@ page import="com.mcafee.scor.common.Constants"%>
<%@ page import="com.mcafee.scor.event.EventConstants"%>
<%@ page import="com.mcafee.scor.common.HelpConstants"%>
<%@ page import="com.mcafee.scor.common.URLConstants"%>
<%@ page import="com.mcafee.scor.filediff.FileDiffConstants"%>

<%@ page import="com.mcafee.scor.common.HelpConstants"%>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>" />
<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.EVENTS_PAGE%>");
</script>

<jsp:include page="/common/includejQuery.jsp" />
<orion:message key="scor.SCOR_EVENTS.table.name" var="eventTableTitle" escape="none" />
<orion:message var="GroupsTreeTitleText" key="scor.SCOR_EVENTS.orggrouptree.title" escape="none" />
<orion:message key="scor.SCOR_EVENTS.filter.title.text" var="filterTitleText" escape="none" />
<orion:message key="scor.SCOR_EVENTS.filter.timefilter" var="timeFilter" />
<orion:message key="scor.SCOR_EVENTS.filter.systemtreefilter" var="systemTreeFilter" />
<orion:message key="scor.SCOR_EVENTS.filter.thisgrouponly" var="thisGroupOnly" />
<orion:message key="scor.SCOR_EVENTS.filter.thisgroupandallsubgroups" var="thisGroupAndAllSubgroups" />
<orion:message key="scor.SCOR_EVENTS.filter.lastonehour" var="lastonehour" />
<orion:message key="scor.SCOR_EVENTS.filter.lastoneday" var="lastoneday" />
<orion:message key="scor.SCOR_EVENTS.filter.lastsevendays" var="lastsevendays" />
<orion:message key="scor.SCOR_EVENTS.filter.lastthirtydays" var="lastthirtydays" />
<orion:message key="scor.SCOR_EVENTS.filter.alltime" var="alltime" />
<orion:message key="scor.event.filter.advanced.text" var="advancedFilterText" />
<orion:message key="scor.event.filter.advanced.filtered" var="filteredText" escape="none" />
<orion:message key="scor.event.userComments.dialog.title" var="userCommentsDialogTitle" escape="javascript" />
<orion:message key="scor.SCOR_EVENTS.filter.alltime" var="alltime" />
<orion:message key="scor.reputation.whatisreputationbasedexecution.label" var="whatsReputationBasedExecution" escape="html" />
	
	
<script type="text/javascript">
			  function getTitleForActionColumn(elementId) {
				var titleText;
				$j(elementId).parent("td").find("a").each(function(index){
				if(index === 0)
				 {
				 titleText=$j(this).text();
				 }
				 else
				 {
				  titleText=titleText+"  |  "+$j(this).text();
				 }
				})
				$j(elementId).parent("td").attr("title",titleText);
				}
	    		OrionCore.addLoadHandler(init);
	    		    
	            function fnGroupSelectionChanged(node){
			        var key = OrionTree.getNodeKey(node);
	                var paramMap = ["orgGroupKey", key];
	                $j("#EventsTable_scrollContainer").scrollTop(0);
	                scor.actions.doAsyncAction("<%=URLConstants.SLASH_WEB_APP_NAME%>/<%=URLConstants.SET_ORGANIZATION_GROUP_ID_URL%>", paramMap, fnSuccess);
	            }
	
	            function fnSuccess(){
	                    var timeFilterElement = document.getElementById("scortimeFilter");
        				var time= timeFilterElement.options[timeFilterElement.selectedIndex].value;
        				var sysTreeFilterForGroupInclusionElement = document.getElementById("systemtreefilter");
        				var sysTreeGroupInclusion = sysTreeFilterForGroupInclusionElement.options[sysTreeFilterForGroupInclusionElement.selectedIndex].value;
        				var filterStr = time + " " + sysTreeGroupInclusion;
        				var requestsTable = MFSTable.get("EventsTable");
    	            	requestsTable.setFilter(filterStr);
	            }

	            
	            function init(){
	            	requestsTable = MFSTable.get("EventsTable");
	            	requestsTable.setOnStateChange(scorEventsTableStateChanged);
        			OrionTree.expandToPath("GroupsTree", "${scorNodeExpandPath}", false,"${scorSelectedNodeKey}");
        			
    			}	            
	           

	            function scorAWLPolicyForEventId(eventId){	            	
	            		OrionCore.doAction("<%=URLConstants.OBSERVATION_SUGGESTION_FOR_EVENT_ID_URL%>", ["uid",eventId], "GET");                  	
	            }
	            
	            function getActionIndexByURLInActionTab(url) {
                    var scorEventsTableActionIndex = -1;
	            	for(var j in OrionAction.actionList){
                        if(OrionAction.actionList[j].actionURI.indexOf(url) != -1){
                        	scorEventsTableActionIndex = j;
                        	break;
                        }
                    }
                    return scorEventsTableActionIndex;
	            }
	            
	            function enableDisableActionOnEventSelection() {
    				var scorEventsTableDismissActionIndex;
    				var requestsTable = MFSTable.get("EventsTable");
                    var selectedUids = requestsTable.getSelected().split(",");
                    var dismissSuggestionActionIndex = getActionIndexByURLInActionTab("dismissSuggestions.do");
                    var excludeEventActionIndex = getActionIndexByURLInActionTab("loadExcludeDialogUi.do");
                    for(var k in selectedUids){
                    	if (selectedUids[k] === "") {
                    		continue;
                    	}
                    	var sizeOfExcludeEventLinks=$j('#'+selectedUids[k] + ' .showClassForMaliciousEvent').size();
                    	if(sizeOfExcludeEventLinks ===1){
                    		OrionAction.actionList[excludeEventActionIndex].disabled = true;
                    	}
                    	var sizeOfSuggestionLinks = $j('#'+selectedUids[k] + ' .showSuggestionClass').size();
                    	if (sizeOfSuggestionLinks === 1) {
                    		OrionAction.actionList[dismissSuggestionActionIndex].disabled = false;
                    		return;
                    	}
                    }
                    
          			OrionAction.actionList[dismissSuggestionActionIndex].disabled = true;
	            }

       			function scorEventsTableStateChanged(){
    				if("${isReconLicenseSupported}" === "true"){
    					for(var i in OrionAction.actionList){
                            if(OrionAction.actionList[i].actionURI.indexOf("doManualRecon.do") != -1){
                                    OrionAction.actionList[i].disabled = true;
                            }
    					}
    				}
    				
    				enableDisableActionOnEventSelection();
       			}
       			var scor = scor || {};
            	scor.event = scor.event || {};
         

        scor.event.page = (function(){
                    var tab ;
                    return {
                        	getTable : function(){
                    				return tab;
                    			},
                			setTable : function(table){
                    				tab = table;
                    			}
                        }
                    })();
         scor.event.handleUserComments = function(event,targetAction){
        	 		OrionEvent.stopPropagation(event); 
                	scor.event.eventIdForUserComments=$j(targetAction).attr("hrefattr");
                	scor.event.eventUserComments =''; 
                	if($j(targetAction).attr("hrefcomment") ==='1')
                		scor.event.eventUserComments = event.target.innerText || event.srcElement.innerText; 
                    OrionCore.showDialogBox(true, $('userCommentsGroupTempLate').innerHTML, OrionCore.DIALOG_OK_CANCEL);
                    $j('#userComments').text(scor.event.eventUserComments);     
                    OrionCore.setDialogBoxTitle('${userCommentsDialogTitle}');
                    OrionCore.dialogBoxOkHandler = scor.event.handleUserCommentsDialogHandler;

                }
         

         scor.event.handleUserCommentsDialogHandler = function(){
                    var form = document.getElementById('orion.dialog.box.text.id');
                    var flds = {};
                    flds = scor.utils.getFormVals(form);
                    if(scor.event.eventUserComments === flds['<%=Constants.USER_COMMENTS%>']){
                        return false;
                    }      
                    scor.actions.doAsyncAction("<%=URLConstants.USER_COMMENTS_FROM_LINK_EVENT_URL%>",
                            ['<%=EventConstants.UIDS%>',scor.event.eventIdForUserComments,'<%=Constants.USER_COMMENTS%>',flds['<%=Constants.USER_COMMENTS%>'] ], 
                            scor.event.handleUserCommentsSuccess );

			}
          scor.event.handleUserCommentsSuccess = function(result) {
        	  	var requestsTable = MFSTable.get("EventsTable");
				requestsTable.refresh();
			}

</script>





<orion:hbox>
	<orion:vbox id="GroupsVbox" width="200">
		<orion:titlebar id="GroupsTreeTitle" text="${GroupsTreeTitleText}" />
		<orion:tree id="GroupsTree" checkboxes="false" selectable="true"
			treeDataAttr="<%=EventConstants.SCOR_MONITORING_EVENTS_SYSTEM_TREE_ATTR%>"
			preloadData="false" />
		<script type="text/javascript">
				OrionTree.setSelectHandler(fnGroupSelectionChanged);
			</script>
	</orion:vbox>
	<orion:vdivider id="divider" resizeTarget="GroupsVbox" />
	<orion:vbox>
        <orion:box height="100">
                <orion:titlebar text="${filterTitleText}">
                </orion:titlebar>
                <table width="100%" height="70%" cellspacing="1px" cellpadding="1px" style="background-color: rgb(235, 235, 235); width: 100%;">
                    <tr>
                        <td width="10%">
                            ${timeFilter}
                        </td>
                        <td width="40%">
							<select id="scortimeFilter" name="scortimeFilter" onchange="fnSuccess()">
								<option <c:if test="${scorTimeFilterAttr eq 'scor.SCOR_EVENTS.timeFitler.lastOneHour'}">selected="true"</c:if> value="scor.SCOR_EVENTS.timeFitler.lastOneHour">${lastonehour}</option>
								<option <c:if test="${scorTimeFilterAttr eq 'scor.SCOR_EVENTS.timeFitler.lastOneDay'}">selected="true"</c:if> value="scor.SCOR_EVENTS.timeFitler.lastOneDay">${lastoneday}</option>
								<option <c:if test="${scorTimeFilterAttr eq 'scor.SCOR_EVENTS.timeFilter.lastSevenDays'}">selected="true"</c:if> value="scor.SCOR_EVENTS.timeFilter.lastSevenDays">${lastsevendays}</option>
								<option <c:if test="${scorTimeFilterAttr eq 'scor.SCOR_EVENTS.timeFilter.lastThirtyDays'}">selected="true"</c:if> value="scor.SCOR_EVENTS.timeFilter.lastThirtyDays">${lastthirtydays}</option>
								<option  <c:if test="${scorTimeFilterAttr eq 'scor.SCOR_EVENTS.timeFilter.all'}">selected="true"</c:if> value="scor.SCOR_EVENTS.timeFilter.all">${alltime}</option>
							</select>
                        </td>
                         <td width="10%">
                            ${systemTreeFilter}
                        </td>
                        <td width="20%">
                        	<select id="systemtreefilter" name="systemtreefilter" onchange="fnSuccess()">
								<option <c:if test="${scorGroupSubgroupFilterAttr eq 'scor.SCOR_EVENTS.filter.thisgrouponly'}">selected="true"</c:if> value="scor.SCOR_EVENTS.filter.thisgrouponly">${thisGroupOnly}</option>
								<option <c:if test="${scorGroupSubgroupFilterAttr eq 'scor.SCOR_EVENTS.filter.thisgroupandallsubgroups'}">selected="true"</c:if> value="scor.SCOR_EVENTS.filter.thisgroupandallsubgroups">${thisGroupAndAllSubgroups}</option>
							</select>
                        </td>
                        <td width="20%" align="right" style="padding-right: 1%;">
                        <c:if test="${whatsFinalReputationLink !=null}">
							<a href="${orion:escapeHtml(whatsFinalReputationLink)}" target="_blank">
                       			 ${whatsReputationBasedExecution}
                        	</a>
                        </c:if>
                        </td>
                    </tr>
                    <tr>
                       <td width="10%"><a href="/SOLIDCORE_META/displayEventFilters.do${scor_csrf_param_lq}">${advancedFilterText}</a></td>
                       <td width="40%"></td>
                       <td width="10%"></td>
                       <td width="20%"></td>
                       <td width="20%"></td>
                    </tr>
                    <tr style="display:none">
		                      <td>
		                            <input type="hidden" id="urlForActionColumn"/>
		                      </td>
		           </tr>
                </table>
		</orion:box>
			<orion:table2 id="EventsTable" registeredTypeUID="scor.rt.SCOR_EVENTS"
			titleText="${empty scorEventAdvancedFilterXML ? eventTableTitle : eventTableTitle.concat(' (').concat(filteredText).concat(')')}"
			cellRendererAttr="<%=EventConstants.SCOR_EVENTS_CELL_RENDERER_ATTR%>"
			datasourceAttr="<%=EventConstants.SCOR_EVENTS_DATASOURCE_ATTR%>"
			sortColumn="detectedUTC" sortOrder="1" 
			showCheckboxColumn="true"
			properties="detectedUTC,hostName,evtOrigUserName,evtFileName,evtDisplayKey,evtDenyReasonId,evtReputationScore,actions,userComments"
			/>
		
	</orion:vbox>
</orion:hbox>
<div id="userCommentsGroupTempLate" style="display: none;">
<br>
	<table>
		<tr>
		  <td>&nbsp;&nbsp;&nbsp;</td>
			<td><orion:textarea id="<%=Constants.USER_COMMENTS%>"
					required="true" maxlength="4000" cols="50" rows="5" /></td>
		</tr>

	</table>
	

</div>
