<%-- COPYRIGHT:		Copyright (C) 2015 McAfee, Inc.  All rights reserved--%>
<%@ page import="com.mcafee.scor.common.URLConstants"%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<orion:message key="scor.event.exclusion.wizardTitle"
               var="exclusionWizardTitle" escape="none" />
<orion:message key="scor.event.exclusion.selectOs" var="selectOsMsg"
               escape="html" />
<orion:message key="scor.event.exclusion.selectType" var="selectTypeMsg"
               escape="html" />

<orion:core>
    <orion:corehead />
    <orion:corebody>
        <orion:navigation helpId="${helpPageId}"/>
        <orion:content>
            <jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>" />
            <orion:script context="/core" src="/corebundle.js" />
            <orion:script context="/core" src="/core.js" />
            <orion:script context="/core" src="/majic.js" />
            <orion:script context="/core" src="/formlib.js" />
            <orion:script context="/core" src="/wizardlib.js" />

            <orion:vbox>
                <orion:box id="exclusionWizardDiv" height="24">
                    <orion:wizard id="exclusionWizard" currentStep="selectOs"
                                  wizardInfo="${exclusionWizardInfo}" text="${exclusionWizardTitle}"
                                  cancelURI="<%=URLConstants.NAVIGATE_TO_EVENTS_PAGE%>"
                                  editMode="false" />
                </orion:box>

                <orion:box id="exclusionSelectOsDiv">
                    <br>
                    <br>
                    <table>
                        <tr>
                            <td>${selectOsMsg}</td>
                            <td><orion:select id="exclusionFiltergroupPlatform"
                                              name="osType" items="${groupPlatformList}" /></td>
                        </tr>
                        <tr><td>${selectTypeMsg}</td><td><orion:select id="filtergroupType" name="groupType" items="${groupTypeList}" />
                        </td>
                        </tr>
                    </table>
                </orion:box>

                <orion:footerbar>
                    <orion:previous-next id="exclusionPrevNext" currentStep="selectOs"
                                         wizardInfo="${exclusionWizardInfo}" />
                </orion:footerbar>


            </orion:vbox>
        </orion:content>
    </orion:corebody>
</orion:core>
