<!-- Copyright (C) 2014 McAfee, Inc.  All rights reserved.  -->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://www.mcafee.com/orion/response" prefix="resp" %>

<orion:message key="scor.eventalerts.severity.critical" var="scorCritical" />
<orion:message key="scor.eventalerts.severity.warning" var="scorWarning" />
<orion:message key="scor.eventalerts.severity.info" var="scorInfo" />
<orion:message key="scor.SCOR_ALERTS.da.severity" var="scorSeverity" />
<orion:message key="scor.SCOR_ALERTS.da.alertMessage" var="scorMessage" />

<table>
	<tr>
		<td>${scorSeverity}:</td>
		<td>
			<select id="${orion:escapeHtml(instanceId)}_severity">
				<option value="1">${scorCritical}</option>
				<option value="2">${scorWarning}</option>
				<option value="3">${scorInfo}</option>
			</select>
		</td>
	</tr>
	<tr>
		<td>${scorMessage}:</td>
		<td><orion:textbox id="${instanceId}_message"/></td>
	</tr>
	<tr>
		<td></td>
		<td><resp:tokeninsert id="${instanceId}_tk" fieldId="${instanceId}_message"/></td>
<br/><br/>




<script type="text/javascript">
ComponentManager.registerComponent( ${orion:escapeJavaScriptString(instanceId)},
    {
        getData : function()
        {
            var data = {};
            var textbox = $("${orion:escapeJavaScriptString(instanceId)}_message");
			var select = $("${orion:escapeJavaScriptString(instanceId)}_severity");
            data["message"] = textbox.value;
            data["severity"] = select.value;

            return data;
        },

        setData : function( data )
        {
            var textbox = $("${orion:escapeJavaScriptString(instanceId)}_message");
            var select = $("${orion:escapeJavaScriptString(instanceId)}_severity");
            textbox.value = data["message"];
            select.value=data["severity"];
        }
    }
);
</script>