<!-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved-->

<%@page import="com.mcafee.scor.common.ScorReturnCodes"%>
<%@page import="com.mcafee.scor.common.ReturnCode"%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<%@ page import="com.mcafee.orion.core.OrionCore" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ page import="com.mcafee.scor.inventory.InventoryConstants"%>
<%@ page import="com.mcafee.scor.selfapproval.SelfApprovalConstants"%>
<%@ page import="com.mcafee.scor.common.Constants" %>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
<jsp:include page="/common/includejQuery.jsp" />
<orion:script context="/core" src="/majic.js"/>
<orion:script context="/core" src="/treelib.js"/>
<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="/jsFiles/commonUtil.js"/>


<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.INVENTORY_BY_APPLICATIONS_PAGE%>");
</script>

<orion:message key="scor.reporting.inventory.searchHeader.findBtnTxt" var="findBtnTxt" escape="none"/>
<orion:message key="scor.inv.savedsearch.defaultFilter" var="defaultFilter" escape="javascript"/>
<orion:message key="scor.inv.savedsearch.hiddenApps" var="hiddenFilter" escape="javascript"/>
<orion:message key="scor.inventory.select" var="selectDropdownOption"/>
<orion:message key="scor.inventory.savedsearches" var="savedSearchesText"/>
<orion:message key="scor.inventory.filter.advanced.filtered" var="advanceFilteredText" escape="none"/>
<orion:message key="scor.inventory.filter.advance.filter" var="aef"/>
<orion:message key="scor.inventory.filter.remove.advance.filter" var="removeAef"/>
<orion:message key="scor.reporting.inventory.appView.appTree.button.appDetails" var="appDetails" escape="none"/>
<orion:message key="scor.reporting.inventory.appView.appTree.menu.item.excludeApp" var="excludeApp" escape="none"/>
<orion:message key="scor.reporting.inventory.appView.appTree.menu.item.showApp" var="showApp" escape="none"/>
<orion:message key="scor.reporting.inventory.vendorView.appTree.menu.item.excludeVendor" var="excludeVendor" escape="none"/>
<orion:message key="scor.reporting.inventory.vendorView.appTree.menu.item.showVendor" var="showVendor" escape="none"/>
<orion:message key="scor.reporting.inventory.appView.appTree.menu.inventoryTree" var="inventoryTreeMenu" escape="none"/>
<orion:message key="scor.reporting.inventory.appView.appTree.vendor.none" var="unknownVendorString" escape="javascript"/>
<orion:message key="scor.inventory.appTree.button.collapseAll" var="collapseAll" escape="none"/>
<orion:message key="scor.inv.aef.duplicateaef" var="duplicateAef"/>
<orion:message key="scor.inv.aef.duplicateaef" var="duplicateAefText" escape="javascript"/>
<orion:message key="scor.inv.aef.editandupdateaef" var="editAef"/>
<orion:message key="scor.inv.aef.renamesavedfilter" var="renameAef"/>
<orion:message key="scor.inv.aef.renamesavedfilter" var="renameAefText" escape="javascript" />
<orion:message key="scor.inv.aef.deleteaef" var="deleteAef"/>
<orion:message key="scor.inv.aef.addsavedfilter" var="addSavedFilter"/>
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DUPLICATE.getDisplayKey()%>" var="cantDuplicateSavedSearch" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DELETE.getDisplayKey()%>" var="cantDeleteSavedSearch" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_RENAME.getDisplayKey()%>" var="cantRenameSavedSearch" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_DUPLICATE_NAME_EXISTS.getDisplayKey()%>" var="duplicateNameExists" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.SAVED_SEARCH_ERROR_ID_NOT_EXISTS.getDisplayKey()%>" var="nonExistentSearchSpecified" escape="javascript" />
<orion:message key="<%=ScorReturnCodes.INV_INVALID_CHARACTERS_IN_NAME.getDisplayKey()%>" var="unsupportedCharactersInName" escape="javascript" />
<orion:message key="scor.inv.aef.savedFilterName" var="savedFilterName" escape="html" />
<orion:message key="scor.inv.aef.emptySearchNameErrorMsg" var="emptySearchNameErrorMsg" escape="html" />
<orion:message key="scor.reputation.whatisfinalreputation.label" var="whatsfinalreputation" escape="html"/>

<script type="text/javascript">
var invSearchCriteria= "${orion:escapeJavaScript(requestScope.searchCriteria)}";
var allowBanActionTypeVar= "${orion:escapeHtml(requestScope.allowBanActionType)}";
</script>


<orion:vbox>
	    <orion:box height="60">
	        <table width="100%" height="100%" cellspacing="1px" cellpadding="1px" style="background-color: rgb(235, 235, 235); width: 100%;">
	             <tr style="vertical-align: middle;">	
				 	<td>
						<orion:select style="width: 110px;" id="searchOptionsId" items="${items}" onchange="onSearchCriteriaChange()"/>
						<orion:select id="reputationOptionId" items="${reputationSelectItems}"/>

                        <orion:textbox id="searchBoxId" maxlength="64" size="64"/> 
						<orion:button id="searchButtonId" text="${findBtnTxt}" disabled="false" onclick="searchInventoryClick()"/>
	                </td>		                
	                <td width="45%" align="right">
						${savedSearchesText}:
						<SELECT style="width: 300px;" name="invSavedSearchId" id="invSavedSearchId" onchange="goToSavedSearch()">
	                			<OPTION value="-1"> ${addSavedFilter} </OPTION>
	                			<OPTION value="-2" disabled> ------ </OPTION>
	                      <c:forEach var="savedSearch" items="${scorInvSavedSeraches}">
								<OPTION value="${savedSearch.searchId}"  <c:if test="${invSearchName eq savedSearch.searchName}"> selected </c:if> >
									${savedSearch.searchName} 
								</OPTION>
						  </c:forEach>
						</SELECT>
						&nbsp;
						<a href="#" id="dupSearchLinkId" onclick="askForDupSearchName()" >${duplicateAef}</a>
					<c:if test="${scorIsSavedSearchEditable == 'true'}">	
					 	| <a href="#" onclick="editSavedFilter()">${editAef}</a>
					 	| <a href="#" onclick="askForSearchName()">${renameAef}</a>
					 	| <a href="#" onclick="deleteSavedFilter()">${deleteAef}</a>
					</c:if>
					&nbsp;
					</td>
	  	        </tr>
                      <tr>
                        <td colspan="2" align="right" style="padding-right:0.5%">
                        	<a href="${orion:escapeHtml(whatsFinalReputationLink)}" target="_blank" >
                       			 ${whatsfinalreputation} 
                        	</a>
                        </td>
                      </tr>
	        </table>
	    </orion:box>    
        <orion:hbox id="invTableContainer">
            <c:if test="${showTree == 'true'}">
                <!--  Application Tree -->
				<orion:vbox id="appListContainer" width="${scorInventoryAppTreeWidth}">			
				<!--This is a workaround that was done to have compatibility with ePo5.10, also the styles were added since every div and orion:button has already a defined class-->
				    <div id="" class="layout_box_24_ orionTitleBar" style="overflow: hidden; flex-basis: 24px;">
                        <div id="" class="orionTitleBarText" title="Applications">
                        <orion:button id="collapseAllButton" onclick="collapseTree();" text="${collapseAll}" style="float: right;margin-right: 5px;"/>
                        <span>${requestScope.treeTitle}</span>
                        </div>
                    </div>
					<orion:tree id="${treeID}" treeDataAttr="${scorTreeDataProvider}" preloadData="false" selectable="true" showRootNode="${showRootNode}" persistBranchState="false"/>
					<orion:listbuttonarea>
                            <orion:menubutton id="inventoryTreeMenu" text="${inventoryTreeMenu}">
                            	
                                <orion:menubuttonitem id="appDetailMenuItemId" value="appDetail">${appDetails}</orion:menubuttonitem>
                                <c:choose>
                                	<c:when test="${isHiddenPropertySelectedInAdvFilters == 'false' }">
	                                	<orion:menubuttonitem id="showAppMenuItemId" value="showApp">${showApp}</orion:menubuttonitem>
	                                	<orion:menubuttonitem id="excludeAppMenuItemId" value="excludeApp">${excludeApp}</orion:menubuttonitem>    
	                                	<c:choose>
	            							<c:when test="${invViewType == 'invVendorView'}">	  
	            								<orion:menubuttonitem id="excludeVendorMenuItemId" value="excludeVendor">${excludeVendor}</orion:menubuttonitem>
	            								<orion:menubuttonitem id="showVendorMenuItemId" value="showVendor">${showVendor}</orion:menubuttonitem>     
	            							</c:when>
										</c:choose>    
									</c:when>
									<c:when test="${isHiddenPropertySelectedInAdvFilters == 'true' }">
										<c:choose>
										<c:when test="${enableShowAction == 'true' }">
	                                		<orion:menubuttonitem id="showAppMenuItemId" value="showApp">${showApp}</orion:menubuttonitem>
	                                		<c:choose>
	            							<c:when test="${invViewType == 'invVendorView'}">	  
	            								<orion:menubuttonitem id="showVendorMenuItemId" value="showVendor">${showVendor}</orion:menubuttonitem>     
	            							</c:when>
											</c:choose>
	                                	</c:when>
	                               		<c:when test="${enableShowAction == 'false' }"> 
	                                		<orion:menubuttonitem id="excludeAppMenuItemId" value="excludeApp">${excludeApp}</orion:menubuttonitem>   
	                                		<c:choose>
	                                		<c:when test="${invViewType == 'invVendorView'}">	  
	            								<orion:menubuttonitem id="excludeVendorMenuItemId" value="excludeVendor">${excludeVendor}</orion:menubuttonitem>	            								     
	            							</c:when>   
	            							</c:choose>         
										</c:when>
										</c:choose>
									</c:when>								
								</c:choose> 
							</orion:menubutton>
                    </orion:listbuttonarea>			     
				</orion:vbox>
				<orion:vdivider id="scorMonPolicydivider" resizeTarget="appListContainer"/>
            </c:if>
            
			<!-- Binary Table -->
            <c:choose>
	            <c:when test="${agentGuid == null}">
	            	<orion:vbox>			 
						<orion:table2 id="binaryTableId" titleText="${requestScope.tableTitle}" 
						cellRendererAttr="<%=InventoryConstants.INVENTORY_BINARY_CELL_RENDR_ATTR%>"  
						datasourceAttr="${requestScope.inventoryBinaryDS}"  showCheckboxColumn="true" enableDrilldown="false" 
						allowExport="true" allowConfiguration="true" allowAdvancedFilter="true" allowAction="true" 
						showFilters="true" allowFilter="true" sortOrder="0" sortColumn="binaryBaseName"
						properties="binaryBaseName,embedVersion,embedAppName,embedAppVersion,effectiveLevel,effectiveLevelReason,gtiTrustLevel,certSubject,firstSeenTime" registeredTypeUID="${requestScope.registeredTypeUID}"/>
					</orion:vbox>
	            </c:when>
	            <c:otherwise>
	            	<orion:vbox>			 
						<orion:table2 id="binaryTableId" titleText="${requestScope.tableTitle}" 
						cellRendererAttr="<%=InventoryConstants.INVENTORY_BINARY_CELL_RENDR_ATTR%>"  
						datasourceAttr="${requestScope.inventoryBinaryDS}"  showCheckboxColumn="true" enableDrilldown="false" 
						allowExport="true" allowConfiguration="true" allowAdvancedFilter="true" allowAction="true" 
						showFilters="true" allowFilter="true" sortOrder="0" sortColumn="binaryBaseName"
						properties="binaryBaseName,embedVersion,embedAppName,embedAppVersion,effectiveLevel,effectiveLevelReason,gtiTrustLevel,certSubject" registeredTypeUID="${requestScope.registeredTypeUID}"/>
					</orion:vbox>
	            </c:otherwise>
            </c:choose>
				
		</orion:hbox>
		
<div id="scor.inv.askforsearchname" style="display:none;">
<table width="100%" height="100%" cellspacing="1px" cellpadding="1px">
    <tr>
        <td>${savedFilterName}:</td>
        <td><orion:textbox id="scor.inv.savedsearch.name.ask" name="scor.inv.savedsearch.name.ask" required="true"/> </td>
	</tr>    
	<tr> 
		<td></td>
		<td id="searchNameErrorMsgId" name="searchNameErrorMsgId" style="display: none; color: red;">${emptySearchNameErrorMsg}
		</td>
	</tr>
</table>
</div>
		
		
</orion:vbox> 
<script type="text/javascript">


	function returnIfInvalidSearch(){
		var savedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
     
		if(savedSearchId < 0){
			return;
		}	
	}

     function navigateToInvPage(){
        var invPageSourceValue = "${inventoryPageSource}";
        var paramMap = ["invPageSource",invPageSourceValue];
        OrionCore.doAction("/SOLIDCORE_META/navigateToInv.do", paramMap, "GET","_self");
     }

function showDialogBox(message,title){
        OrionCore.showDialogBox(true, message, OrionCore.DIALOG_OK);
    	OrionCore.setDialogBoxTitle(title);
}

function validateNewSearchName () {
	var searchElem = scor.utils.GetElementFromDialogBox('scor.inv.savedsearch.name.ask', 'input');
	var isValid = OrionValidate.isNotEmpty(searchElem.value);
	var errorElem = $j('#searchNameErrorMsgId');
	var showError = !isValid;
	errorElem.toggle( showError );

	return isValid;
}

function duplicateFilter(){
      var searchElem = scor.utils.GetElementFromDialogBox('scor.inv.savedsearch.name.ask', 'input');
      var isValid = validateNewSearchName();
      if (isValid === false) {
		OrionEvent.registerHandler(searchElem,validateNewSearchName, null, "keyup", false);
	    return false;
      }

	  OrionEvent.unregisterHandler(searchElem,validateNewSearchName, null, "keyup", false); 
			  
      var invPageSourceValue = "${inventoryPageSource}";
      var searchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
      var searchElem = scor.utils.GetElementFromDialogBox('scor.inv.savedsearch.name.ask', 'input');
      var searchName = searchElem.value;
    
      var paramMap = ["invSavedSearchId", searchId,"invPageSource",invPageSourceValue,'invSearchName',searchName];
      
      scor.actions.doAsyncAction("/SOLIDCORE_META/duplicateSearch.do",paramMap, handleAfterDuplicate);
      
      OrionCore.showPleaseWait(true);	
}

function handleAfterDuplicate(duplicateSuccessfulId, ret, msg){
       OrionCore.showPleaseWait(false);
        
	   if(duplicateSuccessfulId === <%=ScorReturnCodes.SUCCESS.getCode()%>){
	   	navigateToInvPage(); 
	   }else if (duplicateSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DUPLICATE.getCode()%>){
		   showDialogBox('${cantDuplicateSavedSearch}','');
	   }else if(duplicateSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_DUPLICATE_NAME_EXISTS.getCode()%>){
		   showDialogBox('${duplicateNameExists}','');
	   }else if(duplicateSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_ID_NOT_EXISTS.getCode()%>){
		   showDialogBox('${nonExistentSearchSpecified}','');
	   }else if(duplicateSuccessfulId === <%=ScorReturnCodes.INV_INVALID_CHARACTERS_IN_NAME.getCode()%>){
		   showDialogBox('${unsupportedCharactersInName}','');
	   }
}

function editSavedFilter(){
	returnIfInvalidSearch();
	goToAef("true");
}

function askForSearchName(){
		returnIfInvalidSearch();
		
		OrionCore.dialogBoxOkHandler = renameSavedFilter;
		OrionCore.showDialogBox(true, $('scor.inv.askforsearchname').innerHTML);
		OrionCore.setDialogBoxTitle("${renameAefText}"); 
}

function askForDupSearchName(){
		returnIfInvalidSearch();
		
		OrionCore.dialogBoxOkHandler = duplicateFilter;
		OrionCore.showDialogBox(true, $('scor.inv.askforsearchname').innerHTML);
		OrionCore.setDialogBoxTitle("${duplicateAefText}"); 
}

function renameSavedFilter(){
      var searchElem = scor.utils.GetElementFromDialogBox('scor.inv.savedsearch.name.ask', 'input');
	  
	  var isValid = validateNewSearchName();
      if (isValid === false) {
		OrionEvent.registerHandler(searchElem,validateNewSearchName, null, "keyup", false);
	    return false;
      }

	  OrionEvent.unregisterHandler(searchElem,validateNewSearchName, null, "keyup", false); 

      var invPageSourceValue = "${inventoryPageSource}";
      var savedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
      var savedSearchName = searchElem.value;
    
      var paramMap = ["invSavedSearchId", savedSearchId,"invPageSource",invPageSourceValue,'invSearchName',savedSearchName];
      
      scor.actions.doAsyncAction("/SOLIDCORE_META/renameSavedSearch.do",paramMap, handleAfterRename);
      
      OrionCore.showPleaseWait(true);	
}

function handleAfterRename(renameSuccessfulId, ret, msg){
       OrionCore.showPleaseWait(false);
        
	   if(renameSuccessfulId === <%=ScorReturnCodes.SUCCESS.getCode()%>){
	   		 navigateToInvPage(); 
	   }else if (renameSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_RENAME.getCode()%>){
		   showDialogBox('${cantRenameSavedSearch}','');
	   }else if(renameSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_DUPLICATE_NAME_EXISTS.getCode()%>){
		   showDialogBox('${duplicateNameExists}','');
	   }else if(renameSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_ID_NOT_EXISTS.getCode()%>){
		   showDialogBox('${nonExistentSearchSpecified}','');
	   }else if(renameSuccessfulId === <%=ScorReturnCodes.INV_INVALID_CHARACTERS_IN_NAME.getCode()%>){
		   showDialogBox('${unsupportedCharactersInName}','');
	   }
}

function deleteSavedFilter(){
	  returnIfInvalidSearch();

      var invPageSourceValue = "${inventoryPageSource}";
      var savedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
    
      var paramMap = ["invSavedSearchId", savedSearchId,"invPageSource",invPageSourceValue];
      
      scor.actions.doAsyncAction("/SOLIDCORE_META/deleteInvAdvFilter.do",paramMap, handleAfterDelete);
      
      OrionCore.showPleaseWait(true);	
}

function handleAfterDelete(deleteSuccessfulId, ret, msg){
       OrionCore.showPleaseWait(false);
        
	   if(deleteSuccessfulId === <%=ScorReturnCodes.SUCCESS.getCode()%>){
	   		 navigateToInvPage(); 
	   }else if (deleteSuccessfulId === <%=ScorReturnCodes.SAVED_SEARCH_ERROR_IN_DELETE.getCode()%>){
		   showDialogBox('${cantDeleteSavedSearch}','');
	   }
}


 function onSearchCriteriaChange(){
	 var trustLevelOptionsElement = document.getElementById("reputationOptionId");
	 var searchBoxElement = document.getElementById("searchBoxId");
     var searchTypeOptions =  $("searchOptionsId");
 	 var searchOption = searchTypeOptions.options[searchTypeOptions.selectedIndex].value;
	 if(searchOption === 'ent_trust_level'){
		searchBoxElement.style.display = 'none';
		trustLevelOptionsElement.style.display = '';
	 }else {
		searchBoxElement.style.display = '';
		trustLevelOptionsElement.style.display = 'none';
	  }	
 }


 function goToAef(shouldEdit){
  	var selectedSavedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
 	var paramMap = ["invPageSource",  "${requestScope.inventoryPageSource}","shouldEdit",shouldEdit,"scorInvSavedSearchId",selectedSavedSearchId];
 	
 	OrionCore.doAction("/SOLIDCORE_META/showInvAdvFilterCriteria.do", paramMap, "GET","_self");
 }

 function goToSavedSearch(){
 	var selectedSavedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
 	

    if(selectedSavedSearchId === "-1"){
	  	goToAef("false");
 	 }
 	 
    if(selectedSavedSearchId === "-3"){
	  	 goToRemoveAef();
 	 } 	 
 	 
 	 if(selectedSavedSearchId > 0){ 	
 		var paramMap = ["invSavedSearchId", selectedSavedSearchId,"invPageSource", "${requestScope.inventoryPageSource}" ];
 		OrionCore.doAction("/SOLIDCORE_META/loadInvSavedSearch.do", paramMap, "GET","_self");
 	}
 }

function goToRemoveAef(){
  	var paramMap = ["invPageSource", "${requestScope.inventoryPageSource}"];
  	
  	scor.actions.doAsyncAction("/SOLIDCORE_META/removeInvAdvFilterCriteria.do",paramMap, navigateToInvPage);
}

function collapseTree(){
	var treeID = '${orion:escapeJavaScriptString(treeID)}';
	OrionTree.collapseAll(treeID);
	OrionCore.setEnabledById("collapseAllButton", false);
}
function _treeNodeExpanded(node, isExpanded){
	OrionCore.setEnabledById("collapseAllButton", true);
	if(isExpanded){
		var nodeEnabled = OrionTree.getNodeEnabled(node);
	}
}

function _treeNodeSelected(node) {	 
	 enableDisableAppDetailMenuItem(node);
	 enableDisableExcludeApplicationMenuItem(node);
	 enableDisableShowApplicationMenuItem(node);
	 if('${orion:escapeJavaScriptString(invViewType)}' === 'invVendorView'){
	 	enableDisableExcludeVendorMenuItem(node);
	 	enableDisableShowVendorMenuItem(node);
	 }
	
}
 
 enableDisableAppDetailMenuItem = function (node) {
	 MenuButton.setItemEnabled("appDetailMenuItemId", false);
	 var binaryTable=MFSTable.get("binaryTableId");
	 var nodeKey = OrionTree.getNodeKey(node);
	 var nodeKeyArray = nodeKey.split('<%=InventoryConstants.INV_APP_TREE_KEY_DELIMITER%>');
	 var treeID ='${orion:escapeJavaScriptString(treeID)}';
	 var nodePath = OrionTree.getNodePath(node);
	 var nodePathDelimiter = OrionTree.PATH_DELIMITER;
	 if(nodeKeyArray[0] === '<%=InventoryConstants.INV_APP_TREE_APP_ID_KEY%>') {
		 appId = nodeKeyArray[1];
		 if(!(isNaN(parseInt(appId)))){
			 MenuButton.setItemEnabled("appDetailMenuItemId", true);
		 }
		 scor.actions.doAsyncAction("/SOLIDCORE_META/setNodeInvAppTree.do",['scorSelectedTreeID',treeID,'scorSelectedNodePath',nodePath,'scorSelectedNodePathDelimiter',nodePathDelimiter],setNodeInvAppTree_Success,setNodeInvAppTree_Failure,"POST");
	 }else {
		 appId =  "<%=InventoryConstants.NOT_AN_APP_ID%>";
		 scor.actions.doAsyncAction("/SOLIDCORE_META/setNodeInvAppTree.do",['scorSelectedTreeID',treeID,'scorSelectedNodePath',"",'scorSelectedNodePathDelimiter',nodePathDelimiter],setNodeInvAppTree_Success,setNodeInvAppTree_Failure,"POST");
	 }	
	 binaryTable.setFilter(appId);
}

 function setNodeInvAppTree_Success(result){
 }
 
 function setNodeInvAppTree_Failure() {
 }

 function searchInventoryClick(){
     var searchBox = document.getElementById("searchBoxId");
     if (!scor.common.isValidText(searchBox.value)) {
         searchBox.value = "";
         searchBox.focus();
     } else {
	     searchInventory();
     }    
 }
 function searchInventory(){
        var searchString;
        var searchTypeOptions =  $("searchOptionsId");
        var searchCriteria =  searchTypeOptions.options[searchTypeOptions.selectedIndex].value;
        if(searchCriteria === 'ent_trust_level'){
            var trustLevelOptionsElement =  $("reputationOptionId");
			searchString = trustLevelOptionsElement.options[trustLevelOptionsElement.selectedIndex].value;
		}else {
            searchString = document.getElementById("searchBoxId").value;
		}     
        
	    var aray = new Array();
        aray[0] = '<%=InventoryConstants.SEARCH_CRITERIA%>';
        aray[1] = searchCriteria;
        aray[2] = '<%=InventoryConstants.SEARCH_STRING%>';
        aray[3] = searchString;        
		aray[4] = 'currentTab';
        aray[5] = '${requestScope.inventoryTab}';
        aray[6] = 'sectionId';
        aray[7] = 'scor.section.appcontrol';
        aray[8] = 'tabId';
        aray[9] = 'scor.tab.inventory';
     	aray[10] = '<%=InventoryConstants.AGENT_GUID%>';
        aray[11] = "${orion:escapeJavaScript(requestScope.agentGuid)}";
        aray[12] = '<%=InventoryConstants.REQUEST_ATTR_IS_SEARCH_ACTION%>';
        aray[13] = "true";
        aray[14] = '<%=SelfApprovalConstants.REQUEST_PARAM_SA_REQUEST_ID%>';
        aray[15] = '${saRequestId}';
        aray[16] = '<%=Constants.UID_ATTR%>'
        aray[17] = '${orion:escapeJavaScriptString(uid)}';
        var curUrl = location.href;            
        OrionCore.doFormAction(curUrl, aray, "GET");     
 }

 function triggerSearchInventry(event){
	  var characterCode = event.keyCode;
	  if(characterCode === 13){
		  searchInventory()
	  }  
 }



 fnShowAppDetail = function() {
	 var treeID = '${orion:escapeJavaScriptString(treeID)}';
	 var node = OrionTree.getSelectedNode(treeID);
	 var nodeKey = OrionTree.getNodeKey(node);
	 var nodeKeyArray = nodeKey.split(':');
	 if(nodeKeyArray[0] === '<%=InventoryConstants.INV_APP_TREE_APP_ID_KEY%>'){
		 appId = nodeKeyArray[1];
		 if (appId != '<%=InventoryConstants.INV_APP_TREE_OTHER_BINARIES_KEY%>') {
			 var paramMap = ["<%=InventoryConstants.INV_APP_TREE_APP_ID_KEY%>", appId];
			 OrionCore.doAction("/SOLIDCORE_META/showAppDetails.do", paramMap, "GET","_self");	 
		 }
	 }	
}

enableDisableExcludeApplicationMenuItem = function(node){
		if('${enableShowAction}' == '' || '${isHiddenPropertySelectedInAdvFilters}' == ''
			|| ('${enableShowAction}' !== 'false' && '${isHiddenPropertySelectedInAdvFilters}' === 'true')){
			 return;
		 }
		MenuButton.setItemEnabled("excludeAppMenuItemId", false);
	 	var nodePath = OrionTree.getNodePath(node);
	 	var nodePathElemArray = nodePath.split(OrionTree.PATH_DELIMITER);
	 	<%-- apps are available on and after array length 4 --%>
	
	 	if(nodePathElemArray.length >= 4){
		  <%-- Enable hide application option for all grouped and single applications on first level --%>
	 		MenuButton.setItemEnabled("excludeAppMenuItemId", true);
	 	}
}

enableDisableShowApplicationMenuItem = function(node){
		if('${enableShowAction}' == '' || '${isHiddenPropertySelectedInAdvFilters}' == ''
			|| ('${enableShowAction}' !== 'true' && '${isHiddenPropertySelectedInAdvFilters}' === 'true')){
			 return;
		 }
		MenuButton.setItemEnabled("showAppMenuItemId", false);
	 	var nodePath = OrionTree.getNodePath(node);
	 	var nodePathElemArray = nodePath.split(OrionTree.PATH_DELIMITER);
	 	<%-- apps are available on and after array length 4 --%>
	
 		if(nodePathElemArray.length >= 4){
	  	<%-- Enable show application option for all grouped and single applications on first level --%>
 			MenuButton.setItemEnabled("showAppMenuItemId", true);
 		}
}

handleOnReturnShowHide = function( successId, ret, msg ){
	
	if(successId === <%=ScorReturnCodes.SUCCESS.getCode()%>){
		var treeID = '${orion:escapeJavaScriptString(treeID)}';
		var selectedAppNode = OrionTree.getSelectedNode(treeID);
		OrionTree.setNodeEnabled(selectedAppNode, false);
		<%--Check and diasble show/hide menu items--%>
		fnCheckAndDisableMenuItemOnSuccess("appDetailMenuItemId");
		fnCheckAndDisableMenuItemOnSuccess("showAppMenuItemId");
		fnCheckAndDisableMenuItemOnSuccess("excludeAppMenuItemId");
		fnCheckAndDisableMenuItemOnSuccess("showVendorMenuItemId");
		fnCheckAndDisableMenuItemOnSuccess("excludeVendorMenuItemId");
	}
}

fnCheckAndDisableMenuItemOnSuccess = function(menuItemIdToBeDisabled){	
	if ($j('#'+menuItemIdToBeDisabled).size() != 0){
		MenuButton.setItemEnabled(menuItemIdToBeDisabled, false);
	}
}

fnShowExcludeApp = function(doHide){
	 var treeID = '${orion:escapeJavaScriptString(treeID)}';
	 var selectAppNodeObj = OrionTree.getSelectedNode(treeID);
	 appNode =  fnGetTextValueOfNode(selectAppNodeObj);
	 var nodePath = OrionTree.getNodePath(selectAppNodeObj);
	 var nodePathElemArray = nodePath.split(OrionTree.PATH_DELIMITER);
	 var isGroupedApp = false; 
	 var nodeDepth = nodePathElemArray.length;
		
	 if( nodeDepth >= 4 && nodePathElemArray[nodeDepth - 1].indexOf('<%=InventoryConstants.INV_APP_TREE_APP_ID_KEY%>') !== 0 ){
			isGroupedApp = true;	
		}
	 if($j.trim(appNode).length !== 0){	
		 if('${orion:escapeJavaScriptString(invViewType)}' === 'invVendorView'){
				 var vendorNodeKey = nodePathElemArray[1];
				 var vendorNodeObj = OrionTree.getNodeByKey('${treeID}', vendorNodeKey);			 
				 vendorNode =  fnGetTextValueOfNode(vendorNodeObj);					 
				 var paramMap = ["<%=InventoryConstants.INV_TREE_SELECTED_APP_NODE%>", $j.trim(appNode),
				        		 "<%=InventoryConstants.INV_IS_GROUPED_APP%>", isGroupedApp,
				        		 "<%=InventoryConstants.INV_IS_HIDE_ACTION%>", doHide,
				        		 "<%=InventoryConstants.INV_TREE_SELECTED_APP_VENDOR_NODE%>", $j.trim(vendorNode)
				        		];
				 scor.actions.doAsyncAction("/SOLIDCORE_META/showHideApplicationsFromVendorView.do", paramMap, handleOnReturnShowHide, "GET","_self");
		 }
		 else{
				 var paramMap = ["<%=InventoryConstants.INV_TREE_SELECTED_APP_NODE%>", $j.trim(appNode),
			        		 "<%=InventoryConstants.INV_IS_GROUPED_APP%>", isGroupedApp,
			        		 "<%=InventoryConstants.INV_IS_HIDE_ACTION%>", doHide
			        		];
				 scor.actions.doAsyncAction("/SOLIDCORE_META/showHideApplications.do", paramMap, handleOnReturnShowHide, "GET","_self");
		 }
		}	
}

fnShowExcludeVendor = function(doHide){
	 var treeID = '${orion:escapeJavaScriptString(treeID)}';
	 var selectAppNodeObj = OrionTree.getSelectedNode(treeID);
	 var nodePath = OrionTree.getNodePath(selectAppNodeObj);
	 var nodePathElemArray = nodePath.split(OrionTree.PATH_DELIMITER);
	 var vendorNodeKey = nodePathElemArray[1];
	 var vendorNodeObj = OrionTree.getNodeByKey('${orion:escapeJavaScriptString(treeID)}', vendorNodeKey);			 
	 vendorNode =  fnGetTextValueOfNode(vendorNodeObj);					 
	 var paramMap = ["<%=InventoryConstants.INV_TREE_SELECTED_APP_VENDOR_NODE%>", $j.trim(vendorNode),
	        		 "<%=InventoryConstants.INV_IS_HIDE_ACTION%>", doHide
	        		];
	 scor.actions.doAsyncAction("/SOLIDCORE_META/showHideVendorFromVendorView.do", paramMap, handleOnReturnShowHide, "GET","_self");
		
}

enableDisableExcludeVendorMenuItem = function(node){
	if('${enableShowAction}' == '' || '${isHiddenPropertySelectedInAdvFilters}' == ''
		|| ('${enableShowAction}' !== 'false' && '${isHiddenPropertySelectedInAdvFilters}' === 'true')){
		 return;
	 }
	 MenuButton.setItemEnabled("excludeVendorMenuItemId", false);
	 var nodePath = OrionTree.getNodePath(node);
	 var nodePathElemArray = nodePath.split(OrionTree.PATH_DELIMITER);
	 if(nodePathElemArray.length === 2){
		 MenuButton.setItemEnabled("excludeVendorMenuItemId", true);
	 }	 
}

enableDisableShowVendorMenuItem = function(node){
	if('${enableShowAction}' == '' || '${isHiddenPropertySelectedInAdvFilters}' == ''
		|| ('${enableShowAction}' !== 'true' && '${isHiddenPropertySelectedInAdvFilters}' === 'true')){
		 return;
	 }
	 MenuButton.setItemEnabled("showVendorMenuItemId", false);
	 var nodePath = OrionTree.getNodePath(node);
	 var nodePathElemArray = nodePath.split(OrionTree.PATH_DELIMITER);
	 if(nodePathElemArray.length === 2 ){
		 MenuButton.setItemEnabled("showVendorMenuItemId", true);
	 }	 
}

fnGetTextValueOfNode = function(nodeObj){
	if(!nodeObj){
		return;
	}
	 var node = OrionTree.getNodeLabel(nodeObj);
	 var strNodeInHtml = "<div id=\"myDiv\">"+node+"</div>";	 
	 return  $j(strNodeInHtml).text();
}


 inventorytreeMenuHandler = function(buttonID, itemID, itemValue)
 {
	 var doHide = true;
	 switch (itemValue)
     {
         case "appDetail":
        	 fnShowAppDetail();
             break;
         case "excludeApp":
             fnShowExcludeApp(doHide);
             break;   
         case "excludeVendor":
        	 fnShowExcludeVendor(doHide);
             break; 
         case "showApp":
        	 doHide = false
        	 fnShowExcludeApp(doHide);
             break;
         case "showVendor":
        	 doHide = false;
        	 fnShowExcludeVendor(doHide);
        	 break;           
     }
 }
 
 function checkAndHideDupSearhLink () {
	var selectedSearchId = document.getElementById('invSavedSearchId').options[document.getElementById('invSavedSearchId').selectedIndex].value;
     
	if(selectedSearchId < 0) {
		document.getElementById('dupSearchLinkId').style.display = 'none';
	}
 }

 
   enableDisableShowHideBinariesAction = function(){
 	    var showBinariesActionIndex = getActionIndexByURLInActionTab("showBinaries.do");
 	    var hideBinariesActionIndex = getActionIndexByURLInActionTab("hideBinaries.do");
 	    if('${enableShowAction}' === 'true' && '${isHiddenPropertySelectedInAdvFilters}' === 'true'){
 	    	OrionAction.actionList.splice(hideBinariesActionIndex, 1);
 	    }else if('${enableShowAction}' === 'false' && '${isHiddenPropertySelectedInAdvFilters}' === 'true'){
 	   		OrionAction.actionList.splice(showBinariesActionIndex, 1);
 	    }
 	   }
 	   
 	function getActionIndexByURLInActionTab(url) {
 	    var scorInvTableActionIndex = -1;
 		for(var j in OrionAction.actionList){
 	        if(OrionAction.actionList[j].actionURI.indexOf(url) != -1){
 	        	scorInvTableActionIndex = j;
 	        	break;
 	        }
 	    }
 	    return scorInvTableActionIndex;
 	}
 
 function _initApp(){
	 	if ($("inventoryTreeMenu"))
	    {
	        MenuButton.addSelectListener("inventoryTreeMenu", inventorytreeMenuHandler);
	    }
    	var trustLevelOptionsElement = document.getElementById("reputationOptionId");
	    var searchBoxElement = document.getElementById("searchBoxId");
		if(invSearchCriteria === 'ent_trust_level'){
			trustLevelOptionsElement.value = "${orion:escapeJavaScript(searchString)}";
            searchBoxElement.style.display = 'none';
		}else {
            trustLevelOptionsElement.style.display = 'none';
			searchBoxElement.value = "${orion:escapeJavaScript(searchString)}";
		}
		document.getElementById('searchOptionsId').value = invSearchCriteria;
    	<c:if test="${showTree == 'true'}">
    			OrionTree.setSelectHandler(_treeNodeSelected);	 
    			OrionTree.setExpColHandler(_treeNodeExpanded);
    			var selectedNodePath = '${scorSelectedNodePath}';
    			var computedNodePath = '${scorComputedNodePath}';
    			var orionNodePathDelimiter = OrionTree.PATH_DELIMITER;
    			if(computedNodePath !== null && computedNodePath !== '' ){
    				computedNodePath = computedNodePath.replace( /\|/g,orionNodePathDelimiter);	
    				selectedNodePath = computedNodePath;
    			}
    			var prevSelectedTreeID ='${scorSelectedTreeID}';
 			    var currentTreeID = '${orion:escapeJavaScriptString(treeID)}';
 			  	var defaultNodePath = '${scorDefaultNodePath}';
 			  	defaultNodePath = defaultNodePath.replace( /\|/g,orionNodePathDelimiter);	
 			   	if(prevSelectedTreeID !== '' && prevSelectedTreeID === currentTreeID && selectedNodePath !== '' ){
 			   			var nodePath = selectedNodePath;
			    }else{
			    	    var nodePath = defaultNodePath;
			    	    var viewType = '${orion:escapeJavaScriptString(invViewType)}';
			    	    if(viewType == 'invVendorView'){
			    	    	OrionCore.setEnabledById("collapseAllButton", false);
			    	    }
			    }
 				OrionTree.expandToPath(currentTreeID,nodePath,true); 	 			
		</c:if>
		
		searchTextBoxInputField =document.getElementById("searchBoxId");
		OrionForm.markInputExempt("searchBoxId");
		OrionForm.markInputExempt("searchOptionsId");
		OrionForm.markInputExempt("reputationOptionId");
		OrionEvent.registerHandler(searchTextBoxInputField,triggerSearchInventry, null, "keyup", false);
		enableDisableShowHideBinariesAction();
		checkAndHideDupSearhLink ();
  }	 
  OrionCore.addLoadHandler(_initApp);
</script>










