//Copyright (C) 2015-2018 McAfee, Inc. All rights reserved.
var scor = scor || {};
scor.common = scor.common || {};
scor.common.getShortenedString = function (valString, maxLength) {
	
    if(valString != null && valString.length > maxLength){
    	maxLength = maxLength/2;
    	var part1Length = Math.floor((maxLength - 3) / 2);
    	var part2Length = (maxLength - part1Length) - 3;
    	var part2StartIndex = (valString.length - part2Length) - 1;
    	var part1 = valString.substring( 0, part1Length );
    	var part2 = valString.substring( part2StartIndex, valString.length);
   
    	var returnString = part1.concat("...");
    	var compressedString = returnString.concat(part2);
    	return compressedString;
    }
    
    return valString;
};

scor.common.registerPanelAt = function( panelId, valueDivId, title, panelWidth){
		panelWidth = panelWidth || "320px";
	
		var newPanel = new YAHOO.widget.Panel( panelId, { width:panelWidth, draggable:false, visible:false, close:false } );
		newPanel.render(); 
		YAHOO.util.Event.addListener(valueDivId, "click", newPanel.show, newPanel, true);
		YAHOO.util.Event.addListener(panelId, "mouseleave", newPanel.hide, newPanel, true);
		title = title;
		$j("#"+valueDivId).attr("title",title);
		
};

scor.common.changeInputId = function(origenId, dialogId) {
    var dialogBox = (OrionCore.isDialogBoxVisible()) ? OrionCore.getDialogBoxContainer() : dialogId;
    var listInput = $j(dialogBox).find('input[type=radio]');
    var listLabel = $j(dialogBox).find('label');
    for (var i = 0; i < listInput.length; i++) {	
	    listInput[i].id = (listInput[i].checked) ? origenId : origenId + "Generic" + i;
	    listLabel[i].htmlFor = listInput[i].id;
    }
}
 
scor.common.isValidText = function(searchString) {
    var searchStringHtml = OrionCore.escapeHtml(searchString);
    return (searchStringHtml == searchString);
}
