var scor;
scor = scor || {};
scor.fd = scor.fd || {};
scor.fd.fileContentTableRow = scor.fd.fileContentTableRow || {};
scor.fd.fileContentTableRow.top = scor.fd.fileContentTableRow.top || 0;
scor.fd.fileContentTableRow.index = scor.fd.fileContentTableRow.index ||0;

scor.fd.addStyling = function(tableId){
    	$j("#"+tableId+" tr").each(function(){
    		 	$j(this).find('td').each(function(){
        			var cellHTML = $j(this).html();
					if(cellHTML !== null){
						var arr = cellHTML.split(":::");	
						if(!arr || arr.length === 1){
							var formattedStr= scor.fd.boldHeaderOftext(cellHTML);
							$j(this).html(formattedStr);
						}else{
							for(var arrIndex = 0; arrIndex < arr.length ; arrIndex++){	
								if(!arr[arrIndex]){
									continue;
								}
								arr[arrIndex] = scor.fd.boldHeaderOftext(arr[arrIndex]);
								if(arrIndex !== 0){
									arr[arrIndex] = "&nbsp;&nbsp;&nbsp;&nbsp;"+arr[arrIndex];
								}
							}
							var arrStr = arr.join("<br>");
							$j(this).html(arrStr);
						}					
					}
				})
        	})
        };
        

scor.fd.boldHeaderOftext = function(cellHTML){
	if(!cellHTML){
		return;
	}
	var colonIndex = cellHTML.indexOf(":", 0);
	var textToBold = cellHTML.substring(0, colonIndex+1);
	var textNotToBold = cellHTML.substring(colonIndex+1);
	return "<b>"+ textToBold + "</b>" + textNotToBold;   				
}
        
scor.fd.getDiff = function(baseText, newText, contextSize) {
            var base = difflib.stringAsLines(baseText);
            var newtxt = difflib.stringAsLines(newText);
            var sm = new difflib.SequenceMatcher(base, newtxt);
            var opcodes = sm.get_opcodes();
            var het = diffview.buildView({ baseTextLines:base,
                newTextLines:newtxt,
                opcodes:opcodes,
                baseTextName:"Base Text",
                newTextName:"New Text",
                contextSize:contextSize,
                viewType: 0 });
            return het;
        }  ;

scor.fd.getDiff.innerHtml = function(baseText, newText, contextSize) {
            return scor.fd.getDiff(baseText, newText, contextSize).innerHTML;
        }  ;


scor.fd.removeNumbering = function(tableId){
	$j("#"+tableId+" tr").each(
	    	function(){
				$j(this).find('th:eq(0)').hide();
    	    	$j(this).find('th:eq(1)').hide();
    	    	}
	    	)
	}	; 


scor.fd.addAlternatColouring = function(){
		$j('#attributeDiffTable tr:even').addClass("orionTableRow");  
		$j('#attributeDiffTable tr:odd').addClass("orionTableRowAlt");     		
	};
	
	
	scor.fd.iterateTable =function(container, element){
		scor.fd.fileContentTableRow.top = $j("#"+$j(container).attr('id')).scrollTop();
		$j("#"+$j(element).attr('id')+" tr td").each(			
				function(){
					if($j(this).hasClass("replace") || $j(this).hasClass("delete") || $j(this).hasClass("insert") || $j(this).hasClass("empty")){	
						//alert($j(this).parent().index());
						if($j(this).parent().position().top <= scor.fd.fileContentTableRow.top){
							return true;
						}
						scor.fd.fileContentTableRow.top = $j(this).parent().position().top;
						scor.fd.fileContentTableRow.index = $j(this).parent().index();
						$j("#"+$j(container).attr('id')).scrollTop(scor.fd.fileContentTableRow.top);
						return false;
					}							
			})		
	}

	scor.fd.iterateTable.reverse =function(container, element){
		scor.fd.fileContentTableRow.top = $j("#"+$j(container).attr('id')).scrollTop();
		$j($j("#"+$j(element).attr('id')+" tr td").get().reverse()).each(			
				function(){
					if($j(this).hasClass("replace") || $j(this).hasClass("delete") || $j(this).hasClass("insert") || $j(this).hasClass("empty")){	
						//alert($j(this).parent().index());
						if($j(this).parent().position().top >= scor.fd.fileContentTableRow.top){
							return true;
						}
						scor.fd.fileContentTableRow.top = $j(this).parent().position().top;
						scor.fd.fileContentTableRow.index = $j(this).parent().index();
						$j("#"+$j(container).attr('id')).scrollTop(scor.fd.fileContentTableRow.top);
						return false;
					}							
			})			
	}
