// Copyright (C) 2014 McAfee, Inc.  All rights reserved. 

var scor;
scor = scor || {};
scor.vos = scor.vos || {};
scor.vos.awl = scor.vos.awl || {};

scor.vos.awl.ApplicationUnitVO = function(appName,binaryName, version, vendor, checksum, makeBy) {
    var vo = {
        "appName":appName,
        "binaryName":binaryName,
        "version":version,
        "vendor":vendor,
        "checksum":checksum,
        "makeBy":makeBy
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);

    return {
        "common": commonFunc
    };
};

scor.vos.awl.UpdaterUnitVO = function(binaryPath,tag,typeValue,libraryParent,inherit,log) {
    var vo = {
        "binaryPath":binaryPath,
        "tag":tag,
        "typeValue":typeValue,
        "libraryParent":libraryParent,
        "inherit":inherit,
        "log":log
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);

    return {
        "common": commonFunc
    };
};

scor.vos.awl.AWLPolicyVO = function(
		id,groupName, platform, readOnly, type,updaters,
		trustedGroups,trustedUsers,apps,
		trustedDirectories,publishers,binaries, attributes, advanced, invFilters, execControlVOs){
              
    var vo = {
        id:id,
        groupName:groupName,
        platform:platform,
        readOnly:readOnly,
        type:type,
        updaters:updaters,
        trustedGroups:trustedGroups,
        trustedUsers:trustedUsers,
        apps:apps,
        trustedDirectories:trustedDirectories,
        publishers:publishers,
        binaries:binaries,
        attributes: attributes,
        advanced: advanced,
        invFilters: invFilters,
        execControlVOs: execControlVOs
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);
    return {
        common: commonFunc
    };
};
