<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%--
  COPYRIGHT: Copyright (C) 2015 McAfee, Inc. All rights reserved.
  --%>
<jsp:include page="/common/includejQuery.jsp"/>
<orion:message var="globalUpdaterWarning" key="scor.selfapproval.publisher.updaterWarnMsg" escape="javascript"/>
<orion:message var="globalCertWarning" key="scor.selfapproval.publisher.addByPublisherWarnMsg" escape="javascript"/>
<orion:message var="restrictedPublisherMessage" key="scor.selfapproval.publisher.restrictedPublisherMsg" escape="javascript"/>
<orion:message key="scor.selfapproval.cert.all.catalog" var="allCatalogCertJS" escape="javascript"/>

<style type="text/css">
	.error{
		color:red;		
	}	
</style>

<table>
    <tr>
        <td id="addByPublisherSAMessageContainer"></td>
    </tr>
</table>


<script type="text/javascript">
   var scor;
	scor = scor || {};
	scor.saAddByPub = scor.saAddByPub || {};
    
    scor.saAddByPub.setWarningMessage = function(){
    	var isAllowByPublisher = '${scorSAIsAllowByPublisher}';
    	var isPublisherAsUpdater = '${isPublisherAddedAsUpdater}';
    	var message ='${globalCertWarning}';
    	if('${scorSaAllCatalogCertsFound}'){
    		$j("#addByPublisherSAMessageContainer").html('${allCatalogCertJS}');
    		$j("#addByPublisherSAMessageContainer").append('&nbsp;<a href=\"https://kc.mcafee.com/corporate/index?page=content&id=KB85696\" target=\"_blank\">KB85696</a> ');
    		$j("#addByPublisherSAMessageContainer").addClass("error");
    		OrionCore.enableDialogBoxOkButton(false);
    		return;
    	}
    	if(isAllowByPublisher === 'false'){
    	  message = '${restrictedPublisherMessage}';
    	  $j("#addByPublisherSAMessageContainer").html(message);
    	  return;
    	}
    	if(isPublisherAsUpdater === 'true'){
    		message = '${globalUpdaterWarning}';
    	}
    	$j("#addByPublisherSAMessageContainer").html(message);
    	OrionCore.enableDialogBoxOkButton(true);
    }
    scor.saAddByPub.setWarningMessage();
    
    
</script>
