<!-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved-->
<%@page import="com.mcafee.scor.policy.PolicyConstants"%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor"%>
<%@ page import="com.mcafee.scor.common.URLConstants"%>
<%@ page import="com.mcafee.scor.common.Constants"%>
<%@ page import="com.mcafee.scor.rulegroup.RuleGroupConstants"%>
<%@ page import="com.mcafee.scor.common.HelpConstants"%>
<%@ page import="com.mcafee.scor.config.ScorConfig"%>

<c:choose>
	<c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
		<%-- No subpage Rule Group Help required --%>
	</c:when>
	<c:when test="${changeHelpPageWithTabs == 'false'}">
		<%-- No subpage Rule Group Help required --%>
	</c:when>
	<c:otherwise>
		<c:if test="${param.osType == 'WIN'}">
			<script type="text/javascript">
		OrionHelp.setHelpId("<%=HelpConstants.GENERAL_POLICY_EXCEPTION_RULES_WINDOWS%>");
	</script>
		</c:if>
		<c:if test="${param.osType == 'UNIX'}">
			<script type="text/javascript">
		OrionHelp.setHelpId("<%=HelpConstants.GENERAL_POLICY_EXCEPTION_RULES_UNIX%>");
	</script>
		</c:if>
	</c:otherwise>
</c:choose>

<orion:script context="/core" src="/majic.js" />
<orion:style context="/SOLIDCORE_META" url="/css/override.css" />
<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>" />

<orion:message key="scor.attr.fileHeader" var="fileHeader" escape="HTML"/>
<orion:message key="scor.attr.optionHeader" var="optionHeader" escape="HTML"/>
<orion:message key="scor.attr.parentHeader" var="parentHeader" escape="HTML"/>
<orion:message key="scor.attr.moduleHeader" var="moduleHeader" escape="HTML"/>

<orion:message key="scor.attr.file.label" var="fileLbl" escape="javascript"/>
<orion:message key="scor.attr.duplicate.label" var="duplicateLabel" escape="HTML"/>

<orion:message key="scor.attr.option.label" var="optionLbl" escape="HTML"/>
<orion:message key="scor.attr.parent.label" var="parentLbl" escape="javascript"/>
<orion:message key="scor.attr.module.label" var="moduleLbl" escape="javascript"/>

<orion:message key="scor.attr.exclusion.parentProcessLabel" var="processLabel" escape="javascript" />
<orion:message key="scor.attr.exclusion.pathLabel" var="pathLabel" escape="javascript" />
<orion:message key="scor.attr.exclusion.solidificationPathLabel" var="solidificationPathLabel" escape="javascript" />
<orion:message key="scor.attr.exclusion.volumeLabel" var="volumeLabel" escape="javascript" />
<orion:message key="scor.attr.exclusion.mp.label" var="memoryProtectionLabel" escape="HTML" />
<orion:message key="scor.attr.exclusion.registryLabel" var="registryLabel" escape="javascript" />

<orion:message key="scor.attr.exclusion.id.label" var="idExclusionsLabel" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.label" var="customExclusionLabel" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.moniterFileOpt" var="moniterFileOpt" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.excludeFileOpt" var="excludeFileOpt" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.excludeFileOpt_F" var="excludeFileOpt_F" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.enforceWriteOpt" var="enforceWriteOpt" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.whitelistOpt" var="whitelistOpt" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.excludeVolOpt" var="excludeVolOpt" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.registryTracking" var="registryTracking" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.changeTracking" var="changeTracking" escape="HTML" />

<orion:message key="scor.attr.exclusion.ce.moniterFileOptDesc" var="moniterFileOptDesc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.excludeFileOpt_F_Desc" var="excludeFileOpt_F_Desc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.excludeFileOptDesc" var="excludeFileOptDesc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.enforceWriteOptDesc" var="enforceWriteOptDesc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.whitelistOptDesc" var="whitelistOptDesc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.excludeVolOptDesc" var="excludeVolOptDesc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.registryTrackingDesc" var="registryTrackingDesc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.changeTrackingDesc" var="changeTrackingDesc" escape="HTML" />

<orion:message key="scor.attr.mangBypass" var="mangBypass" escape="HTML" />
<orion:message key="scor.attr.caspBypass" var="caspBypassHtml" escape="HTML" />
<orion:message key="scor.attr.vasrRandBypass" var="vasrRandBypass" escape="HTML" />
<orion:message key="scor.attr.rbsDll" var="rbsDll" escape="HTML" />
<orion:message key="scor.attr.fulCrwl" var="fulCrwl" escape="HTML" />
<orion:message key="scor.attr.procCtxRegBypass" var="procCtxRegBypass" escape="HTML" />
<orion:message key="scor.attr.instBypass" var="instBypass" escape="HTML" />
<orion:message key="scor.attr.uninstallBypass" var="uninstallBypassLabel" escape="HTML" />
<orion:message key="scor.attr.vasrRelocateDllStrVar" var="vasrRelocateDllStrVar" escape="HTML" />
<orion:message key="scor.attr.uninstallBypass" var="uninstallBypassMessageParam" escape="none" />
<orion:message key="scor.attr.antiDbgBypass" var="antiDbgBypass" escape="HTML" />
<orion:message key="scor.attr.procCtxBypass" var="procCtxBypass" escape="HTML" />
<orion:message key="scor.attr.callCtxBypass" var="callCtxBypass" escape="HTML" />
<orion:message key="scor.attr.aslrBypass" var="aslrBypass" escape="HTML" />
<orion:message key="scor.attr.depBypass" var="depBypassHTML" escape="HTML" />
<orion:message key="scor.attr.depBypass.inherit" var="depBypassInheritHTML" escape="javascript" />
<orion:message key="scor.attr.vasrRelBypass" var="vasrRelBypass" escape="HTML" />
<orion:message key="scor.attr.alwsAuth" var="alwsAuth" escape="HTML" />
<orion:message key="scor.attr.alwsUnauth" var="alwsUnauth" escape="HTML" />
<orion:message key="scor.attr.mp.label" var="memProtectionLbl" escape="HTML" />
<orion:message key="scor.attr.mpdeprecated.label" var="memProtectionDeprecatedLbl" escape="HTML" />
<orion:message key="scor.attr.others.label" var="othersLabel" escape="HTML" />
<orion:message key="scor.attr.others.instBypassDesc" var="instBypassDesc" escape="HTML" />
<orion:message key="scor.attr.exclusion.ce.customExclusionLabelDesc" var="customExclusionLabelDesc" escape="HTML" />
<orion:message key="scor.attr.summary.dialogBoxPart1" var="dialogBoxSummary1" escape="HTML" />
<orion:message key="scor.attr.summary.dialogBoxPart2" var="dialogBoxSummary2" escape="HTML" />
<orion:message key="scor.attr.vasrRelBypass.title" var="vasrRelBypassTitle" escape="HTML" />
<orion:message key="scor.attr.aslrBypass.title" var="aslrBypassTitle" escape="HTML" />
<orion:message key="scor.attr.vasrRandBypass.title" var="vasrRandBypassTitle" escape="HTML" />

<orion:message key="scor.attr.add.title" var="addTitle" escape="javascript" />
<orion:message key="scor.attr.edit.title" var="editTitle" escape="javascript" />
<orion:message key="scor.attr.add.btnTxt" var="addBtnTxt" escape="javascript" />
<orion:message key="scor.attr.edit.btnTxt" var="editBtnTxt" escape="javascript" />
<orion:message key="scor.attr.remove.btnTxt" var="remBtnTxt" escape="javascript" />
<orion:message key="scor.policy.awl.button.diagSuggest" var="awlButtonDiagSuggest" escape="javascript" />
<orion:message key="scor.attr.empty.fileName" var="emptyFile" escape="javascript" />
<orion:message key="scor.attr.empty.fileNameMsgs" var="emptyFileMsgs" escape="javascript" />
<orion:message key="scor.attr.empty.parentName" var="parentMandatory" escape="javascript" params="${uninstallBypassMessageParam}" />
<orion:message key="scor.attr.InstallerOption.deprecatedWarning" var="installerDeprecatedWarning" escape="javascript" />

<orion:message key="scor.policy.awl.updater.diag.findLabel" var="findLbl" escape="HTML" />
<orion:message key="scor.policy.awl.updater.diag.findBtnTxt" var="findBtnTxt" escape="HTML" />
<orion:message key="scor.policy.awl.updater.diag.System" var="diagSystem" escape="javascript" />
<orion:message key="scor.policy.awl.updater.diag.Binary" var="diagBinary" escape="javascript" />
<orion:message key="scor.policy.awl.attr.diag.ManglingBypass" var="diagManglingBypass" escape="javascript" />
<orion:message key="scor.policy.awl.attr.diag.CaspBypass" var="diagCaspBypass" escape="javascript" />
<orion:message key="scor.policy.awl.attr.diag.DepBypass" var="diagDepBypass" escape="javascript" />
<orion:message key="scor.policy.exclusion.kbLink" var="kbLink" escape="HTML" /> 
<orion:message key="scor.policy.exclusion.kbLinkText" var="kbLinkText" escape="HTML" />
<orion:message key="scor.awl.attributes.no.editPermission.msg" var="noEditPermissionMsg" escape="HTML"/>
<orion:message key="scor.commandResponse.msg.failed" var="msgFailed" escape="javascript" />

	
<c:set var="WIN_OS" scope="request" value="<%=RuleGroupConstants.RULE_GROUP_OS.WIN.getValue()%>" />
<c:set var="UNIX_OS" scope="request" value="<%=RuleGroupConstants.RULE_GROUP_OS.UNIX.getValue()%>" />
<c:set var="SKIPLIST_TYPE" value="<%=PolicyConstants.SKIPLIST_TYPE%>" />
<c:set var="ATTR_TYPE" value="<%=PolicyConstants.ATTR_TYPE%>" />
<c:set var="scorShowAdvancedExclusionOptions" scope="request" value="<%=ScorConfig.showAdvancedSkipListOptions.get()%>"/>

<scor:auth
	authClassName="com.mcafee.scor.common.ScorPermissionValidationHelper"
	authMethodName="isUserAllowedToEditRuleGroupExceptionRules"
	authToken="isAuthorizedToEditExceptionRules" />
<scor:auth
	authClassName="com.mcafee.scor.common.ScorPermissionValidationHelper"
	authMethodName="isUserAllowedToViewRuleGroupExceptionRules"
	authToken="isAuthorizedToViewExceptionRules" />
 <script type="text/javascript">
	var scor = scor || {};
	scor.awl = scor.awl || {};
	scor.rule= scor.rule || {};
	scor.rule.exclusion=scor.rule.exclusion || {};

  scor.rule.exclusion.AllInputFields = {
	    "filePathAttributes": {"fieldType":"textbox","fieldLabel": "${fileLbl}","fieldName": "filePath","required":"true","txtBoxWidth":"15%"},
	    "dllAttributes": {"fieldType":"textbox","fieldLabel": "${moduleLbl}", "fieldName": "modulePath","required":"true","txtBoxWidth":"15%"},
	    "parentAttributes": {"fieldType":"textbox","fieldLabel": "${parentLbl}","fieldName": "parentPath","required":"true","txtBoxWidth":"17%"},
	    "depBypassAttributes": {"fieldType":"checkbox","fieldLabel":"${depBypassInheritHTML}","fieldName":"dep_bypass_inherit","required":"true","txtBoxWidth":"22%"},
	    "attrForFileSkipList":{"fieldType":"textbox","fieldLabel": "${fileLbl}","fieldName": "filePath","required":"true","txtBoxWidth":"18%"},
	    "attrForprocessNameSkipList": {"fieldType":"textbox","fieldLabel": "${processLabel}","fieldName": "parentPath","required":"false","txtBoxWidth":"18%"},
	    "attrForFileOptSkipList": {"fieldType":"textbox","fieldLabel":"${pathLabel}","fieldName":"filePath","required":"true","txtBoxWidth":"18%"},
	    "attrForFileOpt_F_SkipList": {"fieldType":"textbox","fieldLabel":"${pathLabel}","fieldName":"filePath","required":"true","txtBoxWidth":"18%"},
	    "attrForDenyOptSkipList": {"fieldType":"textbox","fieldLabel":"${pathLabel}","fieldName":"filePath","required":"true","txtBoxWidth":"18%"},
	    "attrForSolidSkipList": {"fieldType":"textbox","fieldLabel":"${solidificationPathLabel}","fieldName":"filePath","required":"true","txtBoxWidth":"18%"},
	    "attrForvolumeSkipList": {"fieldType":"textbox","fieldLabel":"${volumeLabel}","fieldName":"filePath","required":"true","txtBoxWidth":"18%"},
	    "attrForregistrySkipList": {"fieldType":"textbox","fieldLabel":"${registryLabel}","fieldName":"filePath","required":"true","txtBoxWidth":"18%"},
	    "attrForchngeTrckSkipList": {"fieldType":"textbox","fieldLabel":"${pathLabel}","fieldName":"filePath","required":"true","txtBoxWidth":"18%"},
	    "filePathAttributesForUninstall":{"fieldType":"textbox","fieldLabel": "${fileLbl}","fieldName": "filePath","txtBoxWidth":"15%"},
	    "dllAttributesForVASR": {"fieldType":"textbox","fieldLabel": "${moduleLbl}", "fieldName": "modulePath","required":"false","txtBoxWidth":"15%"},
	                                }                           
  scor.rule.exclusion.MappingWithAllInputFields = {
	    "casp_bypass": ["filePathAttributes"],
	    "vasr_reloc_bypass": ["filePathAttributes"],
	    "vasr_force_reloc_bypass": ["filePathAttributes","dllAttributesForVASR"],
	    "vasr_rand_bypass": ["filePathAttributes"],
	    "dep_bypass": ["filePathAttributes","depBypassAttributes"],
	    "uninstall_bypass":["filePathAttributesForUninstall","parentAttributes"],
	    "installer_detection_bypass":["filePathAttributesForUninstall"],
	    "mangling_bypass":["filePathAttributes"],
	    "full_crawl":["filePathAttributes"],
	    "always_auth":["filePathAttributes"],
	    "always_unauth":["filePathAttributes"],
	    "anti_debugging_bypass":["filePathAttributes"],
	    "process_ctx_bypass":["attrForFileSkipList","attrForprocessNameSkipList"],
	    "skipFileOperation":["attrForFileOptSkipList"],
	    "skipFileOperation_f":["attrForFileOpt_F_SkipList"],
	    "skipDenyWrite":["attrForDenyOptSkipList"],
	    "skipSolidification":["attrForSolidSkipList"],
	    "skipVolume":["attrForvolumeSkipList"],
	    "skipRegistry":["attrForregistrySkipList"],
	    "skipChangeTracking":["attrForchngeTrckSkipList"],
	    "rebase_dll":["filePathAttributes"]
	        }

	scor.rule.exclusion.handleTogglingActionforDivs = function(divElements) {
	  scor.rule.exclusion.actionEventOnOkButton();
	    var togglingDivId="divToggle_"+divElements.id; 
	      $j(".filtersDesAreaForExceptions").each(function(){
		if(togglingDivId==$j(this).attr("id")){
			 $j(this).toggle();
		  if($j("#"+togglingDivId).is(':visible')){
			  $j("#"+divElements.id).html("&#x25bc;");
		      }
		  else {
			  $j("#"+divElements.id).html("&#x25ba;");
		      }
		    }
		  else{
		     var spanId = $j(this).attr("id").split("_");
		     $j("#"+spanId[1]).html("&#x25ba;");
		     $j(this).slideUp();
		     }
		  })
	   }

	scor.rule.exclusion.handleAttrOptionSelection = function(attrOptionCheckBox) {
			var attrOptionKey = OrionCore.trim(attrOptionCheckBox.value); 
			var findTrForAppend=$j(attrOptionCheckBox).closest("tr"); 
		 // IE Bug Fixes
		  if($j("#exclusion"+attrOptionCheckBox.id).length <1){
		    $j.each(scor.rule.exclusion.MappingWithAllInputFields,function(key,fieldIds){ 
		      if(key === attrOptionKey){
		      var creatingTrAttr=$j("table.tableTemplateForTr >tbody").clone();
		      creatingTrAttr.find('tr:eq(0)').attr("id","exclusion"+attrOptionCheckBox.id);
		      var addedTrAttr="";
		      for(var i=0;i<fieldIds.length;i++){ 
		       addedTrAttr+=scor.rule.exclusion.createDynamicFields(attrOptionKey,fieldIds[i]);
		      }	
		    creatingTrAttr.find('tr>td>table').html(addedTrAttr);
		    findTrForAppend.after(creatingTrAttr.html());
		     }
		    })
		    scor.rule.exclusion.triggerKeyUpEventsOnElements(attrOptionCheckBox);
		   }
		 else
		 {
		  if($j("#exclusion"+attrOptionCheckBox.id).length >0){
			findTrForAppend.next().remove();
			scor.rule.exclusion.actionEventOnOkButton();
		   }
		 }
		}
	scor.rule.exclusion.createDynamicFields = function(suffixforTextFieldId,fieldKey) {
		  var attrForInputBox= $j("table.txtBoxTemplateForTr >tbody").clone();
		  var attrForChkBox=$j("table.chkBoxTemplateForTr >tbody").clone(); 
		  
		  var fieldLabel=scor.rule.exclusion.AllInputFields[fieldKey].fieldLabel;
		  var fieldType=scor.rule.exclusion.AllInputFields[fieldKey].fieldType;
		  var fieldName=scor.rule.exclusion.AllInputFields[fieldKey].fieldName; 
		  var fieldId=fieldName+"_"+suffixforTextFieldId;
		  var addedTrAttr="";
		if(fieldType === "textbox") {  
		   attrForInputBox.find('td:eq(0)').html(fieldLabel);
		   attrForInputBox.find(':text').attr("id",fieldId);
		   var tdWidth=OrionCore.escapeHtml(scor.rule.exclusion.AllInputFields[fieldKey].txtBoxWidth); 
		   if(tdWidth !== "undefined"){
				   attrForInputBox.find('td:eq(0)').css('width',tdWidth);
		     } 
		   var requiredValidation=OrionCore.escapeHtml(scor.rule.exclusion.AllInputFields[fieldKey].required);
		   if(requiredValidation === "false") {
		   attrForInputBox.find(':text').attr("onkeyup",null);
		   attrForInputBox.find(':text').attr("onchange",null);
		   attrForInputBox.find(':text').attr("required",false);
		   attrForInputBox.find('span').html("");
				}
		   addedTrAttr=attrForInputBox.html(); 
		   }
	    if(fieldType === "checkbox") {
		    attrForChkBox.find('td:eq(0)').html(fieldLabel);
			attrForChkBox.find(':checkbox').attr("id",fieldId+"_id");
		    attrForChkBox.find('label').attr("for",fieldId+"_id");
			attrForChkBox.find(':checkbox').val(fieldName);
			attrForChkBox.find('td:eq(2)>div').attr("id","error_"+fieldId);
			addedTrAttr=attrForChkBox.html();
		  }
	    return addedTrAttr+scor.rule.exclusion.createFieldsForErrorMsg(fieldId);
	 }
	scor.rule.exclusion.createFieldsForErrorMsg = function(fieldId){
	      var attrForErrorMsg=$j("table.errorMsgTemplateForTr >tbody").clone();
	      attrForErrorMsg.find('td:eq(0)>div').attr("id","error_"+fieldId); 
	      return attrForErrorMsg.html();
	} 
	scor.rule.exclusion.triggerKeyUpEventsOnElements=function (attrOptionCheckBox){
		if($j("#exclusion"+attrOptionCheckBox.id).length > 0 && $j("#"+attrOptionCheckBox.id).is(":checked") === true){
			$j("#exclusion"+attrOptionCheckBox.id).find("input[type=text]").each(function(index) {
				var textBoxId=$j(this).attr("id");
				$j("#"+textBoxId).trigger('onkeyup');
				if(index === 0)
					{
					OrionCore.focusOn(textBoxId);
					}
			})
		}		
	}
	
	</script>
   <orion:box id="attributesTabId">
   <div id="attributesErrorDivId" class="errorRuleTab">${noEditPermissionMsg}</div>
	<table id="attributes" cellspacing="0" cellpadding="0" width="98%">
		<%@ include file="../AdjustOtherTabs.jsp"%>
		<tr>
			<td class="orionSummaryColumn">
				<table cellspacing='3' cellpadding='0' width='882px;'>
					<tr>
					   <td width="40%" align=""><b>${optionHeader}</b></td>
						<td width="20%" align=""><b>${fileHeader}</b></td>
						<td width="20%" align=""><b>${parentHeader}</b></td>
						<c:if test="${param.osType == WIN_OS}">
							<td width="17%" align=""><b>${moduleHeader}</b></td>
						</c:if>
						<td width=3%" align="" style="display:none;">RuleType</td>
						<!-- more attributes add here -->
					</tr>
				</table> <orion:box id="attrListContainer" height="auto" width="620"/>
			</td>
		</tr>
	</table>

	<div id="attribute_list_row_template" style="display: none;">
		<table cellspacing='0' cellpadding='0' width='98%'
			style="table-layout: fixed">
			<tr>
			    <td width='40%' class="scorWordWrap" align="">@optionString</td>
				<td width='20%' class="scorWordWrap" align="">@filePath</td>
				<td width='20%' class="scorWordWrap" align="">@parentPath</td>
				<c:if test="${param.osType == WIN_OS}">
				<td width='17%' class="scorWordWrap" align="">@modulePath</td>
				</c:if>
				<td width="3%" align="" style="display:none;">@type</td>
				<!-- more attributes add here -->
			</tr>
		</table>
	</div>

	<div id="attribute_filter_editor_template" style="display: none;">
	   <c:if test="${param.osType == 'WIN'}"> <div><span class="summaryOfDialogBox">${dialogBoxSummary1}<a href="${kbLink}" target="_blank">${kbLinkText}</a> ${dialogBoxSummary2}</span></div>
		<br />
	   </c:if>	
		<div id="error_deprecated_option" style="display: none; color: red;">
		</div>
		<div id="error_information" style="display: none; color: red;">
		</div>
		<!-- Options List Start -->
		<c:if test="${param.osType == 'WIN'}">
		<div>
				<span id="flipIdMemoryProtection" onclick="scor.rule.exclusion.handleTogglingActionforDivs(this);" style="cursor:pointer">&#x25ba;</span>
				<span class="mmProtectionLabel">${memoryProtectionLabel}</span>
		</div>
		<div id="divToggle_flipIdMemoryProtection" class="filtersDesAreaForExceptions" style="cursor:pointer;display:none">
					<table width="100%">
						<tr>
						    <td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="casp_bypass_id" value="casp_bypass" />
							    <label class="orionClickableTextLabel" for="casp_bypass_id" id="casp_bypass_id_label"></label>
							</td>
							<td width="98%">${caspBypassHtml} </td>
						</tr>
						<tr> 
						    <td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="dep_bypass_id" value="dep_bypass" />
							    <label class="orionClickableTextLabel" for="dep_bypass_id" id="dep_bypass_id_label"></label>
							</td>
							<td width="98%">${depBypassHTML} </td>
						</tr>
						<tr title="${vasrRelBypassTitle}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="vasr_force_reloc_bypass_id" value="vasr_force_reloc_bypass" />
							    <label class="orionClickableTextLabel" for="vasr_force_reloc_bypass_id" id="vasr_force_reloc_bypass_id_label"></label>
							</td>
							<td width="98%">${aslrBypass}</td>
						</tr>
						<tr title="${aslrBypassTitle}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="vasr_reloc_bypass_id" value="vasr_reloc_bypass" />
							    <label class="orionClickableTextLabel" for="vasr_reloc_bypass_id" id="vasr_reloc_bypass_id_label"></label>
							</td>
							<td width="98%">${vasrRelBypass} </td>
						</tr>
						<tr title="${vasrRandBypassTitle}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="vasr_rand_bypass_id" value="vasr_rand_bypass" />
							    <label class="orionClickableTextLabel" for="vasr_rand_bypass_id" id="vasr_rand_bypass_id_label"></label>
							</td>
							<td width="98%">${vasrRandBypass} </td>
						</tr>
					</table>
		</div>
			<div>
				<span id="flipIdInstallerDetection" onclick="scor.rule.exclusion.handleTogglingActionforDivs(this);" style="cursor:pointer">&#x25ba;</span>
				<span class="mmProtectionLabel">${idExclusionsLabel}</span>
			</div>
		<div id="divToggle_flipIdInstallerDetection" class="filtersDesAreaForExceptions"  style="cursor:pointer;display:none">
					<table width="100%">
						<tr>
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="uninstall_bypass_id" value="uninstall_bypass" />
							    <label class="orionClickableTextLabel" for="uninstall_bypass_id" id="uninstall_bypass_id_label"></label>
							</td>
							<td width="98%">${uninstallBypassLabel}</td>
						</tr>
					</table>
		</div>
		 <div>
				<span id="flipIdSkipList" onclick="scor.rule.exclusion.handleTogglingActionforDivs(this);" style="cursor:pointer">&#x25ba;</span>
				<span class="mmProtectionLabel">${customExclusionLabel}</span>
				<span title="${customExclusionLabelDesc}" class="exceptionQuesMark" style="margin-left:14px;">?</span>
		  </div>
		 <div id="divToggle_flipIdSkipList" class="filtersDesAreaForExceptions"  style="cursor:pointer;display:none">		 
					<table width="100%">
						<tr title="${moniterFileOptDesc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="process_ctx_bypass_id" value="process_ctx_bypass"/>
							    <label class="orionClickableTextLabel" for="process_ctx_bypass_id" id="process_ctx_bypass_id_label"></label>
							</td>
							<td width="98%">${moniterFileOpt}</td>
						</tr>
						<tr title="${excludeFileOptDesc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${SKIPLIST_TYPE}"/>"  
								id="skipFileOperation_id" value="skipFileOperation" />
							    <label class="orionClickableTextLabel" for="skipFileOperation_id" id="skipFileOperation_id_label"></label>
							</td>
							<td width="98%">${excludeFileOpt}</td>
						</tr>
						<tr title="${excludeFileOpt_F_Desc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${SKIPLIST_TYPE}"/>"  
								id="skipFileOperation_f_id" value="skipFileOperation_f" />
							    <label class="orionClickableTextLabel" for="skipFileOperation_f_id" id="skipFileOperation_f_id_label"></label>
							</td>
							<td width="98%">${excludeFileOpt_F}</td>
						</tr>
						<tr title="${enforceWriteOptDesc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${SKIPLIST_TYPE}"/>"
								id="skipDenyWrite_id" value="skipDenyWrite" />
							    <label class="orionClickableTextLabel" for="skipDenyWrite_id" id="skipDenyWrite_id_label"></label>
							</td>
							<td width="98%">${enforceWriteOpt}</td>
						</tr>
						<tr title="${whitelistOptDesc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${SKIPLIST_TYPE}"/>" 
								id="skipSolidification_id" value="skipSolidification" />
							    <label class="orionClickableTextLabel" for="skipSolidification_id" id="skipSolidification_id_label"></label>
							</td>
							<td width="98%">${whitelistOpt}</td>
						</tr>
						<tr title="${excludeVolOptDesc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${SKIPLIST_TYPE}"/>"  
								id="skipVolume_id" value="skipVolume" />
							    <label class="orionClickableTextLabel" for="skipVolume_id" id="skipVolume_id_label"></label>
							</td>
							<td width="98%">${excludeVolOpt}</td>
						</tr>
						<tr class="advancedSkipListOptn" title="${registryTrackingDesc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${SKIPLIST_TYPE}"/>" 
								id="skipRegistry_id" value="skipRegistry" />
							    <label class="orionClickableTextLabel" for="skipRegistry_id" id="skipRegistry_id_label"></label>
							</td>
							<td width="98%">${registryTracking}</td>
						</tr>
						<tr class="advancedSkipListOptn" title="${changeTrackingDesc}">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${SKIPLIST_TYPE}"/>" 
								id="skipChangeTracking_id" value="skipChangeTracking" />
							    <label class="orionClickableTextLabel" for="skipChangeTracking_id" id="skipChangeTracking_id_label"></label>
							</td>
							<td width="98%">${changeTracking}</td>
						</tr>
					</table>
		</div>
		<div>
				<span id="flipIdMPDeprecated" onclick="scor.rule.exclusion.handleTogglingActionforDivs(this);" style="cursor:pointer">&#x25ba;</span>
				<span class="mmProtectionLabel">${memProtectionDeprecatedLbl}</span>
				<span title="${customExclusionLabelDesc}" class="exceptionQuesMark" style="margin-left:14px;">?</span>
		</div>
		<div id="divToggle_flipIdMPDeprecated" class="filtersDesAreaForExceptions"  style="cursor:pointer;display:none">		 
					<table width="100%">
						<tr>
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="mangling_bypass_id" value="mangling_bypass"/>
							    <label class="orionClickableTextLabel" for="mangling_bypass_id" id="mangling_bypass_id_label"></label>
							</td>
							<td width="98%">${mangBypass}</td>
						</tr>
						<!-- 
						<tr>
							<td width="2%"><input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="always_auth_id" value="always_auth" />
							</td>
							<td width="98%">${alwsAuth}</td>
						</tr>
						<tr>
							<td width="2%"><input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="always_unauth_id" value="always_unauth" />
							</td>
							<td width="98%">${alwsUnauth}</td>
						</tr>
						 -->
						<tr>
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>" 
								id="anti_debugging_bypass_id" value="anti_debugging_bypass" />
							    <label class="orionClickableTextLabel" for="anti_debugging_bypass_id" id="anti_debugging_bypass_id_label"></label>
							</td>
							<td width="98%">${antiDbgBypass}</td>
						</tr>
						<tr>
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="full_crawl_id" value="full_crawl" />
							    <label class="orionClickableTextLabel" for="full_crawl_id" id="full_crawl_id_label"></label>
							</td>
							<td width="98%">${fulCrwl}</td>
						</tr>
						<tr class="advancedSkipListOptn">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>" 
								id="rebase_dll_id" value="rebase_dll" />
							    <label class="orionClickableTextLabel" for="rebase_dll_id" id="rebase_dll_id"></label>
							</td>
							<td width="98%">${rbsDll}</td>
						</tr>
						<tr class="advancedSkipListOptn">
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="installer_detection_bypass_id" value="installer_detection_bypass" title="${instBypassDesc}" />
							    <label class="orionClickableTextLabel" for="installer_detection_bypass_id" id="installer_detection_bypass_id_lavel"></label>
							</td>
							<td width="98%">${instBypass}
							</td>
						</tr>
					</table>
		</div>
		</c:if>		
		<!-- Unix Options -->
		<c:if test="${param.osType == 'UNIX'}">
			<table>
				<tr>
					<table width="">
					<!-- 
						<tr>
							<td width="2%"><input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="always_auth_id" value="always_auth" /></td>
							<td width="98%">${alwsAuth}</td>
						</tr>
						<tr>	
							<td width="2%"><input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="always_unauth_id" value="always_unauth" /></td>
							<td width="98%">${alwsUnauth}</td>
						</tr>
					 -->	
						<tr>
							<td width="2%">
							    <input type="checkbox" name="attrOptsChkBox" onclick="scor.rule.exclusion.handleAttrOptionSelection(this)" ruleType="<c:out value="${ATTR_TYPE}"/>"
								id="process_ctx_bypass_id" value="process_ctx_bypass"/>
							    <label class="orionClickableTextLabel" for="process_ctx_bypass_id" id="process_ctx_bypass_id"></label>
							</td>
							<td width="98%">${moniterFileOpt}</td>
						</tr>
					</table>
				</tr>
			</table>
		</c:if>

		<!-- more attributes add here -->
		</table>
	</div>

	<div id="diagnostic_editor_template" style="display: none;">
		<div id="diagnosticListDB"></div>
		<div id="error_include" style="display: none; color: red;">
			*&nbsp;${duplicateLabel}</div>
	</div>
	<div style="display:none;">
		 <table  width="" cellpadding=2>
		    <tr>
		     <td>
		       <table class="txtBoxTemplateForTr">
		            <tr>
		              <td width="">
		              </td>
		             <td width="">
		              <input type="text" required="true" maxlength="255" class="exclusionsTabInputBox" size="35" onkeyup="scor.rule.exclusion.exclusionCommonValidation(this)" onchange="scor.rule.exclusion.exclusionCommonValidation(this)">
		              <span style="color:red;margin-left: 5px;">*</span>
		             </td>
		           </tr>
		     </table>
		   </td>
		  </tr>
		 <tr>
		   <td>
		       <table class="chkBoxTemplateForTr">
		            <tr>
		                <td width="2%"></td>		                
		                <td width="">
		                    <input type="checkbox" id="chkBoxId"class="orionCheckbox" style="margin-left:0%;">
		                    <label for="chkBoxId"></label>
		                </td>		               
		                <td><div style="display: none; color: red;">*&nbsp;${duplicateLabel}</div></td>
		             </tr>
		     </table>
		   </td>
		 </tr>
		 <tr>
		    <td>
		       <table class="tableTemplateForTr">
		            <tr>   
		                  <td width="2%"></td>
						  <td colspan=2 width="98%">
						    <table width="100%" cellpadding=2 cellspacing=0>
						     </table>
						   </td>
		            </tr>
		      </table>
		   </td>
		 </tr>
		 <tr>
		    <td>
		       <table class="errorMsgTemplateForTr">
		            <tr>   
		              <td width="" colspan="2">
		             <div class="error_include orionInputErrorText" style="display: none; color: red;"></div>
		             </td>
		            </tr>
		      </table>
		   </td>
		 </tr>
         </table>
     </div>
</orion:box>

	<script type="text/javascript">
	<c:if test = "${isAuthorizedToViewExceptionRules == false}">
		$j('#attributesTabId').hide();
	</c:if>
	    var myEpoEnableApplyButton;
	    myEpoEnableApplyButton = function() {
	        if (typeof epoEnableApplyButton == 'function') {
	            epoEnableApplyButton();
	        }
	    };
	    
	    function attrCallback(isEdit){
	        OrionCore.showDialogBox(true, $('attribute_filter_editor_template').innerHTML, OrionCore.DIALOG_OK_CANCEL);
	    	
	        OrionCore.dialogBoxOkHandler=scor.utils.partial(okHandler,isEdit);
	        <c:if test="${param.osType == 'WIN'}">
	        scorSetDialogSize(550,750);
	    	</c:if>
	        <c:if test="${param.osType == 'UNIX'}">
	        scorSetDialogSize(243,562);
	    	</c:if>
	        <c:choose>
	        <c:when test="${scorShowAdvancedExclusionOptions}">
	        $j('.advancedSkipListOptn').show();
	    	</c:when>
	    	<c:otherwise>
	    	$j('.advancedSkipListOptn').hide();
			</c:otherwise>
			</c:choose>
	        if(isEdit === true){
	            OrionCore.setDialogBoxTitle('${editTitle}');
	        }else{
	            OrionCore.setDialogBoxTitle('${addTitle}');
	            scor.rg.awl.attrs.displayActionOnDivs();
	            scor.rg.awl.attrs.enableAllChkBox();
	            OrionCore.enableDialogBoxOkButton(false);
	        }
	        
	        epoEnableApplyButton();
	    }
	    
	    // Get the selected checkbox array and add those rows.
	    function processOptions(selectedIDs){
	        var options="";
	        for(var j=0; j < selectedIDs.length; j++){
	            options = options + selectedIDs[j]+', ';
	        }
	         return options;
	    }

		function directoryChkBoxClkHandler(box,hiddenField){
		    if(box.checked){
		        hiddenField.value = 'true';
		    }else{
		        hiddenField.value = 'false';
		    }
		}
		
		function AttrPolicyVO (attributes) {
		    this.attributes = attributes;
		}

		var attributesList = new majic.ListWidget({
		    container: "attrListContainer",
		    width: "900px",
		    height: "320px",
		    buttons: {
		        'insert': '${addBtnTxt}',
		        'modify': '${editBtnTxt}',
		        'remove': '${remBtnTxt}',
		        'suggest': '${awlButtonDiagSuggest}'
		    },
		    content: $('attribute_filter_editor_template').innerHTML,
		    displayText: $('attribute_list_row_template').innerHTML,
		    formatCallback: listWidgetformatCallback
		});
		
		var insertButton = attributesList.buttonElements[0];
		insertButton.onclick = handleAdd;
		
		var editButton = attributesList.buttonElements[1];
		editButton.onclick = handleEdit;


		var scor = scor || {};
		scor.rg = scor.rg || {};
		scor.rg.awl = scor.rg.awl || {};
		scor.rg.awl.attrs = scor.rg.awl.attrs || {};
		
		scor.rg.awl.attrs.hideButton = function(buttonName) {
			var btnNameList = ['insert', 'modify', 'remove', 'suggest'];
			var i;
			var found = -1;//false
			var button;
			for (i=0;i<btnNameList.length;i++){
				if (buttonName === btnNameList[i]) {
					found = i;
					break;
				}
			}
			if (found !== -1) {
				button = attributesList.buttonElements[found];
				button.style.display = 'none';
			}
		};

	var okHandler = function (edit){
		$j("input:checkbox[name=attrOptsChkBox]:checked").each(function () {     
		var filePath="";
		var parentPath="";
		var modulePath="";
		var optionString="";
		var ruleType="";
		
		if($j("#filePath_"+$j(this).val()).length > 0) {
		 filePath=$j("#filePath_"+$j(this).val()).val();
		}
		if($j("#parentPath_"+$j(this).val()).length > 0) {
		  parentPath=$j("#parentPath_"+$j(this).val()).val();
		}
		if($j("#modulePath_"+$j(this).val()).length > 0) {
		  modulePath=$j("#modulePath_"+$j(this).val()).val();
		}	 
		var checkofAddedCheckBox=$j(this).closest('tr').next().find('input[type=checkbox]').attr("id");
		if($j("#"+checkofAddedCheckBox).length>0){
		  if($j("#"+checkofAddedCheckBox).is(":checked")){
		  optionString=$j(this).val()+","+$j("#"+checkofAddedCheckBox).val();
		  }
		  else {
	      optionString=$j(this).val();
		    }
	     }	
		 else {
	       optionString=$j(this).val();
		 }
		ruleType=$j(this).attr("ruleType");
			
		  var attrObj = {"filePath" : filePath,
		        "optionString" : optionString,
		        "parentPath":parentPath,
		        "modulePath":modulePath,
		        "type":ruleType
		     }
		  if(edit === true){
			        attributesList.insert(attrObj,true) ;
			  }else{
			        attributesList.insert(attrObj) ;
			    }
		})    
		};

		function handleAdd(){
			 attrCallback(false);			
		}

		 scor.rule.exclusion.exclusionCommonValidation=function(propertiesOfInputBox){
			 var directoryPath = scor.utils.GetElementFromDialogBox(propertiesOfInputBox.id,'input');
		     var validationObj = scor.validation.validatePathForSkipList(propertiesOfInputBox,'${orion:escapeJavaScriptString(param.osType)}');
		     var validationObjMsg = scor.validation.processValidationResultForSkipList(validationObj,directoryPath,"error_"+propertiesOfInputBox.id);  
		     if(validationObj && validationObjMsg && scor.rule.exclusion.actionEventOnOkButton())
		     {
		    	 OrionCore.enableDialogBoxOkButton(true);
		      }
		     else {
		    	 OrionCore.enableDialogBoxOkButton(false);
		      }
	    }
		 
		 scor.rule.exclusion.actionEventOnOkButton=function(){
	    	var isValid = true;
	    	var errorDiv = scorFindElementById(scorGetDialogBox(), 'div', 'error_information');
	    	$j("div.error_include").each(function () {    
	    		if($j(this).css("display") === "block")
	    		{  
	    			var exclusionFlipName=$j(this).parents("div").prev().find("span.mmProtectionLabel").text();		
	    			exclusionFlipName=exclusionFlipName ? exclusionFlipName : "";
	    			errorDiv.style.display = "block";
				    errorDiv.innerHTML = '${emptyFileMsgs}'+exclusionFlipName;
	    		    isValid=false;	
	    		}	
	    	})
	    	if(isValid){
	    		errorDiv.style.display = "none";
			    errorDiv.innerHTML = '';
			    OrionCore.enableDialogBoxOkButton(true);
	    	}
	       return isValid;
	    } 
	
		function handleEdit(){
		    var selectedRow = attributesList.selrow;
		    if(typeof selectedRow === 'undefined' || selectedRow === null){
				return;
		    }
		    attrCallback(true);
		    //Update form values.
		    var row = attributesList.list[selectedRow.id];
			var checkbypass_inherit=false;
			var checkedOption="";
			 var selOptions = row.optionString;
			    var options =selOptions.split(',');
			    for(var i=0; i < options.length; i++){
			          if(OrionCore.trim(options[i])!="dep_bypass_inherit")
			    	   checkedOption=OrionCore.trim(options[i]);
			          if(OrionCore.trim(options[i])=="dep_bypass_inherit")
			        	  checkbypass_inherit=true;
			    }
			 
		    	var fileName = row.filePath;
		        var parentName = row.parentPath;
		        var moduleName = row.modulePath;
		        if(checkedOption === "skipRegistry" || checkedOption === "skipChangeTracking" || checkedOption === "rebase_dll" || checkedOption === "installer_detection_bypass"){
		        	$j("#"+checkedOption+"_id").closest(".advancedSkipListOptn").show();
		        }
		        scor.rg.awl.attrs.actionPerformedOnSelectedRow(checkedOption);
		        $j("#filePath_"+checkedOption).val(fileName);
		        $j("#parentPath_"+checkedOption).val(parentName);
		        $j("#modulePath_"+checkedOption).val(moduleName);
		        if (checkbypass_inherit == true){
		        	$j("#dep_bypass_inherit_"+checkedOption+"_id").attr('checked',true);
		        }
		}

		scor.rg.awl.attrs.actionPerformedOnSelectedRow=function(checkedOptionValue)
		 {   
			var selectedChkBoxId=$j("#"+checkedOptionValue+"_id");
			<c:if test="${param.osType == 'WIN'}">
			scor.rg.awl.attrs.displayActionOnDivs();
			var chkBoxParentDivId=selectedChkBoxId.parents('.filtersDesAreaForExceptions').attr("id").split("_");
			var flipId=chkBoxParentDivId[1];
			$j("#"+flipId).trigger('click');
			</c:if>
			selectedChkBoxId.trigger('click');
			scor.rg.awl.attrs.disableCriteriaOfChkBoxForEdit(checkedOptionValue);
		 }

		scor.rg.awl.attrs.disableCriteriaOfChkBoxForEdit=function(selectedChkBox){
			$j("input:checkbox[name=attrOptsChkBox]").each(function () {
				$j(this).attr("disabled",true);		
			})
			$j("#"+selectedChkBox+"_id").attr('checked',true);
		}
		scor.rg.awl.attrs.displayActionOnDivs= function(){
			$j("#divToggle_flipIdMemoryProtection,#divToggle_flipIdInstallerDetection,#divToggle_flipIdSkipList,#divToggle_flipIdMPDeprecated").css("display","none");
		}
		scor.rg.awl.attrs.enableAllChkBox=function(){
			$j("input:checkbox[name=attrOptsChkBox]").each(function () {
				$j(this).removeAttr("disabled");
			})
		 }
		function epoApplyPolicySettings ()
		{
		    var attributes = getAttributes();
		    var attrPolicyVO = new AttrPolicyVO(attributes);
		    var attrPolicyVOJSON = JSON.stringify(attrPolicyVO);
		    //TODO - hardcoded params
		    var queryStr='?'+"<%=Constants.OS_TYPE%>"+"="+"${orion:escapeJavaScriptString(param.osType)}";
		    scor.actions.doAsyncAction ("<%=URLConstants.SAVE_ATTR_POLICY_URL%>"+queryStr, ["attrData",attrPolicyVOJSON], _applyAttrSuccess, _applyAttrFailure, "POST");
		}
		
		function _applyAttrSuccess()
		{
		    fnGoBack();
		}
		
		function _applyAttrFailure()
		{
		    alert ('${msgFailed}'); 
		    return false;
		}

		function getAttributes(){
		    var vo = [];
		    var rows = attributesList.getRows();
		    for (var rowKey in rows)
		    {
		        var row = rows[rowKey];
		        if (row != null && row != undefined)
		        {
		            vo.push( {"filePath": scor.utils.trim(row['filePath']),
		                "optionString": scor.utils.removeTrailingComma(scor.utils.trim(row['optionString'])),
		                "parentPath": scor.utils.trim(row['parentPath']),
		                "modulePath": scor.utils.trim(row['modulePath']),
		                "type": scor.utils.trim(row['type'])
		            });
		        }
		    }
		    return vo;
		}
		
		function scorModuleHandler(chkBox){
		    OrionCore.setEnabled($('modulePath'), chkBox.checked);
		}
		
		function parentHandler(chkBox){
			var isChecked = false;
			if($j('#uninstall_bypass_id').is(':checked') || $j('#process_ctx_bypass_id').is(':checked')){
				isChecked = true;
			}
		    OrionCore.setEnabled($('processName'), isChecked);
		}
		
		function showOptionDeprecatedWarning(chkBox){
			if(chkBox.checked){
			$j('#error_deprecated_option').show();
			$j('#error_deprecated_option').html('${installerDeprecatedWarning}');
			}else{
				$j('#error_deprecated_option').html('');
				$j('#error_deprecated_option').hide();
			}
		}
		
		function showHideDepInheritance(chkBox){
			if(chkBox.checked){
			$j('#trdep_bypass_inherit').show();
			}else{
				$j('#dep_bypass_inherit_id').attr('checked', false);
				$j('#trdep_bypass_inherit').hide();
			}
		}
		
		function populateAttributes(attrVo){
			if(${isAuthorizedToEditExceptionRules} === false){
				return;
			}
			scor.utils.clearMagicListWidget(attributesList);
		    var obj = attrVo['attributes'] ;
		    obj = obj ? obj : {};
		    for(var i=0; i < obj.length; i++)
		    {
		        var parent = obj[i].parentPath;
		        if(parent === undefined || parent === null){
		            obj[i].parentPath="";
		        }
		        var module = obj[i].modulePath;
		        if(module === undefined || module === null){
		            obj[i].modulePath="";
		        }
		    
		        attributesList.insert(obj[i]) ;
		    }
		}
		<c:if test="${scorAttrPolicyDataJSON != null}">
		var attrVo = JSON.parse('${orion:escapeJavaScript(scorAttrPolicyDataJSON)}');
		OrionCore.addLoadHandler(scorInitializeAttrs);
		</c:if>
		function scorInitializeAttrs()
		{
		    populateAttributes(attrVo);
		    scorAttribDoReadOnly("${epoReadOnlyPolicyObject}" === "true");
		    
		}
		var scorAttribDoReadOnly = function(readOnly){
		    attributesList.setEnabled(!readOnly);
		}
				
		scor.rg.awl.attrs.diags = function() {
			var attrDiags = {};
			return {
				get: function() {
					return attrDiags;
				},
				set: function(diagSet) {
					attrDiags = diagSet;
				}
			}
		}();
			
		//Get the selected checkbox array and add those rows.
		scor.rg.awl.attrs.processDiagFormData = function(selectedIDs){
		
		    // DATA SET
		    var currentDiagAttrSet = scor.rg.awl.attrs.diags.get();
		    var obj = currentDiagAttrSet['diagnostics'] ;
		    for(var i=0; i < obj.length; i++){
		        var diagObj=obj[i];
		
		        // insert row in the list.
		        for(var j=0; j < selectedIDs.length; j++){
		            if(String(diagObj.id) === selectedIDs[j]){
		            	scor.rg.awl.attrs.insertDiagRow(diagObj);
		            }
		        }
		    }
		    epoEnableApplyButton();
		}
		
		scor.rg.awl.attrs.handleMultiAdd = function(){
		    OrionCore.showDialogBox(true, $('diagnostic_editor_template').innerHTML, OrionCore.DIALOG_OK_CANCEL);
		    scor.actions.doAsyncAction ("<%=URLConstants.LOAD_DIAGNOSTIC_ATTR_URL%>",null, scor.rg.awl.attrs.loadDiagnosticSuccess);
		
		    OrionCore.dialogBoxOkHandler = function(){
		        var chkBoxes = scor.utils.scorFindElementsByNames($('<%=Constants.dialogBoxId%>'), 'input', 'diagnosticChkBox');
		        var idList = scor.utils.getValuesOfSelectedChkBoxes(chkBoxes);
		        scor.rg.awl.attrs.processDiagFormData(idList);
		    };
		}
		
		var suggestButton = attributesList.buttonElements[3];
		suggestButton.onclick = scor.rg.awl.attrs.handleMultiAdd;
		suggestButton.style.display = 'none';
		
		scor.rg.awl.attrs.loadDiagnosticSuccess = function (result){
			scor.rg.awl.attrs.diags.set(result);
		    scor.rg.awl.attrs.showDiagnosticList(result);
		}
		
		scor.rg.awl.attrs.showDiagnosticList = function (diagResultSet) {
		    OrionCore.setDialogBoxTitle('${addTitle}');
		    var diagnosticHolder = scor.utils.GetElementFromDialogBox('diagnosticListDB',"div");
		    diagnosticHolder.innerHTML="";
		    // HEADER ROW
		
		    var diagnostics = diagResultSet['diagnostics'] ;
		    if(diagnostics.length == 0){
		        scor.utils.appendNoResultFound(diagnosticHolder);
		        return;
		    }
		    var tableStr ="<table cellspacing='3' cellpadding='0' width='95%'>";
		    tableStr+= "<tr>";
		    tableStr+="<td width='5%'> </td>";
		    tableStr+="<td width='28%'><b>${diagSystem}</b></td>";
		    tableStr+="<td width='28%'><b>${diagBinary}</b></td>";
		    tableStr+= "<td width='13%'><b>${diagManglingBypass}</b></td>";
		    tableStr+= "<td width='13%'><b>${diagCaspBypass}</b></td>";
		    tableStr+= "<td width='13%'><b>${diagDepBypass}</b></td>";
		    tableStr+= "</tr>";
		
		
		    for(var i=0; i < diagnostics.length; i++)
		    {
		        var rowStr = createDiagUpdaterTableRow(diagnostics[i]);
		        tableStr+= rowStr;
		    }
		
		    diagnosticHolder.innerHTML = tableStr;
		}
		
		function createDiagUpdaterTableRow(obj){
		    var rowStr = "<tr>";
		    rowStr+= "<td width='5%'><INPUT TYPE='CHECKBOX' NAME='diagnosticChkBox' VALUE='"+ obj.id + "'/></td>";
		    rowStr+= "<td width='28%'>"+obj.systemName+"</td>";
		    rowStr+= "<td width='28%'>"+obj.binaryName+"</td>";
		    rowStr+= "<td width='13%'>"+obj.manglingBypass+"</td>";
		    rowStr+= "<td width='13%'>"+obj.caspBypass+"</td>";
		    rowStr+= "<td width='13%'>"+obj.depBypass+"</td>";
		    rowStr+= "</tr>"
		    return rowStr;
		}
		
		scor.rg.awl.attrs.insertDiagRow = function (diagnostic){
		    var oVal = '';
		    var trueIgnoreCase = /^true$/i;
		    if (trueIgnoreCase.test(diagnostic.manglingBypass)) {
		        oVal = oVal + 'mangling_bypass,';
		    }
		    if (trueIgnoreCase.test(diagnostic.caspBypass)) {
		        oVal = oVal + 'casp_bypass,';
		    }
		    if (trueIgnoreCase.test(diagnostic.depBypass)) {
		        oVal = oVal + 'dep_bypass,';
		    }
			
		    var newObj = {
		        "filePath":diagnostic.binaryName,
		        "optionString" : oVal,
		        "parentPath": diagnostic.parent,
		        "id":diagnostic.id
		    }
		
		    attributesList.insert(newObj) ;
		}
		
		function enableAttributeList(enable) {
			attributesList.setEnabled(enable && ${isAuthorizedToEditExceptionRules});
		}
				
		</script>
