<%-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>

<orion:message key="scor.task.cliStatus.change" var="labelChangeCliStatus"/>
<orion:message key="scor.task.cliStatus.change.allowed" var="labelChangeCliStatusAllowed" escape="none"/>
<orion:message key="scor.task.cliStatus.change.restricted" var="labelChangeCliStatusRestricted" escape="none"/>
<orion:message key="scor.task.cliStatus.help.text" var="helptext"/>
<orion:message key="scor.general.alertMsg" var="generalAlertMsg" escape="javascript" />


<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.CLIENT_TASK_CHANGE_LOCAL_CLI%>");
</script>

<script type= "text/javascript">
function epoOnBeforeSubmit()
{
 return finalvalidate() ;
}
function finalvalidate()
{
	if ( OrionForm.isFormValid() == false )
	{
	alert("${generalAlertMsg}");
	return false;
	}
 return true;
}
</script>


 <orion:box>
<div class="orionDescriptionArea orionBorderBottomGrey">
                        ${helptext}
</div>
 <table  cellspacing="0" cellpadding="0" width="100%" style="width:100%;" id="generalTab">

  <tr>
 		<td class="orionSummaryHeader" valign="top">
            ${labelChangeCliStatus}
        </td>
        <td class="orionSummaryColumn" valign="top">
      		<orion:radiobutton id="cliStatusRestricted"
      			value="lockdown"
                name="cliStatus"
                checked="${cliStatusRestricted}"
                text="${labelChangeCliStatusRestricted}" disabled="${epoReadOnlyTask}"/>
      		<br>
      	
      		<orion:radiobutton id="cliStatusAllowed"
      			value="recover"
                name="cliStatus"
                checked="${cliStatusAllowed}"
                text="${labelChangeCliStatusAllowed}" disabled="${epoReadOnlyTask}"/>
		

        </td>
 </tr>
 </table>
 
 </orion:box>
