<!-- Copyright (C) 2018 McAfee, Inc.  All rights reserved. -->
<%@ page import="com.mcafee.scor.common.CommonConstants" %>
<%@ taglib prefix="orion" uri="http://www.mcafee.com/orion" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>

<orion:message key="scor.error.defAsyncFailure" var="scorDefAsyncFailureMsg" escape="javascript"/>
<orion:message key="scor.error.dialogBox.title" var="scorErrorDialogBoxTitle" escape="javascript"/>
<jsp:include page="/common/includejQuery.jsp"/>
<%-- validation messages --%>
<orion:message key="policy.mon.filters.empty" var="valFilterEmpty" escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.valFileWinMaxLenghtExceed" var="valFileWinMaxLenghtExceed" escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.fullyQualifiedReq" var="valFileWinfullyQualifiedReq" escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.valFileWinNoStarAtEnd" var="valFileWinNoStarAtEnd" escape="javascript"/>
<orion:message key="policy.mon.file.filters.notValid" var="valFileNotValid" escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.valFileWinStarNotAllowedAtPos" var="valFileWinStarNotAllowedAtPos" escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.valFileWinCurrDirNotAllowed" var="valFileWinCurrDirNotAllowed" escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.valFileWinParentDirNotAllowed" var="valFileWinParentDirNotAllowed" escape="javascript"/>
<orion:message key="policy.mon.file.filters.win.valFileWinMultBSlashesNotAllowed" var="valFileWinMultBSlashesNotAllowed" escape="javascript"/>
<orion:message key="scor.policy.validation.emptyTagMsg" var="emptyTagMsg" escape="javascript"/>
<orion:message key="policy.mon.file.filters.unix.slash" var="shouldStartWithSlash" escape="javascript"/>
<orion:message key="scor.policy.validation.validSHA1" var="validSHA1" escape="javascript"/>
<orion:message key="scor.policy.validation.validSHA256" var="validSHA256" escape="javascript"/>
<orion:message key="scor.policy.validation.reqFields" var="reqFields" escape="javascript"/>
<orion:message key="scor.callback.noDataFound" var="noDataFound" escape="javascript"/>
<orion:message key="policy.mon.file.filters.valPatternBoxCharactersNotValid" var="valPatternBoxCharactersNotValid" escape="javascript"/>

<orion:message key="scor.policy.validation.exclusion.fileRelativePath" var="fileRelativePath" escape="javascript"/>
<orion:message key="scor.policy.validation.exclusion.filePath" var="filePath" escape="javascript"/>
<orion:message key="policy.mon.reg.filters.mustBeginWith" var="registryPath" escape="javascript"/>
<orion:message key="scor.policy.validation.exclusion.volumePath" var="volumePath" escape="javascript"/> 
<orion:message key="scor.policy.validation.exclusion.valFileNotForDashs" var="valFileNotForDashs" escape="javascript"/>

<orion:message key="scor.attr.options.always_auth" var="always_auth_msg" escape="javascript"/>
<orion:message key="scor.attr.options.always_unauth" var="always_unauth_msg" escape="javascript"/>
<orion:message key="scor.attr.options.anti_debugging_bypass" var="anti_debugging_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.casp_bypass" var="casp_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.ccv_bypass" var="ccv_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.dep_bypass" var="dep_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.dep_bypass_inherit" var="dep_bypass_inherit_msg" escape="javascript"/>

<orion:message key="scor.attr.options.full_crawl" var="full_crawl_msg" escape="javascript"/>
<orion:message key="scor.attr.options.installer_detection_bypass" var="installer_detection_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.mangling_bypass" var="mangling_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.process_ctx_bypass" var="process_ctx_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.process_ctx_reg_bypass" var="process_ctx_reg_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.rebase_dll" var="rebase_dll_msg" escape="javascript"/>
<orion:message key="scor.attr.options.relocate_dll" var="relocate_dll_msg" escape="javascript"/>
<orion:message key="scor.attr.options.uninstall_bypass" var="uninstall_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.vasr_force_reloc_bypass" var="vasr_force_reloc_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.vasr_rand_bypass" var="vasr_rand_bypass_msg" escape="javascript"/>
<orion:message key="scor.attr.options.vasr_reloc_bypass" var="vasr_reloc_bypass_msg" escape="javascript"/>

<orion:message key="scor.skiplist.options.skipChangeTracking" var="skipChangeTracking_msg" escape="javascript"/>
<orion:message key="scor.skiplist.options.skipDenyWrite" var="skipDenyWrite_msg" escape="javascript"/>
<orion:message key="scor.skiplist.options.skipFileOperation" var="skipFileOperation_msg" escape="javascript"/>
<orion:message key="scor.skiplist.options.skipFileOperation_f" var="skipFileOperation_f_msg" escape="javascript"/>
<orion:message key="scor.skiplist.options.skipRegistry" var="skipRegistry_msg" escape="javascript"/>
<orion:message key="scor.skiplist.options.skipSolidification" var="skipSolidification_msg" escape="javascript"/>
<orion:message key="scor.skiplist.options.skipVolume" var="skipVolume_msg" escape="javascript"/>
<orion:message key="scor.registeredServer.validation.reqFields" var="reqServerAddress" escape="javascript"/>
<orion:message key="scor.registeredServer.validation.serverAddress" var="serverAddress" escape="javascript"/>
<orion:message key="scor.policy.wildCardvalidation.warningMsg" var="wildCardWarningMsgs" escape="javascript"/>
<orion:message key="scor.policy.regex.filters.notValid" var="FileOrPathNotValid" escape="javascript"/>
<script type="text/javascript">

var scor;
scor = scor || {};
scor.utils = scor.utils || {};
scor.validation = scor.validation || {};
scor.common = scor.common || {};
scor.common.validation = scor.common.validation || {};
scor.validation.constructors = scor.validation.constructors || {};

scor.utils.optionStringMap = scor.utils.optionStringMap || {};
scor.utils.optionStringMap = new Object();

scor.utils.optionStringMap["always_auth"] = '${always_auth_msg}';
scor.utils.optionStringMap["always_unauth"] = '${always_unauth_msg}';
scor.utils.optionStringMap["anti_debugging_bypass"] = '${anti_debugging_bypass_msg}';
scor.utils.optionStringMap["casp_bypass"] = '${casp_bypass_msg}';
scor.utils.optionStringMap["ccv_bypass"] = '${ccv_bypass_msg}';
scor.utils.optionStringMap["dep_bypass"] = '${dep_bypass_msg}';
scor.utils.optionStringMap["dep_bypass_inherit"] = '${dep_bypass_inherit_msg}';

scor.utils.optionStringMap["full_crawl"] = '${full_crawl_msg}';
scor.utils.optionStringMap["installer_detection_bypass"] = '${installer_detection_bypass_msg}';
scor.utils.optionStringMap["mangling_bypass"] = '${mangling_bypass_msg}';
scor.utils.optionStringMap["process_ctx_bypass"] = '${process_ctx_bypass_msg}';
scor.utils.optionStringMap["process_ctx_reg_bypass"] = '${process_ctx_reg_bypass_msg}';
scor.utils.optionStringMap["rebase_dll"] = '${rebase_dll_msg}';
scor.utils.optionStringMap["relocate_dll"] = '${relocate_dll_msg}';
scor.utils.optionStringMap["uninstall_bypass"] = '${uninstall_bypass_msg}';
scor.utils.optionStringMap["vasr_force_reloc_bypass"] = '${vasr_force_reloc_bypass_msg}';
scor.utils.optionStringMap["vasr_rand_bypass"] = '${vasr_rand_bypass_msg}';
scor.utils.optionStringMap["vasr_reloc_bypass"] = '${vasr_reloc_bypass_msg}';

scor.utils.optionStringMap["skipChangeTracking"] = '${skipChangeTracking_msg}';
scor.utils.optionStringMap["skipDenyWrite"] = '${skipDenyWrite_msg}';
scor.utils.optionStringMap["skipFileOperation"] = '${skipFileOperation_msg}';
scor.utils.optionStringMap["skipFileOperation_f"] = '${skipFileOperation_f_msg}';
scor.utils.optionStringMap["skipRegistry"] = '${skipRegistry_msg}';
scor.utils.optionStringMap["skipSolidification"] = '${skipSolidification_msg}';
scor.utils.optionStringMap["skipVolume"] = '${skipVolume_msg}';


function scorGetDialogBox() {
    return  OrionCore.getDialogBoxContainer();
}

scor.utils.validateRuleGroupName = function(groupName){
	var re = /^([@=\+\-\|]).*$/;
	
	return re.test(groupName);
}

scor.utils.GetElementsFromDialogBoxByName =  function(elementName,elementTagName) {
	return scor.utils.scorFindElementsByNames(scorGetDialogBox(),elementTagName,elementName);
};

scor.utils.GetElementFromDialogBox =  function(elementId,elementTagName) {
    var parent = scorGetDialogBox();
    if(elementTagName){
        return scorFindElementById(parent,elementTagName,elementId);
    }
    return null;
};

function scorCreateTableHeader(containerId) {
    var headerTable = document.getElementById(containerId).innerHTML;
    var contentSpan = document.createElement('span');
    contentSpan.innerHTML = headerTable;
    return contentSpan;
}

function scorFindElementById(parent, elementTagName, elementId) {
    var children = parent.getElementsByTagName(elementTagName);
    var retElement = null;
    for (var i = 0; i < children.length; i++) {
        if (children[i] && children[i].id === elementId) {
            retElement = children[i];
            break;
        }
    }
    return retElement;
}

scor.utils.removeTrailingComma = function(optionsString){
	var len = optionsString.length;
    if ($j.trim(optionsString).length > 0 && optionsString.substr(len-1,1) == ",") {
    	optionsString = optionsString.substring(0,len-1);
    }
    return optionsString;
	
}

scor.utils.getValueOrEmpty = function(element) {
    if(!element){
        return "";
    }else if(scor.utils.isNullOrEmpty(element)){
		return "";
	}
    return element.value;
}

scor.utils.isEnabled = function(element) {
    if(!element){
        return false;
    }
    return !element.disabled;
}

scor.utils.setEnabled = function(element, enabled ) {
    if(!element){
        return;
    }
    OrionCore.setEnabled(element,enabled);
}

scor.utils.hideElement = function(element) {
    if(!element){
        return;
    }
    element.style.display = 'none';
}
scor.utils.hideElements = function(elements) {
    if(!elements){
        return;
    }
    for(var i=0; i<elements.length; i++){
        scor.utils.hideElement(elements[i]);
    }
}
scor.utils.showElement = function(element) {
    if(!element){
        return;
    }
    element.style.display = '';
}
scor.utils.showElements = function(elements) {
    if(!elements){
        return;
    }
    for(var i=0; i<elements.length; i++){
        scor.utils.showElement(elements[i]);
    }
}

scor.utils.scorFindElementsByNames = function(parent, elementTagName, elementName) {
    var children = parent.getElementsByTagName(elementTagName);
    var ret = [];
    for (var i = 0; i < children.length; i++) {
        if (children[i] && children[i].name === elementName) {
            ret.push(children[i]);
        }
    }
    return ret;
}

scor.utils.getValuesOfSelectedRadio = function(parent,radioName) {
    var radios = scor.utils.scorFindElementsByNames(parent,'input',radioName);
    for(var i=0; i<radios.length; i++){
        if(radios[i].type === 'radio' && radios[i].checked){
            return radios[i].value;
        }
    }
}

scor.utils.getValuesOfSelectedRadioFromDialogBox = function(radioName) {
    return scor.utils.getValuesOfSelectedRadio(scorGetDialogBox(),radioName);
}

scor.utils.getValuesOfSelectedChkBoxes = function (chkBoxes) {
    chkBoxes = chkBoxes ? chkBoxes : [];
    var ret = [];
    for (var key in chkBoxes) {
        if (chkBoxes[key].checked) {
            ret.push(chkBoxes[key].value);
        }
    }
    return ret;
}

scor.utils.appendNoResultFound = function (element) {
    var noResultDiv = document.createElement("div");
    noResultDiv.innerHTML = "<br><br> ${noDataFound}";
    element.appendChild(noResultDiv);
};

function scorGetValue(id) {
    return document.getElementById(id).value;
}
function check(id) {
    document.getElementById(id).checked = true;
}

function uncheck(id) {
    document.getElementById(id).checked = false;
}

scor.utils.deleteOrionListRow = function (listId, itemKey) {
    var rowId = "OrionList.item." + itemKey;

    var row = document.getElementById(rowId);

    if (!row) {
        return;
    }

    OrionEvent.unregisterHandler(row, OrionList.selectRowEvent, 'click', true);

    row.parentNode.removeChild(row);


};

scor.utils.getOrionListKeys = function (listId, listGroupName) {
	var ids = [];
	var listGroupNameId = listGroupName+"_items";
	listGroupNameId = listGroupNameId.replace(/\./g, '\\.');
	var listGroupNameDiv = $j("#"+listId).find("#"+listGroupNameId);
	
	var listGroupNameItemDivs =  $j("#"+listGroupNameId).find(".orionListItem");
	if (listGroupNameItemDivs.size() > 0) {           
            for (var listGroupNameItemIndex = 0; listGroupNameItemIndex < listGroupNameItemDivs.size(); listGroupNameItemIndex++) {
            	 var childItemId = $j(listGroupNameItemDivs).get(listGroupNameItemIndex).id;
            	 var childItemKey = childItemId.replace("OrionList.item.", "");
                 ids.push(childItemKey);
            }
        }    
    return ids;
};

scor.utils.clearMagicListWidget = function (list) {
    var i;

    var rowids = list.getList();

    for (i = 0; i < rowids.length; i++) {
        var rowid = rowids[i];
        var row = $(rowid);
        if (row) {
            list.list[rowid] = null;
            row.parentNode.removeChild(row);
        }
    }
    list.selrow = null;
}

scor.utils.getVosCommonFuncs = function (vo) {
    return {
        "getJSONString" : function() {
            return JSON.stringify(vo);
        },
        "getVO": function() {
            return vo;
        },
        "setProperty" : function(property, value) {
            vo[property] = value;
        },
        "getProperty" : function(property) {
            return vo[property];
        }

    };
}

scor.utils.trim = function(source) {
    if (!(source === undefined || source === null)) {
        source = OrionCore.trim(String(source));
    }
    return source;
}

scor.utils.isNullOrEmpty = function(element){

	if(element === null){
		return true;
	}
	var value = element.value;
	if($j.trim(value).length === 0){
			return true;
		}else{
			return false;
		}
}
scor.utils.OrionAsyncOnFailure = function(msg) {
    msg = msg || 'Failed';
    OrionCore.showPleaseWait(false);
    alert(msg);
    return false;
}


/**
 * This function can be used to make a function object with parameters
 *
 * @param func The function name to which will be called
 * @params [optional - comma separated n arguments] The arguments that will be passed during the function call
 *
 * Example:
 * var fr = partial(f, 1, 2, 3);
 * // now, when you invoke fr() it will invoke f(1,2,3)
 * fr();
 *
 */
scor.utils.partial = function(func /*, 0..n args */) {
    var args = Array.prototype.slice.call(arguments, 1);
    return function() {
        var allArguments = args.concat(Array.prototype.slice.call(arguments));
        return func.apply(this, allArguments);
    };
}

/**
 *
 * Used by several widgets to grab form value pairs
 * @param {obj} form An object containing form fields
 * @return {obj} An object of name value pairs
 *
 */
scor.utils.getFormVals = function(form) {
    var flds = {};
    if (form === null) return flds;
    var fi = form.getElementsByTagName("input");
    for (var i = 0; i < fi.length; i++) {
        if (fi[i].type != "button") {
            if (fi[i].type === "radio" || fi[i].type === "checkbox") {
                if (fi[i].checked) {
                    flds[fi[i].id] = fi[i].value;
                }
            } else {
                flds[fi[i].id] = fi[i].value;
            }
        }
    }
    var ft = form.getElementsByTagName("textarea");
    for (var i = 0; i < ft.length; i++) {
        flds[ft[i].id] = ft[i].value;
    }
    var fs = form.getElementsByTagName("select");
    for (var i = 0; i < fs.length; i++) {
        if (fs[i].getAttribute("multiple") === true || fs[i].getAttribute("multiple") === "true") {
            if (fs[i].options.length > 0) {
                flds[fs[i].id] = new Array();
                for (var j = 0; j < fs[i].options.length; j++) {
                    flds[fs[i].id].push(fs[i].options[j].value);
                }
                ;
            }
        } else {
            if (fs[i].options.length > 0) {
                var si = (fs[i].selectedIndex > 0) ? fs[i].selectedIndex : 0;
                flds[fs[i].id] = fs[i].options[si].value;
            }
        }
    }
    return flds;
}

scor.utils.getRegexForEscapeCharacters = function(character) {
	 var specials = [
		'/', '.', '*', '+', '?', '|',
		'(', ')', '[', ']', '{', '}', '\\','$','^'
	];
	var sre = new RegExp('(\\' + specials.join('|\\') + ')', 'gim');
	var escapedCharacter = character.replace(sre, '\\\\$&'); 
	return new RegExp(escapedCharacter,"g");
	 
}

scor.utils.getTableActionIndexByURLInActionTab = function(url) {
    var scorTableActionIndex = -1;
	for(var j in OrionAction.actionList){
		if (OrionAction.actionList[j].group == true) {
			continue;
		} else if(OrionAction.actionList[j].actionURI.indexOf(url) != -1){
        	scorTableActionIndex = j;
        	break;
        }
    }
    return scorTableActionIndex;
}

scor.utils.setDisabledStateForTableActionHavingUrl = function(url, isDisabled) {
	var orionActions = OrionAction.getActions();
	for(var j in orionActions){
		if(orionActions[j].actionURI.indexOf(url) != -1){
			orionActions[j].disabled = isDisabled;
        	break;
        }
    }
}

scor.vos = scor.vos || {};

scor.vos.Result = function(resObj) {
    var vo = {
        "returnCode":resObj.returnCode.code,
        "msg":resObj.msg,

        "result":resObj.result
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);
    return {
        "common": commonFunc
        ,"getReturnCode": function() {
            return vo.returnCode;
        },"getMsg": function() {
            return vo.msg;
        },"getResult": function() {
            return vo.result;
        },"isSuccess": function() {
            return vo.returnCode === 0;
        },"isFailure": function() {
            return !(this.isSuccess());
        }
    };
};

scor.actions = scor.actions || {};
scor.actions.asyncCounter = 0;

scor.actions.hideWait = function() {

    if (scor.actions.asyncCounter > 0) {
	scor.actions.asyncCounter--;
    }

    if (scor.actions.asyncCounter === 0) {
        OrionCore.showPleaseWait(false);
    }
};

scor.actions.getSecTokenParamLa = function() {
	return "&"+ scor.actions.getSecTokenParam();
};

scor.actions.getSecTokenParam = function() {
	return "orion.user.security.token=" + OrionCore.getSecurityToken();
};

scor.actions.getSecTokenParamLq = function() {
	return "?"+ scor.actions.getSecTokenParam();
};


scor.actions.doAsyncAction = function(action, params, callbackSuccess, callbackfailure, method, isPleaseWaitReqd) {
    method = method ? method : "POST";
    var waitModalHandlingReqd = true; <%-- By default this method would do wait modal handling --%>
    if (typeof isPleaseWaitReqd === 'boolean' && isPleaseWaitReqd === false) {
    	waitModalHandlingReqd = false;
    }
    if(waitModalHandlingReqd === true && OrionCore.isDialogBoxVisible() === false) {
        scor.actions.asyncCounter++;
        OrionCore.showPleaseWait(true);
    }

    OrionCore.doAsyncAction(action,
            params,
            function(result) {
                scor.actions.asyncActionDefSuccess(result, callbackSuccess, waitModalHandlingReqd);
            },
            function() {
                scor.actions.asyncActionDefFailure(callbackfailure, waitModalHandlingReqd);
            },
            method);
};

scor.actions.asyncActionDefSuccess = function(result, callbackSuccess, waitModalHandlingReqd) {
    if(waitModalHandlingReqd === true && OrionCore.isDialogBoxVisible() === false) {
        scor.actions.hideWait();
    }
    var resultObj = JSON.parse(result);
    var resultVO = scor.vos.Result(resultObj);
    if (resultVO.isFailure()) {
    	// In case any please wait layer is activated.
    	OrionCore.showPleaseWait(false);
        OrionCore.setDialogBoxTitle('${scorErrorDialogBoxTitle}');
        OrionCore.showDialogBox(true, resultVO.getMsg(), OrionCore.DIALOG_OK);
        OrionCore.dialogBoxOkHandler = function(){
        	return true;
        }
    }else{
        callbackSuccess(resultVO.getResult(),resultVO.getReturnCode(),resultVO.getMsg());
    }
};

scor.actions.asyncActionDefFailure = function(callbackfailure, waitModalHandlingReqd) {
    if(waitModalHandlingReqd === true && OrionCore.isDialogBoxVisible() === false) {
        scor.actions.hideWait();
    }
    if (typeof callbackfailure === 'function') {
        callbackfailure();
    } else {
        OrionCore.setDialogBoxTitle('${scorErrorDialogBoxTitle}');
        OrionCore.showDialogBox(true, '${scorDefAsyncFailureMsg}', OrionCore.DIALOG_OK);
        OrionCore.dialogBoxOkHandler = function(){
        	return true; 
        }
    }
};


// redefining OrionCore.clickDialogBoxOk function because of BUG in it
if (typeof OrionCore !== 'undefined') {
    OrionCore.clickDialogBoxOk = function()
    {
        var result = true;
        try
        {
            if (OrionCore.dialogBoxOkHandler)
            {
                var temp = OrionCore.dialogBoxOkHandler();
                if (typeof temp === 'boolean')  // this line was "if (temp && temp != null)" which never allowed temp to be
                {                               // false, due to which result could never be assigned a falsy value
                    result = temp;
                }
            }
        }
        catch (exception)
        {
            alert("Exception occurred in OrionCore.dialogBoxOkHandler!");
        }
        finally
        {
            if (result)
            {
                OrionCore.showDialogBox(false);
                OrionCore.clearDialogBoxHandlers();
            }
        }
    }
}

scor.validation.isNetworkPath = function(value){
    var ret = false;
    if(value && value.length >= 2){
      if("\\" === value.charAt(0) && "\\" === value.charAt(1)){
          ret = true;
      }
    }
    return ret;
}

scor.validation.validatePath = function(fieldValue, os){
    var WIN_MAX_PATH_LENGTH = 1024;
    var re;
    var isValid = true;
    var msg = "";

    if(fieldValue === ''){
        isValid = false;
        msg = "${valFilterEmpty}";
    }

    if (os === "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>") {

        if (isValid && fieldValue.length > WIN_MAX_PATH_LENGTH) {
            isValid = false;
            msg = "${valFileWinMaxLenghtExceed}";
        }

        re = new RegExp("(^[^\\/\\\\:\\*\\?\"<>|]:\\\\)|(^\\\\\\\\)|(^\\*$)|(^%[a-zA-Z0-9_ ]+(\\([xX]{1}86\\))?%(\\\\|$))", "");
        if (isValid && !re.test(fieldValue)) {
            isValid = false;
            msg = OrionCore.escapeHtml("${valFileWinfullyQualifiedReq}");
        }

        re = new RegExp("((.\\*)$)|((.\\*\\\\)$)", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinNoStarAtEnd}";
        }

        re = new RegExp("[/:\\?\"<>\\|]", "");
        if (isValid && re.test(fieldValue.slice(3))) {
            isValid = false;
            msg = "${valFileNotValid}";
        }

        re = new RegExp("([^\\\\]\\*)", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinStarNotAllowedAtPos}";
        }

        re = new RegExp("(\\*[^\\\\])", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinStarNotAllowedAtPos}";
        }

        re = new RegExp("(\\\\\\.\\\\)", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinCurrDirNotAllowed}";
        }


        re = new RegExp("(\\\\\\\\)", "");
        if (isValid && re.test(fieldValue.slice(1))) {
            isValid = false;
            msg = "${valFileWinMultBSlashesNotAllowed}";
        }

        re = new RegExp("(\\\\\\.)$", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinCurrDirNotAllowed}";
        }


    } else if (os === "<%=CommonConstants.POLICY_GROUP_OS.UNIX.getValue()%>") {
		if(isValid && (fieldValue.charAt(0) !== '/')){
			isValid=false;
			msg = "${shouldStartWithSlash}";
		}
		if (fieldValue && fieldValue != null)
    	{	var INVALID_UNIX_DIRECTORYNAME_CHARS = [':','?','<','>','|']
	        var fpath = OrionCore.trim(fieldValue);
	        if (fpath.length != 0)
	        {
	            for (var i = 0; i < INVALID_UNIX_DIRECTORYNAME_CHARS.length; i++)
	            {
	                var ch = INVALID_UNIX_DIRECTORYNAME_CHARS[i];
	                if (fpath.indexOf(ch) >= 0)
	                { isValid =  false;
	                  msg = "${valFileNotValid}";
	                }
	            }
	            isvalid =  true;
	         }
        }
        re = new RegExp("((.\\*)$)|((.\\*\\/)$)", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinNoStarAtEnd}";
        }
        re = new RegExp("([^\\/]\\*)", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinStarNotAllowedAtPos}";
        }

        re = new RegExp("(\\*[^\\/])", "");
        if (isValid && re.test(fieldValue)) {
            isValid = false;
            msg = "${valFileWinStarNotAllowedAtPos}";
        }
        if(fieldValue === "*"){
        isValid = true;
    	}
    }
    return new scor.validation.constructors.ValidationResult(isValid,msg);
};

scor.validation.windowsFileNameCharactersValidater =function(fieldValue){
  var INVALID_WIN_FILENAME_CHARS = [':','?','<','>','|', '*', '"', '\\', '/'];
	var isValid = true;
	var msg="";
	if (fieldValue && fieldValue != null)
    	{	
	        var trimmedValue = OrionCore.trim(fieldValue);
	        if (trimmedValue.length != 0)
	        {
	          for (var i = 0; i < INVALID_WIN_FILENAME_CHARS.length; i++)
	            { var ch = INVALID_WIN_FILENAME_CHARS[i];
	                if (trimmedValue.indexOf(ch) >= 0)
	                { 	
	               		 	isValid=false;
	                }
	            }
	            
	         }
        }
         var validationObj = new scor.validation.constructors.ValidationResult(isValid,msg);
    			
   				return validationObj;
  };

scor.validation.sha1Validater = function(inputElement){
    var re = new RegExp("^([0-9a-fA-F])+$", "");
    var isValid = re.test(inputElement.value);
    if(isValid){
        isValid = inputElement.value.length === 40;
    }
    var msg = '${validSHA1}';
    var validationObj = new scor.validation.constructors.ValidationResult(isValid,msg);
    scor.validation.processValidationResult(validationObj,inputElement);
    return validationObj;
};

scor.validation.sha256Validater = function(inputElement){
    var re = new RegExp("^([0-9a-fA-F])+$", "");
    var isValid = re.test(inputElement.value);
    if(isValid){
        isValid = inputElement.value.length === 64;
    }
    var msg = '${validSHA256}';
    var validationObj = new scor.validation.constructors.ValidationResult(isValid,msg);
    scor.validation.processValidationResult(validationObj,inputElement);
    return validationObj;
};

scor.validation.emptyValidater = function(element){
    var isValid = OrionValidate.isNotEmpty(element.value);
    var msg = '${reqFields}';
    var validationObj = new scor.validation.constructors.ValidationResult(isValid,msg);
    scor.validation.processValidationResult(validationObj,element);
    return validationObj;
};

scor.validation.tagValidater = function(tagElement){
    var isValid = OrionValidate.isNotEmpty(tagElement.value);
    var msg = '${emptyTagMsg}';
    var validationObj = new scor.validation.constructors.ValidationResult(isValid,msg);
    scor.validation.processValidationResult(validationObj,tagElement);
    return validationObj;
};

scor.validation.duplicateValidater = function(list,elementsToCheck,msg){
    var isDuplicate = false;
    var rows = list.getRows();
    for (var rowKey in rows){
        var row = rows[rowKey];
        if (row != null && row != undefined){
            var isThisRowDuplicate = true;
            for(var i=0; i<elementsToCheck.length; i++){
                if(row[elementsToCheck[i].id] !== elementsToCheck[i].value){
                    isThisRowDuplicate = false;
                    break;
                }
            }
            if(isThisRowDuplicate){
                isDuplicate = true;
                break;
            }
        }
    }
    var validationObj = new scor.validation.constructors.ValidationResult(!isDuplicate,msg);
    scor.validation.processValidationResult(validationObj,elementsToCheck[0]);
    return validationObj;
};

scor.validation.constructors.ValidationResult = function(isValid,msg){
    this.isValid = isValid;
    this.msg = msg;
};
scor.validation.constructors.ValidationResult.prototype = {
    getIsValid : function(){
        return this.isValid;
    },isInvalid : function(){
        return !this.isValid;
    },
    getMsg : function(){
        return this.msg;
    },
    setIsValid : function(isValid){
        this.isValid = isValid;
    },
    setMsg : function(msg){
        this.msg = msg;
    },
    constructor : scor.validation.constructors.ValidationResult
};

scor.validation.getSuccessValidationResult = function(){
    return new scor.validation.constructors.ValidationResult(true,'');
};



scor.validation.processValidationResult = function(validationObj,sourceElement){
    var errorDiv = scorFindElementById(scorGetDialogBox(), 'div', 'error_include');
    if (validationObj.getIsValid()) {
        errorDiv.innerHTML = "";
        errorDiv.style.display = "none";
    } else {
        errorDiv.innerHTML = validationObj.getMsg();
        errorDiv.style.display = "block";
        if(sourceElement){
            OrionCore.focusOn(sourceElement);
        }
    }
};
scor.validation.setValidationMessageInDiv = function(validationObj, sourceElement, errorDiv){
    if (validationObj.getIsValid()) {
        errorDiv.innerHTML = "";        
    } else {
        errorDiv.innerHTML = validationObj.getMsg();
        errorDiv.style.display = "block";
        if(sourceElement){
            $j(sourceElement).focus();
        }
    }
};

scor.validation.checkIfExistsInTheTrustedUserlist = function(list,elementsToCheck,msg){
    var isExisting = false;
    var rows = list.getRows();
    for (var rowKey in rows){
        var row = rows[rowKey];
        if (row != null && row != undefined){
            var isThisRowExisting = true;
            for(var i=0; i<elementsToCheck.length; i++){
                if(row[elementsToCheck[i].id] !== elementsToCheck[i].value){
                    isThisRowExisting = false;
                    break;
                }
            }
            if(isThisRowExisting){
                isExisting= true;
                break;
            }
        }
    }
    var validationObj = new scor.validation.constructors.ValidationResult(!isExisting,msg);
    scor.validation.processValidationResult(validationObj,elementsToCheck[0]);
    return validationObj;
};

scor.validation.validateTextForCharacters = function(element, invalidCharactersArray){
	var fieldValue = $j(element).attr('value');
	var isValid = true;
	var msg="";
	if (fieldValue && fieldValue != null)
    	{	
	        var fpath = OrionCore.trim(fieldValue);
	        if (fpath.length != 0)
	        {
	          for (var i = 0; i < invalidCharactersArray.length; i++)
	            { var ch = invalidCharactersArray[i];
	                if (fpath.indexOf(ch) >= 0)
	                { 	
	               		var regexp = scor.utils.getRegexForEscapeCharacters(ch);
	               		fpath = fpath.replace(regexp, "");
	                  	$j(element).attr('value', fpath);
	                  	isValid=false;
	                }
	            }
	            
	         }
        }
         var validationObj = new scor.validation.constructors.ValidationResult(isValid,msg);
    			
   				return validationObj;
};

function addOrEditOkHandler()
{
    epoEnableApplyButton();
    OrionCore.dialogBoxOkHandler = existingOkHanlder;
    if (existingOkHanlder != null)
    {
        existingOkHanlder();
        existingOkHanlder = null;
    }
}
//This is a workaround to take care of dirty form check.
scor.utils.reSetInputValue=function(fldId){
	OrionForm.putOriginalFormValue(fldId,$(fldId).value);
};

// Sets dialog container and contentDiv dimensions.
scorSetDialogSize=function(height, width, visibility){
		if(visibility){
			OrionCore.setDialogBoxVisibility(visibility, height, width);   
		}else{
			OrionCore.setDialogBoxVisibility(true, height, width);  
		}      
}

function listWidgetformatCallback (key,val){

switch(key) {
      case "filter":
        if(val == "Include") {
          return '<orion:message key="policy.mon.include" escape="javascript"/>';
        }
	if(val == "Exclude") {
          return '<orion:message key="policy.mon.exclude" escape="javascript"/>';
        } 
	return val;
        break;
     case "fileTracking":
        if(val == "Enabled") {
          return '<orion:message key="policy.mon.filetracking.enabled" escape="javascript"/>';
        }
	if(val == "Disabled") {
          return '<orion:message key="policy.mon.filetracking.disabled" escape="javascript"/>';
        } 
	return val;
        break;
    case "typeValue":
        if(val == "none") {
          return '<orion:message key="scor.policy.awl.updater.type.none" escape="javascript"/>';
        }
	if(val == "parent") {
          return '<orion:message key="scor.policy.awl.updater.type.parent" escape="javascript"/>';
        }
	if(val == "library") {
          return '<orion:message key="scor.policy.awl.updater.type.library" escape="javascript"/>';
        } 
 	return val;
        break;
  case "inherit":
        if(val == "yes") {
          return '<orion:message key="scor.y" escape="javascript"/>';
        }
	if(val == "no") {
          return '<orion:message key="scor.n" escape="javascript"/>';
        }
	return val; 
        break;
    case "caseSensitive":
        if(val == "yes"){
            return '<orion:message key="scor.y" escape="javascript"/>';
        }
        if(val == "no"){
            return '<orion:message key="scor.n" escape="javascript"/>';
        }
        return val;
        break;
  case "log":
        if(val == "yes") {
          return '<orion:message key="scor.y" escape="javascript"/>';
        }
	if(val == "no") {
          return '<orion:message key="scor.n" escape="javascript"/>';
        } 
	return val;
        break;
 case "binaryAllowBanId":
        if(val == "Allow") {
          return '<orion:message key="scor.awl.binary.add.Allow" escape="javascript"/>';
        }
	if(val == "Ban") {
          return '<orion:message key="scor.awl.binary.add.Ban" escape="javascript"/>';
        } 
	return val;
        break;
 case "binarySearchTypeId":
        if(val == "File Name") {
          return '<orion:message key="scor.awl.binary.add.byName" escape="javascript"/>';
        }
	if(val == "Checksum") {
          return '<orion:message key="scor.awl.binary.add.byChkSum" escape="javascript"/>';
        }
	if(val == "Checksum256") {
        return '<orion:message key="scor.awl.binary.add.byChkSum256" escape="javascript"/>';
      } 
	return val;
        break;
case "updater":
        if(val == "Yes" || val == "true") {
          return '<orion:message key="scor.y" escape="javascript"/>';
        }
	if(val == "No" || val == "false") {
          return '<orion:message key="scor.n" escape="javascript"/>';
        } 
	return val;
        break;
case "trustedUsersTypeId":
        if(val == "User") {
          return '<orion:message key="scor.awl.trustedUsers.user" escape="javascript"/>';
        }
	if(val == "Group") {
          return '<orion:message key="scor.awl.trustedUsers.group" escape="javascript"/>';
        } 
	return val;
        break;		
case "includeExcludeAction":
     if(val == "Include") {
          return '<orion:message key="policy.mon.include" escape="javascript"/>';
        }
	if(val == "Exclude") {
          return '<orion:message key="policy.mon.exclude" escape="javascript"/>';
        } 
	return val;
        break;
case "updaterBy":
    if(val == "Name") {
         return '<orion:message key="scor.policy.awl.updater.updaterBy.value.filename" escape="javascript"/>';
       }
	if(val == "Checksum") {
         return '<orion:message key="scor.policy.awl.updater.updaterBy.value.checksum" escape="javascript"/>';
       }
	if(val == "Checksum256") {
        return '<orion:message key="scor.policy.awl.updater.updaterBy.value.checksum256" escape="javascript"/>';
      } 
	return val;
       break;
   case "makeByHiddenId":
	if(val == "checksum") {
         return '<orion:message key="scor.policy.awl.updater.updaterBy.value.checksum" escape="javascript"/>';
       }
	if(val == "checksum256") {
        return '<orion:message key="scor.policy.awl.updater.updaterBy.value.checksum256" escape="javascript"/>';
      } 
	return val;
      break;       
case "optionString":
	var commaSplitted = val.split(',');
	if(commaSplitted.length>1) {
	//	var msg1=scor.utils.optionStringMap[commaSplitted[0].trim()];
	//	var msg2=scor.utils.optionStringMap[commaSplitted[1].trim()];
	//	if(msg1 === msg1){ 
	//	var msgForDepByPass=msg1+", "+msg2;
		return scor.utils.optionStringMap["dep_bypass_inherit"];
	//	}
		
	} else {
		return scor.utils.optionStringMap[val];
	}
    break;
    
    default:
		return OrionCore.escapeHtml(val);
    };

}


scor.utils.fixYUIFileUploadOnIe = function () {
	
	YAHOO.util.Connect.createFrame = function (secureUri){

		// IE does not allow the setting of id and name attributes as object
		// properties via createElement().  A different iframe creation
		// pattern is required for IE.
		var frameId = 'yuiIO' + this._transaction_id,
                        dM = document.documentMode ? document.documentMode : false,
            // BZ 878629: YUI had a check for IE9 that should have been for IE9+.
            // We've switched the logic to ensure IE10 (and above, presumably) work with async file upload.
			modernIe = (dM >= 9) ? true : false,
			io;

		if(YAHOO.env.ua.ie && !modernIe){
			io = document.createElement('<iframe id="' + frameId + '" name="' + frameId + '" />');

			// IE will throw a security exception in an SSL environment if the
			// iframe source is undefined.
			if(typeof secureUri == 'boolean'){
				io.src = 'javascript:false';
			}
		}
		else{
			io = document.createElement('iframe');
			io.id = frameId;
			io.name = frameId;
		}

		io.style.position = 'absolute';
		io.style.top = '-1000px';
		io.style.left = '-1000px';

		document.body.appendChild(io);
		YAHOO.log('File upload iframe created. Id is:' + frameId, 'info', 'Connection');
	};
};

scor.utils.counter = function(startIndex){
	var counter = (startIndex) ? startIndex : 0;

	return {
		"increment" : function(){
			counter = counter + 1;
		},

		"decrement" : function(){
			counter = counter - 1;
		},

		"getCounter" : function(){
			return counter;
		}	
	};
};
scor.validation.validatePathForSkipList = function(propertiesOfInputBox, os){
	var WIN_MAX_PATH_LENGTH = 1024;
	var re;
    var isValid = true;
    var msg = "";
    var fieldId=propertiesOfInputBox.id;
    var fieldValue=propertiesOfInputBox.value;
    if(fieldValue === ''){
        isValid = false;
        msg = "";
    }

    if (isValid && os === "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>") {
    	   var regexForRelativePath=/^([a-zA-Z]\:([^\\]+\\)*[^\/:"'<>|]+([^\/:'"<>|]+)$)|(([^\\]+\\)*[^\/:"'<>|]+([^\/:'"<>|]+)$)/g;
	    	if (isValid && fieldValue.length > WIN_MAX_PATH_LENGTH) {
	            isValid = false;
	            msg = "${valFileWinMaxLenghtExceed}";
	        }
			if(isValid && fieldId !== "filePath_skipSolidification"){
	        	re = new RegExp("([^\\\\]\\*)", "");
	        	if (isValid && re.test(fieldValue)) {
	            	isValid = false;
	            	msg = "${valFileWinStarNotAllowedAtPos}";
	        	}
			}
	        re = new RegExp("(\\\\\\\\)", "");
	        if (isValid && re.test(fieldValue.slice(1))) {
	            isValid = false;
	            msg = "${valFileWinMultBSlashesNotAllowed}";
	        }
        if(isValid && (fieldId === "filePath_skipFileOperation" || fieldId === "filePath_skipFileOperation_f" || fieldId === "filePath_skipDenyWrite"  || fieldId === "filePath_skipChangeTracking"))
        	{   
	            if (isValid && !regexForRelativePath.test(fieldValue)) {
	            	isValid = false;
	            	msg = OrionCore.escapeHtml("${fileRelativePath}");
	            }
        	}
         if(isValid && (fieldId === "filePath_process_ctx_bypass" || fieldId === "parentPath_process_ctx_bypass")) {
        	    var re=/^[^\\/:\*\?"<>\|]+$/; 
	            if (isValid && !re.test(fieldValue)) {
	            	isValid = false;
	                msg = "${filePath}";
	            }
         }
         if(fieldId === "filePath_skipVolume"){
        	 var regexWithbckSlash=/^([a-zA-Z]:\\)$/; 
        	 var regexWithoutbckSlash=/^[A-Za-z]:$/; 
            if (isValid)
            	{  
            	if(!regexWithbckSlash.test(fieldValue)){
            		if(!regexWithoutbckSlash.test(fieldValue)){
            				isValid = false;
                            msg = OrionCore.escapeHtml("${volumePath}");	
            		}
                 }
              }           	
           }
         if(fieldId === "filePath_skipSolidification"){
        	<%-- Wildcard support for skip solidification --%>  
        	 var reForDriveWithPath=/^([A-Za-z]:\\|([A-Za-z?]:)(\\[^\/:"<>|\\]*[^\/:"<>|\\. ])+)\\?$/;
        	 if(isValid)
        		 {
        			    	if(!reForDriveWithPath.test(fieldValue)){
        			    		isValid = false;
        		                msg = OrionCore.escapeHtml("${valFileNotForDashs}");   		 
        		            }
                  }
         }
        if(fieldId === "filePath_skipRegistry" && fieldValue){
        		isValidObj = isRegistryValid(fieldValue, os);
                isValid = isValidObj.isValid;
                if(!isValid)
                	{
                	if(!regexForRelativePath.test(fieldValue))
                		{
                		msg = OrionCore.escapeHtml("${registryPath}");
                		}
                	}
             }
        } 
    return new scor.validation.constructors.ValidationResult(isValid,msg);
};

scor.validation.processValidationResultForSkipList = function(validationObj,sourceElement,errorDivId){
    var errorDiv = scorFindElementById(scorGetDialogBox(), 'div', errorDivId);
    if (validationObj.getIsValid()) {
        errorDiv.innerHTML = "";
        errorDiv.style.display = "none";
        return true;
    } else {
        errorDiv.innerHTML = validationObj.getMsg();
        errorDiv.style.display = "block";
        if(sourceElement){
          //  OrionCore.focusOn(sourceElement);
            return false;
        }
    }
};

scor.utils.isRecordPresentInMFSTable = function(tableId) {
	var scorTable = MFSTable.get(tableId);
	if (!scorTable) {
		return false;
	}
	if (scorTable.isEmpty()) {
		return false;
	}
	
	var firstData = scorTable.data.dataSet[0];
	if (!firstData) {
		return false;
	}
	
	var uid = firstData.uid;
	if (uid === null || uid === undefined) {
		return false;
	}
	return true;
};

//specify MFS tableId, totalTimeSpent.
scor.utils.selectFirstRowOfMFSTable = function(tableId, totalTimeSpent) {
	totalTimeSpent = totalTimeSpent || 0;
	// We will not do any thing after 2 minutes.
	if (totalTimeSpent >= 120000) {
		return;
	}
	
	if ((totalTimeSpent == 0) || !scor.utils.isRecordPresentInMFSTable(tableId)) {
		
		setTimeout(function() { 
			scor.utils.selectFirstRowOfMFSTable(tableId, (totalTimeSpent+500) )
			} , 500); // totalTimeSpent when the method gets called = currentTotalTime + timeInterval
		return;
	}
	
	var scorTable = MFSTable.get(tableId);
	var datasetZero = scorTable.data.dataSet[0];
	var uid = scorTable.data.dataSet[0].uid;
	scorTable.setSelected(uid, true);
};

	scor.validation.validatePathForRegisteredServers = function(propertiesOfInputBox) {
		var regexForRegisteredServers;
		var isValid = true;
		var msg = "";
		var fieldId = propertiesOfInputBox.id;
		var fieldValue = propertiesOfInputBox.value;
		if (fieldValue === '') {
			isValid = false;
			msg = "${reqServerAddress}";
		}
		if (isValid){
		regexForRegisteredServers = /^(http:\/\/www\.|https:\/\/www\.|http:\/\/|https:\/\/)[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z0-9]{1,5}(:[0-9]{1,5})?(\/.*)?$/;
		if (!regexForRegisteredServers.test(fieldValue)) {
			isValid = false;
			msg = "${serverAddress}";
		}
		}
		return new scor.validation.constructors.ValidationResult(isValid, msg);
	};

	scor.validation.processValidationResultForRegisteredServers = function(validationObj, sourceElement, errorDivId) {
		var returnFlag=scor.validation.handleDisplayErrorMsg(validationObj, sourceElement, errorDivId);
		if(returnFlag){
			 $j("#error_"+sourceElement).attr("errorFlag","disable");
			}
		else {
			 $j("#error_"+sourceElement).attr("errorFlag","enable");
			}
		return returnFlag;
	 }
	scor.validation.handleDisplayErrorMsg=function(validationObj, sourceElement, errorDivId) {
		return scor.validation.processValidationResultForSkipList(validationObj, sourceElement, errorDivId);
		
	}
	scor.validation.wildCardCCPolicy = function(fieldValue, os){
	    var re;
	    var isValid = true;
	    var msg = "";
	    if (os === "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>") {
	        re = new RegExp("(^[^\\/\\\\:\\*\"<>|]:\\\\)|(^\\\\\\\\)|(^%[a-zA-Z0-9_ ]+(\\([xX]{1}86\\))?%(\\\\|$))", "");
	        if (isValid && !re.test(fieldValue)) {
	            isValid = false;
	            msg = OrionCore.escapeHtml("${FileOrPathNotValid}");
	        }
	    }
	    return scor.common.validation(isValid ,fieldValue,os,msg);
	};
	scor.validation.UpdaterWildCardValidation = function(fieldValue, os){
	    var isValid = true;
	    var msg = "";
	    if (os === "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>") {
	    	 var regExNotStartWithStar = new RegExp("(^[\\/\\\\:\\*\"<>|]:\\\\)|(^(\\*){1})", "");
			 var regNotContainOnlyQusMark=/^([\\?]+)$/;	// check for ? mark	
		    if (regExNotStartWithStar.test(fieldValue) || regNotContainOnlyQusMark.test(fieldValue)) {
		            isValid = false;
		            msg = OrionCore.escapeHtml("${FileOrPathNotValid}");
		        }
	    }
	    return scor.common.validation(isValid ,fieldValue,os,msg);
	};
	scor.common.validation=function(isValid, fieldValue, os, msg ){
		    var WIN_MAX_PATH_LENGTH = 1024;
		    var re;
		  if (os === "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>") {
			  if (isValid && fieldValue.length > WIN_MAX_PATH_LENGTH) {
		            isValid = false;
		            msg = "${valFileWinMaxLenghtExceed}";
		        }
			  re = new RegExp("(\\\\\\.\\\\)", "");
		        if (isValid && re.test(fieldValue)) {
		            isValid = false;
		            msg = "${valFileWinCurrDirNotAllowed}";
		        }
		        re = new RegExp("(\\\\\\\\)", "");
		        if (isValid && re.test(fieldValue.slice(1))) {
		            isValid = false;
		            msg = "${valFileWinMultBSlashesNotAllowed}";
		        }

		        re = new RegExp("(\\\\\\.)$", "");
		        if (isValid && re.test(fieldValue)) {
		            isValid = false;
		            msg = "${valFileWinCurrDirNotAllowed}";
		        }
		  } 
		  return new scor.validation.constructors.ValidationResult(isValid,msg);
	 };
	 scor.validation.IsValidDomainUserPath=function(fieldValue,os){
		    var re;
		    var isValid = true;
		    var msg = "";
		    if (os === "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>") {
			    re=/^(\\\\[^\s\\]+|[A-Za-z]:\\|%([^=\s]|[^=]+[^=\s]+)%|(\\\\[^\s\\]+|[A-Za-z]:|%([^=\s]|[^=]+[^=\s]+)%)(\\[^\/:"<>|\\]*[^\/:"<>|\\. ])+)\\?$/
			    if (!re.test(fieldValue)) {
					isValid = false;
					msg = OrionCore.escapeHtml("${FileOrPathNotValid}") + "<br/>" +
							OrionCore.escapeHtml("${valFileWinfullyQualifiedReq}");
			    }
		    }
		    return scor.common.validation(isValid ,fieldValue,os,msg);
		};
		
		scor.common.validation.showWarningOnStarCharactor=function(validationObj,fieldValue,os){
		    if (os === "<%=CommonConstants.POLICY_GROUP_OS.WIN.getValue()%>") { 
		    var warningDiv = scorFindElementById(scorGetDialogBox(), 'div', 'scor_warningDiv');
			 if (validationObj.getIsValid() && fieldValue.indexOf('*') > -1) {
			       warningDiv.innerHTML = "${wildCardWarningMsgs}";
				   warningDiv.style.display = "block";
			    } else {
					warningDiv.innerHTML = "";
			    	warningDiv.style.display = "none";
			    }
			  }
		}
		function ScorException(message) {
			   this.message = message;
			   this.name = "ScorException";
		}
</script>
