<%-- COPYRIGHT:		Copyright (C) 2015 McAfee, Inc.  All rights reserved--%>
<%@ page import="com.mcafee.scor.common.URLConstants"%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>

<orion:core>
	<orion:corehead />
	<orion:corebody>
		<orion:navigation helpId="${helpPageId}"/>
		<orion:content>
			<orion:script context="/core" src="/corebundle.js" />
			<orion:script context="/core" src="/core.js" />
			<orion:script context="/core" src="/formlib.js" />
			<orion:script context="/core" src="/wizardlib.js" />

			<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>" />

			<orion:message key="scor.event.exclusion.wizardTitle"
				var="exclusionWizardTitle" escape="none" />

			<orion:vbox>
				<orion:box id="exclusionWizardDiv" height="24">
					<orion:wizard id="exclusionWizard" currentStep="selectRuleGroup"
						wizardInfo="${exclusionWizardInfo}" text="${exclusionWizardTitle}"
						cancelURI="<%=URLConstants.NAVIGATE_TO_EVENTS_PAGE%>"
						editMode="false" />
				</orion:box>

				<%@ include file="../common/selectRuleGroup.jsp"%>

				<orion:footerbar>
					<orion:previous-next id="exclusionPrevNext"
						currentStep="selectRuleGroup" wizardInfo="${exclusionWizardInfo}" />
				</orion:footerbar>


			</orion:vbox>
		</orion:content>
	</orion:corebody>
	<script type="text/javascript">
		var scor = scor || {};
		scor.exclusion = scor.exclusion || {};
		scor.exclusion.rules = scor.exclusion.rules || {};
		scor.exclusion.rules.init = function() {
				if($('addToNewRuleGroupOption').checked=='true'){
    	    	OrionWizard.setFinalButtonEnabled(false);
        		}
        		scor.rg.sel.setOnValidCallback(function(){
 					OrionWizard.setFinalButtonEnabled(true);
				});
				scor.rg.sel.setOnInvalidCallback(function(){
 					OrionWizard.setFinalButtonEnabled(false);
				});
            
    	if('${scorRuleGroupOption}' == 'addToexisting' && $('scorGroupsSelectId').length != 0){
    	$('addToExistingRuleGroupOption').checked='true';
    	OrionWizard.setFinalButtonEnabled(true);
 		scor.rg.sel.enableDisableTxtBox();
    	var groupSelect = document.getElementById('scorGroupsSelectId');
				for (var i=0; i<groupSelect.length; i++){
                var option = groupSelect[i];
                option.selected = undefined;
                if(option.value == '${scorSelectedGroupId}'){
                    option.selected = 'selected';
                    groupSelect.selectedIndex = i;
                }
             }
          }else{
          	$('addToNewRuleGroupOption').checked='true';
          	OrionWizard.setFinalButtonEnabled(false);
          }
    	    };
    
    OrionCore.addLoadHandler(scor.exclusion.rules.init);  
		
		
		
        
    </script>
</orion:core>
