<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved. -->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@page import="com.mcafee.scor.observationmode.ObservationModeConstants"%>
<orion:message key="scor.event.link.createPolicy" var="createPolicyLinkVar" />
<orion:message key="scor.event.view.similarPolicyRequests" var="showSimilarPDRequestsLinkVar" />
<orion:message key="scor.event.view.inventory" var="showInventoryLinkVar" />
<orion:message key="scor.event.view.viewTIEReputation" var="viewTIEReputationLinkVar" />
<orion:message key="scor.event.link.showThrottlingEvents" var="showThrottlingEventsVar" />
<orion:message key="scor.event.link.showInventoryOfThrottlingEvent" var="showInventoryForThrottlingEventVar" />
<orion:message key="scor.event.link.showPDRequestsOfThrottlingEvent" var="showPDRequestsForThrottlingEventVar" />
<orion:message key="scor.event.detail.msg.clickLinkToReviewEventsForThrottling" var="msgClickLinkToReviewEventsForThrottling" />
<orion:message key="scor.event.detail.msg.clickLinkToReviewPDRequestsForThrottling" var="msgClickLinkToReviewPDRequestsForThrottling" />
<orion:message key="scor.event.detail.msg.linkMightNotListData" var="msgLinkMightNotListData" />
<orion:message key="scor.event.detail.msg.consecutiveThrottledAndDroppedEvents" var="msgConsecutiveThrottlingAndDroppedEvents" />
<orion:message key="scor.event.detail.msg.eventsNotYetRecievedFromEndPoint" var="msgEventsNotYetRecievedFromEndPoint" />
<orion:message key="scor.event.detail.msg.pdRequestsNotYetRecievedFromEndPoint" var="msgPDRequestsNotYetRecievedFromEndPoint" />


<orion:hbox>
	<orion:box>
		<br/>
		<c:if test="${showLinkOnUI}" >
			<a href="javascript:scorAWLPolicyForEventId(${eventId})" title="${createPolicyLinkVar}">${createPolicyLinkVar}</a>
			<br/>
		</c:if>
		<c:if test="${showPDLinkOnUI}" >
			<a href="/SOLIDCORE_META/showSimilarPolicyDiscoveryRequestsForEvent.do?reqParamEventId=${eventId}${scor_csrf_param_la}" title="${showSimilarPDRequestsLinkVar}">${showSimilarPDRequestsLinkVar}</a>
			<br/>
		</c:if>
		<c:if test="${showInventoryLinkOnUI}" >
			<a href="/SOLIDCORE_META/executeShowBinariesForSha1.do?binarySha1=${evtFileSHA1}${scor_csrf_param_la}" title="${showInventoryLinkVar}">${showInventoryLinkVar}</a>
			<br/>
		</c:if>
		<c:if test="${showLinkToTIE}" >
			<a href="/SOLIDCORE_META/evtShowReputationOnTIE.do?sha1=${evtFileSHA1}${scor_csrf_param_la}" title="${viewTIEReputationLinkVar}">${viewTIEReputationLinkVar}</a>
			<br/>
		</c:if>
		<c:if test="${showThrottlingEventsLink}" >
			<a href="/SOLIDCORE_META/showThrottlingEventsDescription.do?uid=${eventId}${scor_csrf_param_la}" title="${showThrottlingEventsVar}">${showThrottlingEventsVar}</a>
			<br/>
			<br/>
			<table>
				<tr>
					<td>&nbsp;${msgClickLinkToReviewEventsForThrottling}</td>
				</tr>
				<tr>
					<td>&nbsp;${msgLinkMightNotListData}</td>
				</tr>
				<tr>
					<td>&nbsp;&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;${msgConsecutiveThrottlingAndDroppedEvents}</td>
				</tr>
				<tr>
					<td>&nbsp;&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;${msgEventsNotYetRecievedFromEndPoint}</td>
				</tr>
			</table>
		</c:if>
		<c:if test="${showInventoryForThrottlingEventLink}" >
			<a href="/SOLIDCORE_META/showInventoryOfThrottlingEvent.do?uid=${eventId}${scor_csrf_param_la}" title="${showInventoryForThrottlingEventVar}">${showInventoryForThrottlingEventVar}</a>
			<br/>
		</c:if>
		<c:if test="${showPDRequestsForThrottlingEventLink}" >
			<a href="/SOLIDCORE_META/executeShowSelfApprovalRequests.do?uid=${eventId}${scor_csrf_param_la}" title="${showPDRequestsForThrottlingEventVar}">${showPDRequestsForThrottlingEventVar}</a>
			<br/>
			<br/>
			<table>
				<tr>
					<td>&nbsp;${msgClickLinkToReviewPDRequestsForThrottling}</td>
				</tr>
				<tr>
					<td>&nbsp;${msgLinkMightNotListData}</td>
				</tr>
				<tr>
					<td>&nbsp;&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;${msgConsecutiveThrottlingAndDroppedEvents}</td>
				</tr>
				<tr>
					<td>&nbsp;&nbsp;*&nbsp;&nbsp;&nbsp;&nbsp;${msgPDRequestsNotYetRecievedFromEndPoint}</td>
				</tr>
			</table>
		</c:if>
	</orion:box>
</orion:hbox>

<script type="text/javascript">

            function scorAWLPolicyForEventId(eventId){	            	
            		OrionCore.doAction("<%=URLConstants.OBSERVATION_SUGGESTION_FOR_EVENT_ID_URL%>", ["uid",eventId], "GET");                  	
            }

            
</script>