<%-- COPYRIGHT:		Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved--%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="com.mcafee.scor.common.URLConstants"%>
<%@ page import="com.mcafee.scor.event.EventConstants"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>
<%@page import="com.mcafee.scor.inventory.InventoryConstants"%>

<orion:message key="scor.selfapproval.createCustomPolicy.save" var="savePolicyTxt" escape="None"/>
<orion:message key="scor.selfapproval.createCustomPolicy.cancel" var="cancelPolicyTxt" escape="None"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_DISPLAY_KEY" var="eventDisplayNameVar" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_DENY_REASON_ID" var="denyReasonVar" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_PAR_PROC_NAME" var="parentProcessNameVarHtml" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_PROG_NAME" var="programNameVar" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.HOST_NAME" var="systemNameVar" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_ORIG_USER_NAME" var="userNameVar" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.FILE_NAME" var="objectNameVar" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_REPUTATION_SCORE" var="reputationAtTimeOfEventVarHtml" escape="html"/>
<orion:message key="scor.event.createPolicyTitle" var="createPolicyTitleVar" escape="none"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_FILE_SHA1" var="binarySHA1" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_FILE_SHA256" var="binarySHA256" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_FILE_MD5" var="binaryMD5" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_PROCESS_SHA1" var="processSHA1" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_PROCESS_SHA256" var="processSHA256" escape="html"/>
<orion:message key="scor.SCOR_EVENTS.da.EVT_PROCESS_MD5" var="processMD5" escape="html"/>
<orion:message key="scor.inventory.da.effectiveLevel" var="customTrustLevel" escape="html"/>
<orion:message key="scor.inventory.da.certSubject" var="certificateSubject" escape="html"/>
<orion:message key="scor.inventory.detail.showFullBinaryPath" var="showFullBinaryPathLabelJS" escape="javascript" />
<orion:message key="scor.cert.title" var="certificateTitleLabel" escape="html" />
<orion:message key="scor.cert.title" var="certificateTitleLabelJS" escape="javascript" />
<orion:message key="scor.reputation.title" var="detailTitleLabelJS" escape="javascript" />
<orion:message key="scor.cert.subject" var="subjectLabel" escape="html" />
<orion:message key="scor.cert.issuedby" var="issuedByLabel" escape="html" />
<orion:message key="scor.cert.reputation" var="certReputationLabel" escape="html" />
<orion:message key="scor.cert.reputationSource" var="certReputationSourceLabel" escape="html" />
<orion:message key="scor.binary.reputationSource" var="binaryReputationSourceVarHtml" escape="html" />
<orion:message key="scor.cert.publicKeyAlgorithm" var="pubKeyAlgorithmLabel" escape="html" />
<orion:message key="scor.cert.publicKeyLength" var="pubKeyLengthLabel" escape="html" />
<orion:message key="scor.event.property.notAvailable" var="varNotAvailableJS" escape="javascript" />
<orion:message key="scor.event.property.notAvailable" var="varNotAvailableHtml" escape="html" />
<orion:message key="scor.certificate.da.PUBLIC_KEY_HASH" var="publicKeyHashLabel" escape="html" />
<orion:message key="scor.certificate.da.VALID_FROM" var="certValidFromLabel" escape="html" />
<orion:message key="scor.certificate.da.VALID_TO" var="certValidToLabel" escape="html" />
<orion:message key="scor.certificate.reputation.da.CERT_HASH" var="certHashLabel" escape="html" />
<orion:message key="scor.cert.reputation.lookupInTIE" var="lookupInTIEVarJS" escape="javascript" />
<orion:message key="scor.binary.currentReputationNotAvailableDesc" var="currentReputationNotAvailableDesc" escape="javascript" />
<orion:message key="scor.common.notavailable" var="certNotAvailable" escape="javascript"/>
<orion:message key="scor.ruleGroup.failureSavingMsg" var="failureRuleGroupSavingMsg" escape="javascript" /> 
<orion:message key="scor.general.alertFailureMsg" var="alertFailureMsg" escape="javascript" />
<c:set var="maxValueFieldSizeVar" value="<%=EventConstants.EVENT_DETAIL_VALUE_FIELD_MAX_LENGTH%>" />
<c:set var="maxValueFieldSizeWithTieLinkVar" value="<%=EventConstants.EVENT_DETAIL_VALUE_FIELD_WITH_TIE_LINK_MAX_LENGTH%>" />
<orion:core>
	<orion:corehead>
	<jsp:include page="/common/includejQuery.jsp" />
	<orion:script context="<%=URLConstants.SLASH_WEB_APP_NAME%>" src="/jsFiles/commonUtil.js"/>
	</orion:corehead>
	<orion:corebody>
		<orion:navigation/>
		<orion:content>
		<script type="text/javascript">
				OrionHelp.setHelpId("${helpPageId}");
			</script>
		<orion:vbox>
				<orion:titlebar text="${createPolicyTitleVar}" />
				<orion:hbox height= "130">
					<orion:box width="550" >
						
						<table style="border-bottom: 0;width:100%; padding-left:5px">
							<tr ><td style = "width:90%">
								<table class="orionPList" cellspacing="0" style="border-bottom: 0">
																
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px ">
											${eventDisplayNameVar}:
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left;" >
                                     		${orion:escapeHtml(eventDisplayNameValue)}
										</td>
										</tr>	
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px ">
											${denyReasonVar}:
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left;" >                                    		
 											${orion:escapeHtml(denyReasonValue)}
										</td>
										</tr>
													
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px ">
											${parentProcessNameVarHtml}:
										</th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     	<div id="parentProcessNameDivId" style="word-wrap:break-word; width:400px;"></div>
										<div id="parentProcessNamePanelId"  class="panelOnTop">
										   <div id="parentProcessNameInPanel" class="bd" style="word-wrap:break-word; width:300px;"></div>
										</div>
                                     	
										</td>
         								</tr>
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px ">
											${programNameVar}:
										</th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     	<div id="processNameDivId" style="word-wrap:break-word; width:400px;"></div>
										<div id="processNamePanelId"  class="panelOnTop">
										   <div id="processNameInPanel" class="bd" style="word-wrap:break-word; width:300px;"></div>
										</div>                                     	
										</td>
         								</tr>
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px ">
											${objectNameVar}:
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
                                     	<div id="objectNameDivId" style="word-wrap:break-word; width:400px;"></div>
										<div id="objectNamePanelId"  class="panelOnTop">
										   <div id="objectNameInPanel" class="bd" style="word-wrap:break-word; width:300px;"></div>
										</div>                                     	
										</td>
										</tr>
													
										</table>
							 </td>

							 </tr>
						</table>					
					</orion:box>		
					
					<orion:box width="auto">
						<table style="border-bottom: 0;width:100%">
						
							<tr ><td style = "width:90%">
								<table class="orionPList" cellspacing="0" style="border-bottom: 0">
									
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px">
											${customTrustLevel}:
										 </th>
										<td id="entTrustLevelCell" class="orionPListPropertyValue" style="border-right: 0; text-align: left" >                                     		
											<div id="binaryReputationDivId"></div>											
										</td>
										</tr>
										
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px">
											${reputationAtTimeOfEventVarHtml}:
										 </th>
										<td id="reputationAtTimeOfEventId" class="orionPListPropertyValue" style="border-right: 0; text-align: left" >                                     		
											<div id="reputationAtTimeOfEventDivId"></div>											
										</td>
										</tr>	
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px">
											${binaryReputationSourceVarHtml}:
										 </th>
										<td id="binaryReputationSourceId" class="orionPListPropertyValue" style="border-right: 0; text-align: left" >                                     		
											<div id="binaryReputationSourceDivId"></div>											
										</td>
										</tr>
										
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:200px;">
											${certificateSubject}:
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
											<div id="publisherDivId"></div>
											<div class="panelOnTop" id="certDetailPanelDivId" style="width:450px;">
												<div class="bd">
													<table>
														<tr>
															<td style="font-weight:bold; width:35%;">${subjectLabel}: </td>
															<td><div id="subjectDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${issuedByLabel}: </td>
															<td><div id="issuedByDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${certReputationLabel}: </td>
															<td><div id="certReputationDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${certReputationSourceLabel}: </td>
															<td><div id="certReputationSourceDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${pubKeyAlgorithmLabel}: </td>
															<td><div id="pubKeyAlgorithmDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${pubKeyLengthLabel}: </td>
															<td><div id="pubKeyLengthDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${publicKeyHashLabel}: </td>
															<td><div id="publicKeyHashDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${certHashLabel}: </td>
															<td><div id="certHashDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${certValidFromLabel}: </td>
															<td><div id="certValidFromDivId"></div></td>
														</tr>
														<tr>
															<td style="font-weight:bold">${certValidToLabel}: </td>
															<td><div id="certValidToDivId"></div></td>
														</tr>
													</table>
												</div>
											</div>
										</td>
										</tr>
										
								</table>	
							 </td>
								
							 </tr>
						</table>
					 </orion:box>
					 
					 <orion:box width="525" >
						
						<table style="border-bottom: 0;width:100%; padding-left:5px">
							<tr ><td style = "width:90%">
								<table class="orionPList" cellspacing="0" style="border-bottom: 0">
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:120px; ">
											${systemNameVar}:
										</th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left;" >
                                     		${orion:escapeHtml(hostNameValue)}
										</td>
										</tr>	
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:120px;">
											${userNameVar}:
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left;" >
                                     		${orion:escapeHtml(userNameValue)}
										</td>
										</tr>	
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:120px">
										 	<c:choose>
	            								<c:when test="${isWriteDeniedEvent == 'true'}">
	            									${processSHA1}:
            									</c:when>
            									<c:otherwise>
            										${binarySHA1}:
            									</c:otherwise>
											</c:choose>  
											
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
	     										${orion:escapeHtml(sha1Value)}
										</td>
										</tr>
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left;  width:120px">
										 	<c:choose>
	            								<c:when test="${isWriteDeniedEvent == 'true'}">
	            									${processSHA256}:
            									</c:when>
            									<c:otherwise>
            										${binarySHA256}:
            									</c:otherwise>
											</c:choose>  
											
										 </th>
										 
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left;">
	     										${orion:escapeHtml(sha256Value)}
										</td>
										</tr>
										
										<tr class="orionPListRow" style="border-bottom: 0">
										<th class="orionPListPropertyName" style="border-right: 0; text-align: left; width:120px">
										<c:choose>
	            								<c:when test="${isWriteDeniedEvent == 'true'}">
	            									${processMD5}:
            									</c:when>
            									<c:otherwise>
            										${binaryMD5}:
            									</c:otherwise>
											</c:choose> 											
										 </th>
										<td class="orionPListPropertyValue" style="border-right: 0; text-align: left" >
											${orion:escapeHtml(md5Value)}
										</td>
										</tr>	
										</table>
							 </td>

							 </tr>
						</table>
					
						</orion:box>	
				</orion:hbox>
				<c:choose>
				<c:when test="${not empty ckSumNotFoundMsg}">
    				<orion:box height="15"> 
    					<font color="red"><i>&nbsp;&nbsp;${ckSumNotFoundMsg}</i></font>
    				</orion:box>
				</c:when>
				<c:when test="${not empty banRuleExistsMsg}">
    				<orion:box height="15"> 
    					<font color="red"><i>&nbsp;&nbsp;${banRuleExistsMsg}</i></font>
    				</orion:box>
				</c:when>
				</c:choose>
				 <jsp:include page="../awl/applicationControlPolicyWithRules.jsp"/>
            </orion:vbox>
		
		
			<script type="text/javascript">
				var scor = scor || {};
				scor.events = scor.events || {};
				scor.events.rg = scor.events.rg || {};				
				scor.events.maxValueFieldSize =  '${maxValueFieldSizeVar}';
				scor.events.maxValueFieldSizeWithTieLink =  '${maxValueFieldSizeWithTieLinkVar}';
				scor.events.rg.removeSpacesFromString = function(stringWithSpaces){
					return stringWithSpaces.replace(/\s+/g, ' ')
				}
				scor.awl.rule.save.success.callback = function(ruleGroupId){	
					var requestId = '${scorSARequestIdAttr}'
					if(! '${scorSARequestIdAttr}'){
						requestId = null;
					}
					scor.actions.doAsyncAction('/SOLIDCORE_META/setStatusAndRuleGroupIdInRelatedPDRequestsFor.do',
									        			['ruleGroupId', ruleGroupId, 'scorSARequestIdAttr', requestId],
							 			        		scor.awl.rule.save.success.callback.success, 
							 			        		scor.awl.rule.save.success.callback.failure, 
							 			        		'POST');
				}
				
				scor.awl.rule.save.success.callback.success = function(){
					OrionNavigation.lastAnchorPage();
				}
				
				scor.awl.rule.save.success.callback.failure = function(){
					window.alert("${alertFailureMsg}");
				}

				scor.events.init = function(){	
					scor.actions.doAsyncAction('/SOLIDCORE_META/getReputationPropertiesForSHA1.do',
			        		['eventReqSha1Param', '${sha1Value}'],
			        		scor.events.success, 
			        		scor.events.failure, 
			        		'POST');					
					
				
					var escapedObjectName = OrionCore.escapeHtml(scor.events.rg.removeSpacesFromString('${objectNameValue}'));
					$j("#objectNameDivId").html(scor.common.getShortenedString(escapedObjectName, scor.events.maxValueFieldSizeWithTieLink));
					scor.events.createAndPopulatePanel(escapedObjectName, "objectNamePanelId", "objectNameDivId", "objectNameInPanel", scor.events.maxValueFieldSizeWithTieLink);
					
					var escapedProcessName = OrionCore.escapeHtml('${programNameValue}');
					$j("#processNameDivId").html(scor.common.getShortenedString(escapedProcessName, scor.events.maxValueFieldSizeWithTieLink));
					scor.events.createAndPopulatePanel( escapedProcessName, "processNamePanelId", "processNameDivId", "processNameInPanel", scor.events.maxValueFieldSizeWithTieLink);
					
					var escapedParentProcessName = OrionCore.escapeHtml('${parentProcessNameValue}');
					$j("#parentProcessNameDivId").html(scor.common.getShortenedString(escapedParentProcessName, scor.events.maxValueFieldSize));
					scor.events.createAndPopulatePanel( escapedParentProcessName, "parentProcessNamePanelId", "parentProcessNameDivId", "parentProcessNameInPanel",scor.events.maxValueFieldSize );
					
					var escapedBinarySHA256 =  OrionCore.escapeHtml('${sha256Value}');
					$j("#binarySHA256DivId").html(escapedBinarySHA256);
					if(${ckSumFound} == true){
						if('${isWriteDeniedEvent}' === 'true'){
							$j("#processNameDivId").append('&nbsp;&nbsp;<a href=/SOLIDCORE_META/evtShowReputationOnTIE.do?sha1='+'${sha1Value}${scor_csrf_param_la}'+'>'+'${lookupInTIEVarJS}'+'</a>');
						}else{
							$j("#objectNameDivId").append('&nbsp;&nbsp;<a href=/SOLIDCORE_META/evtShowReputationOnTIE.do?sha1='+'${sha1Value}${scor_csrf_param_la}'+'>'+'${lookupInTIEVarJS}'+'</a>');
						}
					}
					
					$j("#reputationAtTimeOfEventDivId").html('<span style="color:'+ '${reputationAtTimeOfEventColorValue}'+ '">'+ '${reputationAtTimeOfEventValue}' +'</span>');
					
					$j("#certDetailPanelDivId").hide();
				}	
				
				scor.events.success = function(result) {
		        	if(result == null) {
						return;
					}
					scor.events.setReputationProperties(result);					
				};
				
				scor.events.failure = function(){
					window.alert("${alertFailureMsg}");
				}				
				
				scor.events.setReputationProperties = function(result){				  
				    var binaryReputationColor = result['reqBinaryReputationColor'];
				    var binaryReputation = result['reqBinaryReputationValue'];	
				    $j("#binaryReputationDivId").html('<span style="color:'+ binaryReputationColor+ '">'+ binaryReputation+'</span>');
				    if( result['reqBinaryReputationAvailable'] == false){
				    	$j("#binaryReputationDivId").append('<span><a href="#" title="'+'${currentReputationNotAvailableDesc}'+'" class="exceptionQuesMark" style="margin-left:14px;">?</a></span>');
				    }
				    var binaryReputationReason = result['reqBinaryReputationSource'];
			    	 $j("#binaryReputationSourceDivId").html(binaryReputationReason);			    	 
				    scor.events.setCertificateProperties(result);				   
				}
				
				scor.events.setCertificateProperties = function(result) {
					 var certificateName;
					 var effectiveCertVo = result['scorEffectiveCertDetail'];
					 if(effectiveCertVo && effectiveCertVo.cert){
					   var certificateColor = result['reqEffectiveCertReputationColor'];
					   certificateName = effectiveCertVo.cert.subject;
					   $j("#publisherDivId").html('<span style="color:'+ certificateColor+ '">'+ OrionCore.escapeHtml(certificateName)+'</span>');
					   $j("#publisherDivId").append('&nbsp;&nbsp;<a href=/SOLIDCORE_META/showCertReoutationOnTIE.do?reqCertSha1='+OrionCore.escapeHtml(effectiveCertVo.cert.certHash)+'${scor_csrf_param_la}'+'>'+'${lookupInTIEVarJS}'+'</a>');
					   $j("#pubKeyAlgorithmDivId").html(OrionCore.escapeHtml(effectiveCertVo.cert.publicKeyAlgo));
					   $j("#pubKeyLengthDivId").html(OrionCore.escapeHtml(effectiveCertVo.cert.publicKeyLength));
					   $j("#subjectDivId").html(OrionCore.escapeHtml(effectiveCertVo.cert.subject));
					   $j("#issuedByDivId").html(OrionCore.escapeHtml(effectiveCertVo.cert.issuedBy));
					   $j("#publicKeyHashDivId").html(OrionCore.escapeHtml(effectiveCertVo.cert.publicKeyHash));
					   $j("#certHashDivId").html(OrionCore.escapeHtml(effectiveCertVo.cert.certHash));
					   $j("#certValidFromDivId").html(OrionCore.escapeHtml(result['reqEffectiveCertValidFromValue']));
					   $j("#certValidToDivId").html(OrionCore.escapeHtml(result['reqEffectiveCertValidToValue']));
					   if(effectiveCertVo.certReputation){
						    var certReputationColor = result['reqEffectiveCertReputationColor'];
						    var certReputation = result['reqEffectiveCertReputationValue'];
						    var certReputationReason = result['reqEffectiveCertReputationSourceValue'];
					   		$j("#certReputationDivId").html('<span style="color:'+ certReputationColor+ '">'+ certReputation+'</span>');
					   		$j("#certReputationSourceDivId").html(certReputationReason);
						}					
					   scor.events.initializeCertificateTooltip();
					}	else{
						$j("#publisherDivId").html('${varNotAvailableJS}');
					}				
				}				
				
				
				scor.events.failure = function() {
					window.alert("${failureRuleGroupSavingMsg}");
				};
				
				scor.events.initializeCertificateTooltip = function() {
					scor.common.registerPanelAt("certDetailPanelDivId", "publisherDivId", '${certificateTitleLabelJS}', '450px');
					$j("#certDetailPanelDivId").show();
				};
				
				scor.events.createAndPopulatePanel = function( valueString, panelId, valueDivId, panelValueId, maxLength){
					if( valueString != null && valueString.length > maxLength){
						$j("#"+panelValueId).html(valueString);
						scor.common.registerPanelAt( panelId, valueDivId, '${showFullBinaryPathLabelJS}' );
						$j("#"+panelId).show();
					}else{
						$j("#"+panelId).hide();
					}
				};				
				
								
				OrionCore.addLoadHandler(scor.events.init);   	
				
							</script>
		</orion:content>
	</orion:corebody>
</orion:core>