<%-- COPYRIGHT:		Copyright (C) 2018 McAfee, Inc.  All rights reserved--%>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>

<%@page import="com.mcafee.scor.imagedev.db.model.ImageDevHistoryModelConstants"%>
<%@page import="com.mcafee.scor.imagedev.ImageDevConstants"%>

<script type="text/javascript">
	OrionHelp.setHelpId("<%=HelpConstants.IMAGE_DEVIATION_MAIN_PAGE%>");
</script>

<script type="text/javascript">          

	var scor = scor || [];
	scor.imagedev = scor.imagedev || [];
	scor.imagedev.history = scor.imagedev.history || [];
	
	scor.imagedev.history.getImageDevHistory = function () {		
		var params = new Array();                
		params[0] = 'searchValue';
		params[1] = $("search_value").value;  
		params[4] = 'sectionId';
		params[5] = 'scor.section.appcontrol';
		params[6] = 'tabId';
		params[7] = 'scor.tab.imagedev';
		var curUrl = location.href;            
		OrionCore.doFormAction(curUrl, params, "GET");                                   
	};

	scor.imagedev.history.showImageDevDetails = function (targetSystemAgentGUID) {                              
		var paramMap = ['targetSystemAgentGUID', targetSystemAgentGUID];
		OrionCore.doAction('<%=URLConstants.SHOW_IMAGE_DEV_DETAILS%>', paramMap, "GET", '_self');		 
	};
	    	
</script>


<orion:message var="imageDevTitleText" key="scor.imgdev.page1.titlebar" escape="none"/>
<orion:message var="search" key="scor.imgdev.page1.search" escape="none"/>
<orion:message var="imageDevTableTitle" key="scor.imgdev.page1.imgDevSummary" escape="none"/>
<orion:message var="searchTargetSystemTxt" key="scor.SCOR_IMAGE_DEV.da.searchTargetSystemName" escape="html"/>

<orion:vbox>      
    <orion:box height="80" background="rgb(235, 235, 235);">
		<orion:titlebar text="${imageDevTitleText}"/>
		<table>
			<tr><td>&nbsp;&nbsp;${searchTargetSystemTxt}</td></tr> 
			<tr>
				<td style="text-align: left;">
					&nbsp;
					<orion:textbox id="search_value" 
						size="50" maxlength="100"
						value="${requestScope.searchValue}"/>
					&nbsp;
					<orion:button id="search_button" 
						text="${search}" 
						disabled="false" onclick="scor.imagedev.history.getImageDevHistory();"/>   
				</td>
			</tr>
		</table>
	</orion:box>
	
	<orion:tabletitle id="imageDevTableTitle" tableId="imageDevTable" text="${imageDevTableTitle}" allowExport="true" 
	 datasourceAttr="<%=ImageDevConstants.SCOR_IMAGE_DEV_HISTORY_DS_ATTR%>"/>

	<orion:table2 id="imageDevTable" datasourceAttr="<%=ImageDevConstants.SCOR_IMAGE_DEV_HISTORY_DS_ATTR%>" showCheckboxColumn="false" 
	cellRendererAttr="<%=ImageDevConstants.SCOR_IMAGE_DEV_HISTORY_CR_ATTR%>" enableDrilldown="false"	
	properties="<%=ImageDevHistoryModelConstants.PROP_TARGET_SYSTEM + \",\" + ImageDevHistoryModelConstants.PROP_TARGET_SYSTEM_GROUP_NODE_PATH + 
	\",\" + ImageDevHistoryModelConstants.PROP_GOLD_SYSTEM + \",\" + ImageDevHistoryModelConstants.PROP_TARGET_SYSTEM_INV_FETCH_TIME +
	\",\" + ImageDevHistoryModelConstants.PROP_IMAGE_DEV_RUN_TIME + 
	\",\" + ImageDevHistoryModelConstants.PROP_NUM_DEVIATIONS + \",\" + ImageDevHistoryModelConstants.DISPLAY_PROP_ACTION%>"  
	columnWidths="10,14,10,15,15,27,9"/>			
		
</orion:vbox>
