<!-- COPYRIGHT:		Copyright (C) 2015-2018 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>

<orion:message key="scor.SCOR_INV.da.authByCert" var="authByCert" escape="javascript"/>
<orion:message key="scor.SCOR_INV.da.allowByName" var="allowByName" escape="javascript"/>
<orion:message key="scor.SCOR_INV.da.banByName" var="banByName" escape="javascript"/>
<orion:message key="scor.SCOR_INV.da.trustedPath" var="trustedPath" escape="javascript"/>
<orion:message key="scor.SCOR_INV.da.status" var="status" escape="javascript"/>
<orion:message key="scor.SCOR_INV.da.allowByChksum" var="allowByChksum" escape="javascript"/>
<orion:message key="scor.SCOR_INV.da.banByChksum" var="banByChksum" escape="javascript"/>
<orion:message key="scor.SCOR_INV.da.execAllowed" var="execAllowed" escape="javascript"/>
	
<script type="text/javascript">
setupRow=function(key,value){
    return "<tr class='orionPListRow'>"
     	 + "<th class='orionPListPropertyName'>" + key +"</th>"
    	 + "<td class='orionPListPropertyValue'>" +value +"</td></tr>";
}
_setupview=function(){
	var tableData = JSON.parse('${orion:escapeJavaScript(inventoryDetails)}');
    var output = "<div class='pageExtensionContent'><table id='detailsTbl' class='orionPListColumnTable'><tbody id='detailsTblBody'>";
	 output+=setupRow('${banByChksum}',tableData.banByChecsum);
	 output+=setupRow('${allowByChksum}',tableData.allowByChecsum);
	 output+=setupRow('${authByCert}',tableData.authByCert);
	 output+=setupRow('${banByName}',tableData.banByName);	 
	 output+=setupRow('${allowByName}',tableData.allowByName);
	 output+=setupRow('${trustedPath}',tableData.trustedPath);
	 output+=setupRow('${status}',tableData.status);
	 output += "</tbody></table></div>";
	 document.getElementById("detailsContent").innerHTML = output; 
}
_setupview();
</script>
 <orion:box id="detailsContent">
   <!-- Add content here -->      
 </orion:box>
