<!-- COPYRIGHT:		Copyright (C) 2015 McAfee, Inc.  All rights reserved-->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ page import="com.mcafee.scor.common.URLConstants" %>
<%@ page import="com.mcafee.scor.offlinegti.OfflineGTIConstants" %>

<orion:script context="/core" src="/yui/connection/connection-min.js"/>

<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>

<orion:message key="scor.error.dialogBox.title" var="scorErrorTitle" escape="javascript"/>
<orion:message key="scor.inventory.offlinegti.importGTIRatings.error" var="errorImportingGTIRatings" escape="javascript"/>

<orion:message key="scor.uia.inventory.binaries.importGTIRatings.dialog.text" var="importGTIRatingsConfirm" escape="html"/>


<SCRIPT  type="text/javascript">
	OrionCore.addLoadHandler(init);	
	
	var onUploadButtonClick = function(e)
		{	
			scor.utils.fixYUIFileUploadOnIe();
			YAHOO.util.Connect.setForm(OrionForm.getForm(), true);
			var uploadHandler = {
				upload: function(res) 
				{
					var result = res.responseText;
					verifySuccess(result);
				}
			};
			
			OrionForm.setEncoding(OrionForm.MULTIPART);
			try
			{
				YAHOO.util.Connect.asyncRequest('POST', "<%=URLConstants.IMPORT_GTI_RATINGS_ACTION_URL%>", uploadHandler);
			}
			catch(e)
			{
				alert ("${errorImportingGTIRatings}");
			}
			OrionCore.showPleaseWait(true);
		};
		
	function verifySuccess(result){
		
		OrionCore.showPleaseWait(false);
		var resultObj = JSON.parse(result);
        var resultVO = scor.vos.Result(resultObj);
        if (resultVO.isSuccess()) {
        	OrionCore.showDialogBox(true,resultVO.getResult(),OrionCore.DIALOG_OK);
        } else {
        	OrionCore.showDialogBox(true,resultVO.getMsg(),OrionCore.DIALOG_OK);
        }
	}
	
	function init(){
		OrionCore.dialogBoxOkHandler = onUploadButtonClick;
	}
	init();

</SCRIPT>


<table>
	<tr>
		<td>
			${importGTIRatingsConfirm}
		</td>
	</tr>
	<tr>
		<td>
			<orion:fileupload  id="scor.import.gtiRatings"  name="scorImportGTIRatings"  required="true" contentEditable="false"/>
		</td>
	</tr>
</table>

