var scor;
scor = scor || {};
scor.vos = scor.vos || {};
scor.vos.filediff = scor.vos.filediff || {};


scor.vos.filediff.FileVO = function(lastChangeAttribute, content, host, fileName, version, isBaseline) {
    var vo = {
        "lastChangeAttribute":lastChangeAttribute,
        "content":content,
        "host":host,
        "fileName":fileName,
        "version":version,
        "isBaseline":isBaseline
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);

    return {
        "common": commonFunc
    };
};

scor.vos.filediff.FileChangeAttributesVO = function(who, when, whenTZ, prog_name, workflow_id,metaInfo) {
    var vo = {
        "who":who,
        "when":when,
        "whenTZ":whenTZ,
        "progName":prog_name,
        "workflowId":workflow_id,
        "metaInfo":metaInfo
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);

    return {
        "common": commonFunc
    };
};

scor.vos.filediff.FileInfoVO = function(id, agentguid, filePath, machinename, fileStatus,fileStatusString) {
    var vo = {
        "id":id,
        "agentguid":agentguid,
        "filePath":filePath,
        "machinename":machinename,
        "fileStatus":fileStatus,
        "fileStatusString":fileStatusString
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);

    return {
        "common": commonFunc
    };
};

scor.vos.filediff.FileReposVO = function(id, isBaseVersion, modifiedBy, detectedTimestamp) {
    var vo = {
        "id":id,
        "isBaseVersion":isBaseVersion,
        "modifiedBy":modifiedBy,
        "detectedTimestamp":detectedTimestamp
    };
    var commonFunc = scor.utils.getVosCommonFuncs(vo);

    return {
        "common": commonFunc
    };
};