<%--
//-----------------------------------------------------------------------------
// Copyright (c) 2011-2012 XEROX Corporation.  All rights reserved
//-----------------------------------------------------------------------------
// Revision History:
// -----------------
// AR Number      Author   Date         Change Description
// ---------      ------   ----         ------------------
//
// CQGbl00349040  bvu      01/04/2012   Created       
//-----------------------------------------------------------------------------
--%>

<%--
  This is the view for the Manage sofware tab (Remove) on the 
  Software Update page

  This is part of McAfee tab tag configuration.
--%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core_rt" %>

<orion:vbox>

  <orion:box height="10"/>

    <orion:box height="auto">

      <br/>

<table align="center">
  <tr>
    <td>
       <orion:message key="XeroxMFP.systemSoftwareUpdate.notice.remove" /><br/><br/>
    </td>
  </tr>
  <tr>
    <td>
      <orion:select style="width:400px;" size="10" multiple="true" id="firmwareSelect" items="${firmwareList}"/>
    </td>
  </tr>
</table>

    </orion:box>

  <orion:box height="32">

    <orion:footerbar>
      <orion:message key="XeroxMFP.label.ok" escape="none" var="okLabel" /> 
      <orion:button id="ok" onclick="removeFromServer();" text="${okLabel}" disabled="true"/>
      <orion:message key="XeroxMFP.label.cancel" escape="none" var="cancelLabel" /> 
      <orion:button id="cancel" onclick="backToExtensionHome();" text="${cancelLabel}"/>
                
    </orion:footerbar>
  </orion:box>

</orion:vbox>
