<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved.  -->
<%@ page import="com.mcafee.scor.awl.AWLConstants" %>
<%@ page import="com.mcafee.scor.common.HelpConstants" %>
<%@ page import="com.mcafee.scor.rulegroup.RuleGroupConstants"%>
<%@ page import="com.mcafee.scor.policy.PolicyConstants"%>
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://www.mcafee.com/scor" prefix="scor" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<orion:script context="/core" src="/majic.js"/>

<jsp:include page="/common/includejQuery.jsp" />
<jsp:include page="<%=URLConstants.JSP_COMMON_UTILS%>"/>
<orion:script context="/SOLIDCORE_META" src="/jsFiles/vos/awlvos.js"/>

<orion:message key="scor.awl.trustedUsers.tab.title" var='trustedUsersTab' escape="javascript"/>
<orion:message key="scor.policy.awl.groups" var="groups"  escape="none"/>
<orion:message key="scor.mon.policy.addGroup.button.txt" var="addGroup"  escape="none"/>
<orion:message key="scor.mon.policy.deleteGroup.button.txt" var="removeGroupTxt"  escape="none"/>

<orion:message key="scor.policy.awl.tab.title.updaters" var="titleUpdaters" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.noPermission" var="titleNoPermission" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.binary" var="titleBinary" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.publishers" var="titlePublishers" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.applications" var="titleApplications" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.exceptions" var="titleExceptions" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.trustedDirectories" var="titleTrustedDirectories" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.observationExclusion" var="titleObservationExclusion" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.inventoryExclusion" var="titleInventoryExclusion" escape="javascript"/>
<orion:message key="scor.policy.awl.tab.title.executionControl" var="titleExecControl" escape="javascript"/>

<%@ include file="../widgets/addGroup.jsp" %>
<%@ include file="./PolicyCommon.jsp" %>

<c:set var="WIN_OS" scope="request" value="<%=PolicyConstants.POLICY_OS.WIN.getValue()%>"/>
<c:set var="UNIX_OS" scope="request" value="<%=PolicyConstants.POLICY_OS.UNIX.getValue()%>"/>

<script type="text/javascript">	
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupUpdaterRules" authToken = "isAuthorizedToViewUpdaterRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupBinaryRules" authToken = "isAuthorizedToViewBinaryRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupTrustedUserRules" authToken = "isAuthorizedToViewTrustedUserRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupPublisherRules" authToken = "isAuthorizedToViewPublisherRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupInstallerRules" authToken = "isAuthorizedToViewInstallerRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupExceptionRules" authToken = "isAuthorizedToViewExceptionRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupTrustedDirRules" authToken = "isAuthorizedToViewTrustedDirRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupFilterRules" authToken = "isAuthorizedToViewFilterRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewRuleGroupExecControlRules" authToken = "isAuthorizedToViewExecControlRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToViewAppControlRules" authToken = "isAuthorizedToViewAppControlRules"/>

	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupUpdaterRules" authToken = "isAuthorizedToEditUpdaterRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupBinaryRules" authToken = "isAuthorizedToEditBinaryRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupTrustedUserRules" authToken = "isAuthorizedToEditTrustedUserRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupPublisherRules" authToken = "isAuthorizedToEditPublisherRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupInstallerRules" authToken = "isAuthorizedToEditInstallerRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupExceptionRules" authToken = "isAuthorizedToEditExceptionRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupTrustedDirRules" authToken = "isAuthorizedToEditTrustedDirRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupExecControlRules" authToken = "isAuthorizedToEditExecControlRules"/>
	<scor:auth authClassName = "com.mcafee.scor.common.ScorPermissionValidationHelper" authMethodName = "isUserAllowedToEditRuleGroupFilterRules" authToken = "isAuthorizedToEditFilterRules"/>
	
    var awlPolVOs = [];
    var currentListGroupSelected;
    var _itemSelected = function (itemKey, itemLabel)
    {    	
    	var selectedGroup = OrionCore.unescapeHtml(OrionList.getSelectedItemText("<%=Constants.POLICY_LIST_NAME%>"));
    	groupChange(selectedGroup);
    }

    var addNewGroup = function() {
        var queryString;
    <c:if test="${param.osType != null}">
        scorMonOsType = "${orion:escapeJavaScriptString(param.osType)}"
        queryString = "<%=Constants.GROUP_PLATFORM%>" + "=" + scorMonOsType;
    </c:if>

        scor.widgets.addGrp.scorAddNewGrps("<%=RuleGroupConstants.RULE_GROUP_TYPES.APPLICATION_CONTROL.getValue()%>", scorAwlPolicyGetRulesSuccess, queryString);
    }

    var scorAwlPolicyGetRulesSuccess = function (result) {
        addNewAwlPolicyGroups(result);
        myEpoEnableApplyButton();
    }

    var deleteGroup = function () {
        scor.widgets.deleteSelectedGrp("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", onDeleteGroup);
    }
    var onDeleteGroup = function(deletedObj) {
        var i, indexToDelete;
        var groupName = OrionCore.unescapeHtml(deletedObj.text);

        for (i = 0; i < awlPolVOs.length; i++) {
            var awlPolVO = awlPolVOs[i];
            if (groupName === awlPolVO.common.getProperty("groupName")) {
                indexToDelete = i;
                break;
            }
        }

        if (typeof indexToDelete === 'number') {
            awlPolVOs.splice(indexToDelete, 1);
        }
        scor.widgets.policyVOs = awlPolVOs;
    }
    var addNewAwlPolicyGroups = function(newGroups) {
        var i;
        for (i = 0; i < newGroups.length; i++) {

            var awlPolVO = getAwlPolVOFromJson(newGroups[i]);
            var groupName = awlPolVO.common.getProperty("groupName");
            var groupId = awlPolVO.common.getProperty("id");
            if ( ! scor.widgets.addGrp.isExist(groupId, "<%=Constants.POLICY_LIST_NAME%>") ) {
                awlPolVOs.push(awlPolVO);
              //No need to send 4th parameter in addNewRow function call as this parameter is need when initializing page and policy VO has RGs that do not exist.
                addNewRow("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", groupName, groupId)
            }
        }
        scor.widgets.policyVOs = awlPolVOs;
    }

    function addNewRow(listName, listGroupName, groupName, groupId, counterObj) {
        var groupNameEscapedHTML = OrionCore.escapeHtml(groupName);
        var key = groupId;
        if(key === <%=PolicyConstants.DEFAULT_GROUP_ID_WHEN_RULE_GROUP_NOT_EXIST%>){
        	counterObj.increment();
        	key = "AWL_empty." + counterObj.getCounter();        	
         }
        var item = {"key":key, "label": groupNameEscapedHTML};
        OrionList.insertRow(listName, item, listGroupName);
        return key;
    }
   
    function myEpoEnableApplyButton() {
        if (typeof epoEnableApplyButton === 'function') {
            epoEnableApplyButton();
        }
    }

</script>

<orion:hbox height="auto">
    <orion:vbox id="awlPolicyListBox" width="250">

        <orion:titlebar id="listTitle" text="${groups}"/>
        <orion:list id="<%=Constants.POLICY_LIST_NAME%>" context="<%=Constants.WEB_APP_NAME%>"
                    contentURI="<%=URLConstants.AWL_GROUPS_LIST%>"/>
        <script type="text/javascript">
            OrionList.setSelectRowHandler(_itemSelected);
        </script>

        <orion:listbuttonarea>
            <orion:button id="scorAwlAddGroup" text="${addGroup}"
                          onclick="addNewGroup();"/>
            <orion:button id="scorAwlPolicyDeleteGroup" text="${removeGroupTxt}"
                          onclick="deleteGroup();"/>
        </orion:listbuttonarea>
        <script type="text/javascript">
            (function() {
                if ("${epoReadOnlyPolicyObject}" === "true") {
                    var addButton = new Button("scorAwlAddGroup");
                    addButton.setEnabled(false);
                }
            }());
        </script>

    </orion:vbox>

    <orion:vdivider id="scorAwldivider" resizeTarget="awlPolicyListBox"/>
    <orion:vbox>
        <orion:box id="idTab" height="24"/>
		
		<jsp:include page="../common/noPermission.jsp"/>		
       	<jsp:include page="../awl/_updaters.jsp"/>
       	<jsp:include page="../awl/TrustedDirectories.jsp"/>

         <c:if test="${param.osType == WIN_OS}">         	
            <c:choose>
	            <c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
	            <%-- No Trusted Users--%>
            	</c:when>
            	<c:otherwise>
            	
            		<jsp:include page="../awl/trustedUsers.jsp"/>
            	
            </c:otherwise>
			</c:choose>         
            <jsp:include page="../awl/Publishers.jsp"/>       
           	<jsp:include page="../awl/Applications.jsp"/>	
           	<jsp:include page="../awl/ExecutionControl.jsp"/>		
         </c:if>
		<jsp:include page="../attr/Attributes.jsp"/>	 	 
        <jsp:include page="../awl/AllowBanBinary.jsp"/>        
       
        <orion:box id="advanced">        	
            <table id="" cellspacing='0' cellpadding='0' width='98%' style="padding-left: 10px;">
                <tr>
                    <td>
                   <jsp:include page="../awl/CumulativeAEF.jsp"/> 
                    </td> 
                </tr>
            </table>
        </orion:box>          
	</orion:vbox>
</orion:hbox>

<script type="text/javascript">
	<c:if test = "${isAuthorizedToViewFilterRules == false}">
		$j('#advanced').hide();
	</c:if>    
	var scorRuleGroupTabSwapper;
	var scor = scor || {};
	scor.rg = scor.rg || {};
	scor.rg.tabs = scor.rg.tabs || {};

	
	scor.rg.tabs = function() {
		<%-- List of tab Ids in order which they are expected to appear,
		Currently this is same as the order in which the map keys are, could be a problem with  --%>
			var ids = [
	                	"updaterTabId",
	                	"allowBanBinaryId",
	                	"trustedUsersTabId",
	    			 	"PublisherTab",
	    			 	"applicationsTabId",
	    			 	"attributesTabId",
	    			 	"trustedDirectoriesTabId",
	    			 	"advanced",
	    			 	"execControlTabId"
	               	];
			
           	function isTabVisible(tabId) {
               	return $j("#tab_" + tabId).is(":visible");
           	}

           	function getFirstVisibleTabId() {
               	for (var index=0; index < ids.length; index++) {
                   	var tabId = ids[index];
                   	if(isTabVisible(tabId)) {
                       	return tabId;
                   	}
               	}               
           	}

           	return {
               	getIdList: function () {
               		return ids;
           		},
           		getFirstVisibleTabId: getFirstVisibleTabId
           	};
	}();
	
	function scorChangeHelpPageIfReq(helpPageId){
		<c:choose>
			<c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
				<%-- No subpage Rule Group Help required --%>
			</c:when>
			<c:when test="${changeHelpPageWithTabs == 'false'}">
				<%-- No subpage Rule Group Help required --%>
			</c:when>
			<c:otherwise>
				OrionHelp.setHelpId(helpPageId);
			</c:otherwise>
		</c:choose>	
	}
	
    function fnSetTabStrip()
    {
        scorRuleGroupTabSwapper = new majic.SwapTabStrip( "idTab", {   
    		<%-- For any new tab enter here ensure to make its entry in scor.rg.tabs.ids --%>      
        	 "noPermissionBoxId": {
            title: '${titleNoPermission}',
			callback:function(){
            	
                }
            },
                	
            "<%=AWLConstants.updaterTabId%>": {
                title: '${titleUpdaters}',
				callback:function(){
                	scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_UPDATERS%>");
	                }
                	},
                    
             <c:if test="${param.osType == WIN_OS}">
     			 	"PublisherTab": {
                                 title: '${titlePublishers}',
     							callback:function(){
                                 	scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_PUBLISHERS%>");                            	
                                 }
                             },              		
                		 
                      "applicationsTabId": {
                                 title: '${titleApplications}',
     							callback:function(){
                                 	scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_INSTALLERS%>");								
                                	}
                             },
                 		
               </c:if>
                     "trustedDirectoriesTabId": {
                                title: '${titleTrustedDirectories}',
                 				 callback:function(){
                                 	scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_TRUSTED_DIRECTORIES%>");								
                 				}
                             },               
            <c:if test="${param.osType == WIN_OS}">	
				<c:choose>
          	            <c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
          	            <%-- No Trusted Users--%>
                      	</c:when>
                      	<c:otherwise>            		
                                 "trustedUsersTabId": {
                                      title: '${trustedUsersTab}',
          							callback:function(){
                                      	scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_TRUSTED_USERS%>");	
          							}
                                  },                   
          				</c:otherwise>
				</c:choose>	
			</c:if> 
		             "allowBanBinaryId": {
		                title: '${titleBinary}',
						callback:function(){
		                	scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_BINARY%>");
			                }
		              },
		           
		              "attributesTabId": {
		  				title: '${titleExceptions}',
		  				callback: function(){
		                  	<c:choose>
		       	            <c:when test="${param.osType == UNIX_OS}">
		       	           		scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_UNIX_EXCEPTIONS%>");		
		                   	</c:when>
		                   	<c:otherwise>
		                   		scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_EXCEPTIONS%>");		 
		       				</c:otherwise>
		       				</c:choose>							
		  			     	    }		  					
		  			     },
		  			
			           "advanced": {
			                title: '<orion:message key="policy.mon.advanced" escape="javascript"/>',
							callback: function(){
			                	<c:choose>
			     	            <c:when test="${param.osType == WIN_OS}">
			     	           		scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_EVENT_AND_OB_FILTERS%>");	
			                 	</c:when>
			                 	<c:otherwise>
			                 		scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_EVENT_FILTERS%>");	  
			     				</c:otherwise>
			     				</c:choose>
							}
			            }
			            
			            <c:if test="${param.osType == WIN_OS}">
				            ,
				            
				            "execControlTabId": {
			                title: '${titleExecControl}',
							callback:function(){
			                	scorChangeHelpPageIfReq("<%=HelpConstants.APPLICATION_CONTROL_POLICY_EXECUTION_CONTROL%>");
				                }
			              	}
		              	</c:if>

            <%-- For any new tab enter here ensure to make its entry in scor.rg.tabs.ids --%>      
            
        } );

        $j('#tab_noPermissionBoxId').hide();
        $j('#noPermissionBoxId').hide();
        
        <c:if test="${isAuthorizedToViewAppControlRules == false}">   
		 	$j('#tab_noPermissionBoxId').show();
		 	$j('#noPermissionBoxId').show();
		</c:if>	

		<c:if test = "${isAuthorizedToViewUpdaterRules == false}">
			$j('#tab_updaterTabId').hide();	
		</c:if>	

		<c:if test = "${isAuthorizedToViewBinaryRules == false}">
			$j('#tab_allowBanBinaryId').hide();	
		</c:if>	

		<c:if test = "${isAuthorizedToViewTrustedUserRules == false}">
			$j('#tab_trustedUsersTabId').hide();	
		</c:if>	

		<c:if test = "${isAuthorizedToViewPublisherRules == false}">
			$j('#tab_PublisherTab').hide();	
		</c:if>	

		<c:if test = "${isAuthorizedToViewInstallerRules == false}">
			$j('#tab_applicationsTabId').hide();	
		</c:if>	

		<c:if test = "${isAuthorizedToViewExceptionRules == false}">
			$j('#tab_attributesTabId').hide();	
		</c:if>	

		<c:if test = "${isAuthorizedToViewTrustedDirRules == false}">
			$j('#tab_trustedDirectoriesTabId').hide();	
		</c:if>	

		<c:if test = "${isAuthorizedToViewFilterRules == false}">
			$j('#tab_advanced').hide();	
		</c:if>
		
		<c:if test = "${isAuthorizedToViewExecControlRules == false}">
			$j('#tab_execControlTabId').hide();	
		</c:if>

		scor.rg.swapToFirstVisibleTab();	
		
    }

    scor.rg.swapToFirstVisibleTab = function () {
		var firstVisibleTabId = scor.rg.tabs.getFirstVisibleTabId ();
		if(!firstVisibleTabId){
			$j('#tab_noPermissionBoxId').show();
		 	$j('#noPermissionBoxId').show();
		 	return;
		}
		firstVisibleTabId = "tab_"+firstVisibleTabId;
		scorRuleGroupTabSwapper.swap($(firstVisibleTabId));
    }

    // Core Load handler for things to run when the page loads.
    OrionCore.addLoadHandler (fnSetTabStrip);

    function savePrevGroupData() {
        var updaters = scor.rg.awl.updaters.getUpdaters();
        var trustedDirectories =  getTrustedDirectories();
        var binaries = getBinaries();
        
      <c:if test="${param.osType == WIN_OS}">
        <c:choose>
        	<c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
        	<%-- No Trusted Users--%>
    		</c:when>
    		<c:otherwise>
    			var trustedUsers = getTrustedUsers();
    			var trustedGroups = getTrustedGroups();    			
			</c:otherwise>
		</c:choose>       
		
		
        	var publishers = getPublishers();
	    	var apps = getApplications();
	    	var execControlVOs = getExecControlVOs();
        </c:if>
        
       	var attributes = getAttributes();
       	var advanced = scor.awl.filter.getRulesVO();
      	<c:if test="${param.osType == WIN_OS}">
       		var invFilters = scor.awl.filter.inv.getRulesVO();
		</c:if>
       
       
        var i;
        for (i = 0; i < awlPolVOs.length; i++) {
            var awlPolVO = awlPolVOs[i];
            if (currentListGroupSelected === awlPolVO.common.getProperty("groupName")) {
                awlPolVO.common.setProperty("updaters", updaters);

				<c:if test="${param.osType == WIN_OS}">

		        <c:choose>
		        	<c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
    		    	<%-- No Trusted Users--%>
    				</c:when>
    				<c:otherwise>
	                    awlPolVO.common.setProperty("trustedUsers", trustedUsers);
	                    awlPolVO.common.setProperty("trustedGroups", trustedGroups); 
                		awlPolVO.common.setProperty("execControlVOs", execControlVOs);
                   	</c:otherwise>
				</c:choose>
				
					awlPolVO.common.setProperty("publishers", publishers);
                    awlPolVO.common.setProperty("apps", apps);
                </c:if>
                awlPolVO.common.setProperty("attributes", attributes);
                awlPolVO.common.setProperty("trustedDirectories", trustedDirectories);
                awlPolVO.common.setProperty("binaries", binaries);
                awlPolVO.common.setProperty("advanced", advanced);
              	<c:if test="${param.osType == WIN_OS}">
                	awlPolVO.common.setProperty("invFilters", invFilters);
              	</c:if>
                break;
            }
        }
    }
    var _applyPolicySuccess = function ()
    {
        fnGoBack(); // This is a Mercury function and recommended.
    }

    var epoApplyPolicySettings = function  ()
    {
        if (currentListGroupSelected) {
            savePrevGroupData();
        }

        var jsonVo = [];
        for (i = 0; i < awlPolVOs.length; i++) {
            jsonVo.push(awlPolVOs[i].common.getVO());
        }

        var awlPolVosJSON = JSON.stringify(jsonVo);
        scor.actions.doAsyncAction("<%=URLConstants.SAVE_AWL_POLICY_URL%>", ["<%=Constants.POLICY_AWL_DATA%>", awlPolVosJSON], _applyPolicySuccess);
    }

    var getAwlPolVOFromJson = function(jsonData) {
        var id = jsonData['id'];
        var groupName = jsonData['groupName'];
        var platform = jsonData['platform'];
        var type = jsonData['type'];
        var readOnly = jsonData['readOnly'];
        var updaters = jsonData['updaters'];
        var trustedGroups = jsonData['trustedGroups'];
        var trustedUsers = jsonData['trustedUsers'];
        var apps = jsonData['apps'];
        var trustedDirectories = jsonData['trustedDirectories'];
        var publishers = jsonData['publishers'];
        var binaries = jsonData['binaries'];
        var attributes = jsonData['attributes'];
        var advanced = jsonData['advanced'];
        var invFilters = jsonData['invFilters'];
        var execControlVOs = jsonData['execControlVOs'];
		
        var vo = scor.vos.awl.AWLPolicyVO(id,groupName, platform, readOnly, type,updaters,
        		trustedGroups,trustedUsers,apps,trustedDirectories,publishers,binaries, attributes, advanced, invFilters, execControlVOs);
        return vo;
    }

var setReadOnly = function(readOnly) {
    var enable = !readOnly;
    <c:if test = "${isAuthorizedToViewUpdaterRules == true}">	
    	enableUpdaterList(enable && ${isAuthorizedToEditUpdaterRules});
    </c:if>
    <c:if test = "${isAuthorizedToViewTrustedDirRules == true}">
    	enableTrustedDirectoriesList(enable && ${isAuthorizedToEditTrustedDirRules});
    </c:if>

 <c:if test="${param.osType == WIN_OS}">
	<c:if test = "${isAuthorizedToViewTrustedUserRules == true}">
    	<c:choose>
    		<c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
    		<%-- No Trusted Users--%>
    		</c:when>
    		<c:otherwise>
    			enableTrustedUsersList(enable && ${isAuthorizedToEditTrustedUserRules});
    		</c:otherwise>
    	</c:choose>  
	</c:if>
	
   
    	<c:if test = "${isAuthorizedToViewPublisherRules == true}">   
    		enablePublishList(enable && ${isAuthorizedToEditPublisherRules});
    	</c:if>
    	<c:if test = "${isAuthorizedToViewInstallerRules == true}">   
        	enableApplicationsList(enable && ${isAuthorizedToEditInstallerRules});   
        </c:if>  
        <c:if test = "${isAuthorizedToViewExecControlRules == true}">   
        	enableExecControlVOList(enable && ${isAuthorizedToEditExecControlRules});   
        </c:if>   
    </c:if>
    
    <c:if test = "${isAuthorizedToViewExceptionRules == true}">
    	enableAttributeList(enable && ${isAuthorizedToEditExceptionRules});
    </c:if>

    <c:if test = "${isAuthorizedToViewBinaryRules == true}">
    	enableBinaryList(enable && ${isAuthorizedToEditBinaryRules});
    </c:if>

    <c:if test = "${isAuthorizedToViewFilterRules == true}">
    	scor.awl.filter.ruleGroupReadOnly(enable && ${isAuthorizedToEditFilterRules});
    </c:if>
    
    <c:if test="${param.osType == WIN_OS}">
    	scor.awl.filter.inv.ruleGroupReadOnly(enable && ${isAuthorizedToEditFilterRules});
	</c:if>
    // "Delete group" button
    var removeButton = new Button("scorAwlPolicyDeleteGroup");
    removeButton.setEnabled(false); //reset to disabled first

    if ("${epoReadOnlyPolicyObject}" === "false") {
        removeButton.setEnabled(!enable); // Only the "Ungrouped" group is editable. UI shouldn't allow to remove this group.
    }

}

var doReadOnly = function (forcedReadOnly) {
    if ("${epoReadOnlyPolicyObject}" === "true") {  // have to disable the policy if this
        forcedReadOnly = true;                      // condition is met irrespective of forcedReadOnly's value
    }                                               //so setting forcedReadOnly to true
    setReadOnly(forcedReadOnly);
}

function getAwlVoFor(groupName) {
    var i;
    for (i = 0; i < awlPolVOs.length; i++) {
        var awlPolVO = awlPolVOs[i];
        if (groupName === awlPolVO.common.getProperty("groupName")) {
            return awlPolVO.common.getVO();
        }
    }
    return null;
}

<c:if test="${scorAwlPolData != null}">
var jsonData = JSON.parse('${orion:escapeJavaScript(scorAwlPolData)}');

(function() {
    var i;
    for (i = 0; i < jsonData.length; i++) {
        var awlPolVO =  getAwlPolVOFromJson(jsonData[i]);

        awlPolVOs.push(awlPolVO);
    }
    scor.widgets.policyVOs = awlPolVOs;
}());
</c:if>

function initUI() {
	var scorAwlNonExistentRGCounterObj = scor.utils.counter(0);
    var i;
    for (i = 0; i < awlPolVOs.length; i++) {
        var awlPolVO = awlPolVOs[i];
        var groupName = awlPolVO.common.getProperty("groupName");
        var groupId = awlPolVO.common.getProperty("id");
        addNewRow("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", groupName, groupId, scorAwlNonExistentRGCounterObj)
    }
    //make initial call
    OrionList.setSelectedItem("<%=Constants.POLICY_LIST_NAME%>", 0);
    groupChange(OrionList.getSelectedItemText("<%=Constants.POLICY_LIST_NAME%>"));
}

function groupChange(groupName) {
    if (currentListGroupSelected === groupName) {
        return;
    }
    if (currentListGroupSelected) {
        savePrevGroupData();
    }
    currentListGroupSelected = groupName;

    var awlVO = getAwlVoFor(groupName);
    if (awlVO) {
        var updaters = awlVO['updaters'];
        var trustedGroups = awlVO['trustedGroups'];
        var trustedUsers = awlVO['trustedUsers'];
        var trustedDirectories = awlVO['trustedDirectories'];
        var apps = awlVO['apps'];
        var publishers = awlVO['publishers'];
        var advanced =  awlVO['advanced'];
        var binaries = awlVO['binaries'];
        var invFilters = awlVO['invFilters'];
        var execControlVOs = awlVO['execControlVOs'];
        var readOnly = (awlVO['readOnly'] === "true") ? true : false;

		scor.rg.awl.updaters.populateUpdaters(updaters, awlVO['type']);

		<c:if test="${param.osType == WIN_OS}">
	       	<c:choose>
	   			<c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
	   				<%-- No Trusted Users--%>
	   			</c:when>
	   			<c:otherwise>
	   				rePopulateTrustedUsersGroups(trustedUsers,trustedGroups);    			
	   			</c:otherwise>
	   		</c:choose>
   		

			populatePublishers(publishers);
            populateApplications(apps);
            populateExecControlVOs(execControlVOs);
        </c:if>

 		populateAttributes(awlVO);
       	populateTrustedDirectories(trustedDirectories);
       	populateBinaries(binaries);
		
       	scor.awl.filter.createAdvancedUI(advanced, readOnly, awlVO['type'], '${orion:escapeJavaScriptString(param.osType)}');
       	<c:if test="${param.osType == WIN_OS}">
        		scor.awl.filter.inv.createAdvancedUI(invFilters, readOnly, awlVO['type'], '${orion:escapeJavaScriptString(param.osType)}');
        </c:if>
    }
    doReadOnly(readOnly);
}
OrionCore.addLoadHandler(initUI);
</script>

<script type="text/javascript">
    <%-- functions to support group management --%>
    var scor;
    scor = scor || {};
    scor.grpMgmt = scor.grpMgmt || {};
    scor.widgets.policyVOs = scor.widgets.policyVOs || [];
    scor.grpMgmt.loadGroup = function(group) {
        var itemKey, groupName, groupId;
        if (!group) {
            return;
        }
        groupName = group['groupName'];
        groupId = group['id'];
        addNewAwlPolicyGroups([group]);
      //No need to send 4th parameter in addNewRow function call as this parameter is needed when initializing page and policy VO has RGs that do not exist.
        itemKey = addNewRow("<%=Constants.POLICY_LIST_NAME%>", "<%=Constants.POLICY_LIST_GROUP_NAME%>", groupName, groupId);
        groupChange(groupName);
        OrionList.setSelectedItem("<%=Constants.POLICY_LIST_NAME%>", itemKey);
    }

    scor.grpMgmt.adjustUiItems = function() {
        $('awlPolicyListBox').style.display = "none";
        $('scorAwldivider').style.display = "none";
     <c:if test="${param.osType == WIN_OS}">         	
        <c:choose>
        <c:when test="${hideThingsNotRequiredInSuggestions == 'true'}">
        <%-- No Trusted Users--%>
    	</c:when>
    	<c:otherwise>
			adjustGroupUIEnableSearchGroup();
		</c:otherwise>
		</c:choose>
	</c:if>	
    }

    scor.grpMgmt.getGroup = function() {
        savePrevGroupData();
        return awlPolVOs[0].common.getVO();
    }
</script>

