<%--
//-----------------------------------------------------------------------------
// Copyright (c) 2011-2012 XEROX Corporation.  All rights reserved
//-----------------------------------------------------------------------------
// Revision History:
// -----------------
// AR Number      Author   Date         Change Description
// ---------      ------   ----         ------------------
//
// CQGbl00349040  bvu      01/04/2012   Created       
//-----------------------------------------------------------------------------
--%>

<%--
  Popup to get the ePO credentials and Xerox MFP Admin credentials

  This is a part of McAfee UIActionInfo configuration.
--%>

<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion" %>


<br/>
<orion:message key="XeroxMFP.provision.epoCredentials"/>
<br/>

  <table align="center">
    <tr>
      <td colspan="2">
      <orion:message key="XeroxMFP.ePO.credentials.warning"/>
      </td>
    </tr>
    <tr>
      <td>
      <orion:message key="XeroxMFP.user"/>
      </td>
      <td>
      <orion:textbox id="userName" required="true" name="userName" value="XeroxService" />
      </td>
    </tr>
    <tr>
      <td>
        <orion:message key="XeroxMFP.pass"/>
      </td>
      <td>
        <orion:password id="password" name="password" value="XeroxAtlantis2021!" />
      </td>
    </tr>
</table>

<br/>

<orion:message key="XeroxMFP.provision.deviceCredentials"/>

<br/>

  <table align="center">
    <tr>
      <td>
      <orion:message key="XeroxMFP.user"/>
      </td>
      <td>
      <orion:textbox id="deviceUserName" required="true" name="deviceUserName" value="admin" />
      </td>
    </tr>
    <tr>
      <td>
        <orion:message key="XeroxMFP.pass"/>
      </td>
      <td>
        <orion:password id="devicePassword" name="devicePassword" value="" />
      </td>
    </tr>
</table>

<br/>

<table align="center">
  <tr>
    <td>
      <orion:message key="XeroxMFP.provision.notice" />
    </td>
  </tr>
</table>


