<!-- Copyright (C) 2014-2018 McAfee, Inc.  All rights reserved. -->
<%@ taglib uri="http://www.mcafee.com/orion" prefix="orion"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ page import="com.mcafee.scor.common.URLConstants"%>

<orion:message var="allowSubDirectoryCheckboxMessage" key="scor.selfapproval.createCustom.checkbox.subDirectory" escape="None"/>
<orion:message var="configuredPathHeading" key="scor.selfapproval.globalChanges.warning.allowNetworkPath.configuredPathHeading" escape="HTML"/>
<orion:message var="matchingRequestCountHeading" key="scor.selfapproval.globalChanges.warning.allowNetworkPath.matchingRequestsCountHeading" escape="HTML"/>
<jsp:include page="/common/includejQuery.jsp"/>


<table id="subDirectoriesCheckbox">
	<tr>
		<td><div><orion:checkbox id="allowSubDirectoryCheckBox" text="${allowSubDirectoryCheckboxMessage}" onclick="updateRequestParamCheckbox()"/></div></td>
	</tr>
</table>
<table id="pathCountTable">
	<tr>
		<td style="width:75%">${configuredPathHeading}</td>
		<td style="width:25%">${matchingRequestCountHeading}</td>
	</tr>
	<c:forEach var="path" items="${matchingNetworkPathList}">
	<tr>
		<td>${orion:escapeHtml(path.path)}</td>	
		<td align="center">${path.count}</td>
	</tr>
	</c:forEach>
</table>



